SystemOrganization addCategory: #'Wisconsin-SDK'!
SystemOrganization addCategory: #'Wisconsin-Cache'!
SystemOrganization addCategory: #Wisconsin!
SystemOrganization addCategory: #'Wisconsin-GlobalCache'!
SystemOrganization addCategory: #'Wisconsin-Media'!
SystemOrganization addCategory: #'Wisconsin-InternalExternalMedia'!
SystemOrganization addCategory: #'Wisconsin-Xrfb'!
SystemOrganization addCategory: #'Wisconsin-MPEG'!
SystemOrganization addCategory: #'Wisconsin-Audio'!
SystemOrganization addCategory: #'Wisconsin-Video'!
SystemOrganization addCategory: #'Wisconsin-Video-Win32'!
SystemOrganization addCategory: #'Wisconsin-Video-Mac'!
SystemOrganization addCategory: #'Wisconsin-Video-Hacks'!
SystemOrganization addCategory: #'Wisconsin-UI'!
SystemOrganization addCategory: #'Wisconsin-Worlds'!
SystemOrganization addCategory: #'Wisconsin-BitCache'!
SystemOrganization addCategory: #'Wisconsin-ResourceCache'!
SystemOrganization addCategory: #'Wisconsin-Movie-Decoding'!
SystemOrganization addCategory: #'Wisconsin-Movie'!
SystemOrganization addCategory: #'Wisconsin-KidsFirst'!

!TFrame class methodsFor: '*Wisconsin-hacks' stamp: 'hrs 5/1/2006 20:54'!
connectContentsFrom: input intoContainer: myInstance
	^myInstance future contents: input.! !

!TFrame class methodsFor: '*Wisconsin-hacks' stamp: 'hrs 7/26/2006 19:58'!
getPopupMenuScript: avatar target: target openIn: world at: position carrying: carrying harness: harness
	"This is the default right click popup menu script, may be overridden by sub classes"

	^ [
		| menu clipbrd |
		" Build the menu. "
		menu := CMenu new.
		menu add: 'Information' target: UWMenuBar 
			action: #showInformationOnFarRef: argument: target.
		menu add: 'Explore' target: target action: #explore.

		menu addSeparator.

		clipbrd := harness clipboard.

		menu add: 'Cut' target: clipbrd action: #cutToClipboard: argument: target.
		menu add: 'Copy' target: clipbrd action: #copyToClipboard: argument: target.
		menu add: 'Copy Material' target: clipbrd action: #copyMaterialToClipboard: argument: target.
		menu add: 'Copy Contents' target: clipbrd action: #copyContentsToClipboard: argument: target  disabled: (target send: [:obj | obj respondsTo: #serializeContents]) not.
		menu add: 'Paste' target: clipbrd action: #pasteOnto: argument: target disabled: clipbrd isEmpty.
		menu addSeparator.

		carrying ifFalse: [
			menu add: 'Grab' target: avatar action: #grab: argument: target.
		]
		ifTrue: [
			menu add: 'Release' target: avatar action: #release: argument: target.
		].

		" Open the popup menu. "
		menu openIn: world at: position.
	].
! !

!TFrame class methodsFor: '*Wisconsin-hacks' stamp: 'jcg 8/21/2006 23:29'!
newOn: island
	"Copying between islands is much faster than instance creation. If your class can't get away with this, then redefine this method to just: '^island future new: self'. "	
	| bits |
	bits := KidsFirst frameCache at: self ifAbsentPut: [TIslandCopier new export: self new].
	^TIslandCopier new import: bits to: island.
! !

!TFrame class methodsFor: '*Wisconsin-hacks' stamp: 'hrs 5/1/2006 20:58'!
newOn: island from: input
	| container |
	container := self newOn: island.
	^self connectContentsFrom: input intoContainer: container.! !

!TFrame methodsFor: '*Wisconsin-hacks' stamp: 'hrs 4/28/2006 18:11'!
addChild: aTFrame byUser: anAvatar
	"Adding an object by a user. Might position relative to the user, or might
	provide some visual indication of who it came from."
	self addChild: aTFrame.! !

!TFrame methodsFor: '*Wisconsin-hacks' stamp: 'hrs 7/19/2006 13:09'!
cut: event
	self island controller clipboard copyToClipboard: self by: event userID.
	self destroy.! !

!TFrame methodsFor: '*Wisconsin-hacks' stamp: 'hrs 7/15/2006 14:35'!
gotoFrame: event
	"Mostly copied from #gotoWindow: (only one line changed)"
	| front distance trans dy aspect atar |
	atar := event avatar ifNil:[^self].
	(self hasAncestor: atar) ifTrue:[^ self]. "don't go there"
	(self root = atar root) ifFalse:[^self]. "don't go there either"
	dy := self extent y.
	dy := dy/2.0.
	distance := dy/((atar viewAngle degreesToRadians/2.0) tan).
	aspect := self extent x/self extent y.
	aspect > atar viewAspect
 		ifTrue:[ distance := aspect*distance/atar viewAspect.].
	distance := distance + self frameBox radius.
	front := Vector3 x: 0 y: 0 z: distance.
	front := self orientation localPointToGlobal: front.
	front := self translation + front.
	trans := self localTransform copy.
	trans translation: front.
	atar goto: trans count: 6. ! !

!TFrame methodsFor: '*Wisconsin-hacks' stamp: 'hrs 7/25/2006 15:57'!
grabbedBy: avatar
	| trans  |
	avatar ifNil:[^nil].
	"Is is a bug that #carrying: doesn't fix the transform? No matter. This will work regardless."
	trans := avatar globalTransform orthoNormInverse composeWith: self globalTransform.
	avatar carrying: self.
	self localTransform: trans.! !

!TFrame methodsFor: '*Wisconsin-hacks' stamp: 'hrs 7/25/2006 14:33'!
grabbedState: aBoolean
	"ignore"! !

!TFrame methodsFor: '*Wisconsin-hacks' stamp: 'hrs 7/25/2006 15:53'!
grabFrame: event
	"see #grabWindow:"
	self grabbedBy: event avatar.! !

!TFrame methodsFor: '*Wisconsin-hacks' stamp: 'jcg 4/24/2006 23:39'!
hasBoundingBox
	^ true! !

!TFrame methodsFor: '*Wisconsin-hacks' stamp: 'jcg 5/5/2006 15:13'!
justPastedOnto: target byUser: userAvtrRep
	"Subclasses should extend this method."
	self frameChildrenDo: [:fc | fc justPastedOnto: target byUser: userAvtrRep]! !

!TFrame methodsFor: '*Wisconsin-hacks' stamp: 'jcg 8/1/2006 22:58'!
ocean
	^ self island controller ocean! !

!TFrame methodsFor: '*Wisconsin-hacks' stamp: 'hrs 5/8/2006 21:08'!
pasteMaterial: aMaterialOrTexture
	aMaterialOrTexture asMaterialFor: self.! !

!TFrame methodsFor: '*Wisconsin-hacks' stamp: 'jcg 5/5/2006 15:14'!
pasteOnto: target byUser: userAvtrRep
    target addChild: self byUser: userAvtrRep.
	self justPastedOnto: target byUser: userAvtrRep.	"Subclasses may extend this method."! !

!TFrame methodsFor: '*Wisconsin-hacks' stamp: 'hrs 7/26/2006 17:05'!
releasedBy: avatar
	"We could use the avatar argument to see if that's the avatar currently holding us, 
	but we don't."
	self parent parent carryingRelease: self.

! !

!TFrame methodsFor: '*Wisconsin-hacks' stamp: 'hrs 7/25/2006 15:56'!
releaseFrame: event
	"see #releaseWindow:"
	self releasedBy: event avatar.

! !

!TFrame methodsFor: '*Wisconsin-hacks' stamp: 'jcg 4/24/2006 23:31'!
replaceChild: oldChild with: newChild
	oldChild removeLightFrames.
	oldChild removePortalFrames.	
	oldChild removeRayFrames.
	frameChildren replace: oldChild with: newChild.
	oldChild parent: nil.
	newChild parent: self.
	newChild root: self root.
	newChild addLightFrames.
	newChild addPortalFrames.
	newChild addRayFrames.

! !

!TFrame methodsFor: '*Wisconsin-hacks' stamp: 'hrs 5/11/2006 20:38'!
serializeMaterial
	^(self material ifNil: [
		([self texture] on: Error do: [:e | nil]) ifNil: [TMaterial new]
		]) serializeMaterial
! !

!TFrame methodsFor: '*Wisconsin-hacks' stamp: 'hrs 5/11/2006 20:43'!
serializeYourself

	| saveObjOwner trans pickle |

	saveObjOwner := self parent.
	saveObjOwner ifNotNil: [saveObjOwner removeChild: self].

	trans := self localTransform.
	self localTransform: Matrix4x4 identity.

	pickle := TIslandCopier new export: self.

	saveObjOwner ifNotNil: [saveObjOwner addChild: self].
	self localTransform: trans.

	^ pickle.
! !

CroquetMenuWorld subclass: #UWMenuWorld
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-UI'!

UWMenuWorld defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!UWMenuWorld methodsFor: 'events' stamp: 'hrs 4/28/2006 21:03'!
onBootstrap
	"Load auto load targets"
	| project |
	self flag: #FIXME. "We shouldn't have to repeat all this code just to customize the menu."
	self startScript: #onDrop: when: {self. #dragDrop}.
	project := Smalltalk at: #UWMenuBar ifPresent:[:cls| cls new].
	project window: self.
	project topLeft: 0@0.
	project costume isWorld: true.
	self add: project.
	self activeProject: project.! !

TMesh subclass: #TMediaMesh
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-Media'!

!TMediaMesh class methodsFor: 'accessing' stamp: 'hrs 5/1/2006 21:33'!
containerClass
	^TMedia3DContainer! !

!TMediaMesh class methodsFor: 'instance creation' stamp: 'hrs 5/2/2006 11:22'!
newOn: island from: fileStream
	| meshOrGroup |
	meshOrGroup := self parse: fileStream.
	^meshOrGroup copyOntoIsland: island.
! !

!TMediaMesh class methodsFor: 'instance creation' stamp: 'hrs 5/2/2006 11:21'!
parse: stream
	| suffix fileName |
	suffix := TMedia suffix: stream.
	"Yes, I know this is silly.  The parsers should work on streams, but they don't."
	fileName := stream name.
	suffix = 'ase' ifTrue: [^(TLoad3DSMax new initializeWithFileName: fileName) frame].
	suffix = 'mdl' ifTrue: [^TLoadMDL new parseFileNamed: fileName].
	self notYetImplemented.
! !

!TMediaMesh methodsFor: 'accessing' stamp: 'hrs 7/14/2006 18:50'!
boundsChanged
	super boundsChanged.
	self parent ifNotNil: [self parent adjustButtons.].! !

!TMesh methodsFor: '*Wisconsin-hacks' stamp: 'hrs 5/9/2006 14:07'!
texture: aTexture
	| mat |
	mat := TMaterial new.
	mat texture: aTexture.
	self material: mat.! !

TSoundSource subclass: #TStreamingSoundSource
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-Audio'!

!TStreamingSoundSource methodsFor: 'action' stamp: 'jcg 7/26/2006 00:23'!
addBufferData: aSoundBuffer
	self deprecatedExplanation: 'Source does not have an intrinsic sample rate; sound buffers do'.
	self addBufferData: aSoundBuffer samplingRate: self samplingRate! !

!TStreamingSoundSource methodsFor: 'action' stamp: 'jcg 7/26/2006 19:31'!
addBufferData: aSoundBuffer samplingRate: rate
	| h |
	h := self handle ifNil: [^ self "OpenAL is not available"].
	h addBufferData: aSoundBuffer samplingRate: rate.
! !

!TStreamingSoundSource methodsFor: 'initialize' stamp: 'jcg 7/2/2006 16:38'!
initialize
	super initialize.
	properties at: #samplingRate put: 11025.! !

!TStreamingSoundSource methodsFor: 'accessing' stamp: 'jcg 5/10/2006 18:36'!
resourceNameClass
	"Class of the corresponding OpenALName subclass."
	^ OpenALStreamingSourceName
! !

!TStreamingSoundSource methodsFor: 'accessing' stamp: 'jcg 7/24/2006 23:48'!
samplingRate: anInteger
	"This doesn't belong in the superclass because the sampling rate is (in terms of the OpenAL API) really a property of the sound buffer, not the sound source.  However, since TStreamingSoundSource (actually, the corresponding OpenALStreamingSound) manages sound buffers without exposing them to callers, it makes sense to also manage the sampling rate here."
	anInteger isInteger ifFalse: [ ^self ].
	properties at: #samplingRate put: anInteger.
	self handle ifNotNilDo: [:h | h samplingRate: anInteger].
! !

Object subclass: #CroquetClipboard
	instanceVariableNames: 'harness contents'
	classVariableNames: 'Default'
	poolDictionaries: ''
	category: 'Wisconsin'!

!CroquetClipboard commentStamp: 'jcg 5/5/2006 12:28' prior: 0!
Responsible for cutting and copying croquet objects from worlds, and pasting copies of them into the same or other worlds.

We would prefer to make this solely a per-harness variable, but need a singleton because we didn't wan't to modify the iVars of any controller other than WisconsinController; other controllers just use the singleton.  Since the clipboard needs a harness to perform some of its operations (such as pasting into the harness's active space), a newly-created WisconsinHarness will bash itself into the singleton's harness iVar.!

!CroquetClipboard class methodsFor: 'singleton' stamp: 'jcg 5/5/2006 12:28'!
default
	^ Default ifNil: [Default := self new].! !

!CroquetClipboard methodsFor: 'accessing' stamp: 'jcg 5/5/2006 10:28'!
contents: c
	contents := c! !

!CroquetClipboard methodsFor: 'actions' stamp: 'hrs 6/14/2006 11:18'!
copyContentsToClipboard: target
	" serialize the target object to the clipboard."
	self contents: (target get: #serializeContents).
! !

!CroquetClipboard methodsFor: 'actions' stamp: 'hrs 5/8/2006 16:41'!
copyMaterialToClipboard: target
	" serialize the target object to the clipboard."
	self contents: (target get: #serializeMaterial).
! !

!CroquetClipboard methodsFor: 'actions' stamp: 'jcg 5/7/2006 17:26'!
copyToClipboard: target
	" serialize the target object to the clipboard."
	self contents: (target get: #serializeYourself).
! !

!CroquetClipboard methodsFor: 'actions' stamp: 'jcg 5/7/2006 17:29'!
copyToClipboard: target by: aUserID
	harness userID = aUserID ifTrue: [self copyToClipboard: target]
! !

!CroquetClipboard methodsFor: 'actions' stamp: 'jcg 5/19/2006 15:27'!
cutToClipboard: target
	" serialize the object to the clipboard and then delete it."
	self copyToClipboard: target.
	target future destroy.! !

!CroquetClipboard methodsFor: 'initialization' stamp: 'hrs 5/10/2006 10:45'!
harness
	^harness 
	
! !

!CroquetClipboard methodsFor: 'initialization' stamp: 'jcg 5/5/2006 11:56'!
harness: aCroquetHarness
	harness := aCroquetHarness
	
! !

!CroquetClipboard methodsFor: 'testing' stamp: 'jcg 5/5/2006 11:58'!
isEmpty	
	^ contents isNil
! !

!CroquetClipboard methodsFor: 'actions' stamp: 'jcg 5/5/2006 12:07'!
pasteIntoActiveSpace
	self pasteOnto: harness activeSpace! !

!CroquetClipboard methodsFor: 'actions' stamp: 'jcg 5/5/2006 15:03'!
pasteOnto: target
	| objToPaste |
	contents ifNil: [^ self].
	objToPaste := TIslandCopier new import: contents to: target island.
	objToPaste future pasteOnto: target byUser: harness avatar replica.! !

Object subclass: #DShowVideoController
	instanceVariableNames: 'frameSemaphore'
	classVariableNames: 'ErrorCodes Registry'
	poolDictionaries: ''
	category: 'Wisconsin-Video-Win32'!

!DShowVideoController commentStamp: 'yo 8/14/2002 23:26' prior: 0!
Interface for the set of primitive in DShowVideoDecoderPlugin.

Look at the #example1 and #example2 on the class side.

Structure:
 frameSemaphore		Semaphore -- signaled when the multithreaded decoder gets a frame.

  The plugin has a capability to display the decoded video stream onto the "stWindow" window handle directly.  This is useful when you only want to see the live video feed and minimize the CPU cycle needed for video handling.  You can specify the rectangle where the video frames are displayed by calling #decoderSetRenderRectX:y:w:h: method.  You can turn on/off the direct displaing by calling #decoderShowWindow:.

  The plugin internally stores the decoded frames when requested by #decoderRequestCapture method and the frame can be copied into a Squeak Form by #decoderCopyLastCapturedFrameInto: method.  If you do this cycle for every frame, it practically becomes another way to display the video stream.  On reasonably fast computers, Squeak can catch up the 30fps frame rate that DV cameras do.

  The other methods should be self-explanatory.

8/14/2002
!

!DShowVideoController class methodsFor: 'examples' stamp: 'yo 8/14/2002 22:38'!
example1
"
	self example1 inspect
"

	| d |
	d := DShowVideoController new.
	d initializeDecoder.
	d decoderSetRenderRectX: 100 y: 100 w: 320 h: 240.
	(Delay forSeconds: 2) wait.
	d decoderShowWindow: true.
	(Delay forSeconds: 1) wait.
	d decoderRun.
	^ d
! !

!DShowVideoController class methodsFor: 'examples' stamp: 'yo 8/14/2002 22:13'!
example2
"
	self example2
"

	DShowVideoMorph new openInWorld
! !

!DShowVideoController class methodsFor: 'class initialization' stamp: 'yo 8/13/2002 20:26'!
initialize
"
	self initialize
"

	self initializeErrorCodes.
	Smalltalk addToShutDownList: self.
! !

!DShowVideoController class methodsFor: 'class initialization' stamp: 'yo 8/13/2002 20:26'!
initializeErrorCodes


	ErrorCodes := Dictionary new: 20.

	ErrorCodes at: 0 put: 'False'.
	ErrorCodes at: 1 put: 'True'.
	ErrorCodes at: 2 put: 'Camera not found'.
	ErrorCodes at: 3 put: 'COM initialization'.
	ErrorCodes at: 4 put: 'Filter graph'.
	ErrorCodes at: 5 put: 'Thread'.
	ErrorCodes at: 6 put: 'Uninitialized'.
	ErrorCodes at: 7 put: 'COM interface'.
	ErrorCodes at: 8 put: 'Video control'.
	ErrorCodes at: 9 put: 'Video media type'.
	ErrorCodes at: 10 put: 'Camera type'.
	ErrorCodes at: 11 put: 'Unknown'.
! !

!DShowVideoController class methodsFor: 'finalization' stamp: 'yo 8/13/2002 19:40'!
register: anObject

	WeakArray isFinalizationSupported ifFalse:[^anObject].
	self registry add: anObject.
! !

!DShowVideoController class methodsFor: 'finalization' stamp: 'yo 8/13/2002 19:42'!
registry

	WeakArray isFinalizationSupported ifFalse:[^nil].
	^Registry isNil
		ifTrue:[Registry := WeakRegistry new]
		ifFalse:[Registry].
! !

!DShowVideoController class methodsFor: 'class initialization' stamp: 'jcg 5/2/2006 11:58'!
shutDown
"
	self shutDown
"

	| insts |
	insts := self allInstances.
	insts size > 0 ifTrue: [
		insts do: [:inst |
			[inst shutdownDecoder] on: Error do: [:err | ].
			(Delay forMilliseconds: 1000) wait.
		].
	].! !

!DShowVideoController class methodsFor: 'finalization' stamp: 'yo 8/13/2002 19:41'!
unregister: anObject

	WeakArray isFinalizationSupported ifFalse:[^anObject].
	self registry remove: anObject ifAbsent:[].
! !

!DShowVideoController methodsFor: 'error checking' stamp: 'jcg 10/6/2005 12:07'!
checkForError
	self decoderGetLastError >= 2 ifTrue: [self error: 'decoder error'].! !

!DShowVideoController methodsFor: 'accessing' stamp: 'yo 8/12/2002 16:04'!
createFrameSemaphore

	| index |
	frameSemaphore := Semaphore new.
	index := Smalltalk registerExternalObject: frameSemaphore.

	self primSetSemaphore: index.
! !

!DShowVideoController methodsFor: 'accessing' stamp: 'yo 8/14/2002 22:43'!
decoderCopyLastCapturedFrameInto: aForm

	<primitive: 'primDecoderCopyLastCapturedFrameInto' module: 'DShowVideoDecoderPlugin'>

	self reportError.
! !

!DShowVideoController methodsFor: 'accessing' stamp: 'yo 8/14/2002 22:11'!
decoderGetLastError

	<primitive: 'primDecoderGetLastError' module: 'DShowVideoDecoderPlugin'>

	self primitiveFailed! !

!DShowVideoController methodsFor: 'accessing' stamp: 'yo 8/14/2002 22:11'!
decoderGetLastSampleTime

	<primitive: 'primDecoderGetLastSampleTime' module: 'DShowVideoDecoderPlugin'>

	self reportError.
! !

!DShowVideoController methodsFor: 'accessing' stamp: 'yo 8/14/2002 22:11'!
decoderPause

	<primitive: 'primDecoderPause' module: 'DShowVideoDecoderPlugin'>

	self reportError.
! !

!DShowVideoController methodsFor: 'accessing' stamp: 'yo 8/14/2002 22:11'!
decoderRequestCapture

	<primitive: 'primDecoderRequestCapture' module: 'DShowVideoDecoderPlugin'>

	self reportError.
! !

!DShowVideoController methodsFor: 'accessing' stamp: 'yo 8/14/2002 22:11'!
decoderRun

	<primitive: 'primDecoderRun' module: 'DShowVideoDecoderPlugin'>

	self reportError.
! !

!DShowVideoController methodsFor: 'accessing' stamp: 'yo 8/14/2002 22:37'!
decoderSetDecodeSizeWidth: w Height: h

	<primitive: 'primDecoderSetDecodeSize' module: 'DShowVideoDecoderPlugin'>

	self reportError.
! !

!DShowVideoController methodsFor: 'accessing' stamp: 'yo 8/14/2002 22:38'!
decoderSetRenderRectX: x y: y w: w h: h

	<primitive: 'primDecoderSetRenderRect' module: 'DShowVideoDecoderPlugin'>

	self reportError.
! !

!DShowVideoController methodsFor: 'accessing' stamp: 'yo 8/14/2002 22:11'!
decoderShowWindow: showFlag

	<primitive: 'primDecoderShowWindow' module: 'DShowVideoDecoderPlugin'>

	self reportError.
! !

!DShowVideoController methodsFor: 'accessing' stamp: 'yo 8/14/2002 22:31'!
decoderSize

	| int32 |
	int32 := self primDecoderSize.

	^ ((int32 >> 16) bitAnd: 16rFFFF)@(int32  bitAnd: 16rFFFF).
! !

!DShowVideoController methodsFor: 'accessing' stamp: 'yo 8/14/2002 22:11'!
decoderStop

	<primitive: 'primDecoderStop' module: 'DShowVideoDecoderPlugin'>

	self reportError.
! !

!DShowVideoController methodsFor: 'private' stamp: 'yo 8/14/2002 22:29'!
finalize

	self shutdownDecoder.
! !

!DShowVideoController methodsFor: 'accessing' stamp: 'yo 8/8/2002 16:05'!
frameSemaphore

	^ frameSemaphore! !

!DShowVideoController methodsFor: 'accessing' stamp: 'yo 8/14/2002 22:28'!
initializeDecoder

	self primInitializeDecoder.
	self class register: self.

! !

!DShowVideoController methodsFor: 'private' stamp: 'yo 8/14/2002 22:31'!
primDecoderSize

	<primitive: 'primDecoderGetDecodeSize' module: 'DShowVideoDecoderPlugin'>

	^ 0! !

!DShowVideoController methodsFor: 'private' stamp: 'yo 8/14/2002 22:15'!
primInitializeDecoder

	<primitive: 'primInitializeDecoder' module: 'DShowVideoDecoderPlugin'>

	self reportError.
! !

!DShowVideoController methodsFor: 'private' stamp: 'yo 8/14/2002 22:20'!
primSetSemaphore: index

	<primitive: 'primSetFrameSemaphore' module: 'DShowVideoDecoderPlugin'>

	self reportError.
! !

!DShowVideoController methodsFor: 'private' stamp: 'yo 8/14/2002 22:24'!
primShutdownDecoder

	<primitive: 'primShutdownDecoder' module: 'DShowVideoDecoderPlugin'>

	self reportError.
! !

!DShowVideoController methodsFor: 'private' stamp: 'yo 8/13/2002 20:28'!
reportError

	| error |
	error := self decoderGetLastError.

	self error: 'DirectShow: ', (ErrorCodes at: error ifAbsent: ['Unknown']).
! !

!DShowVideoController methodsFor: 'accessing' stamp: 'yo 8/14/2002 22:26'!
shutdownDecoder

	frameSemaphore ifNotNil: [
		Smalltalk unregisterExternalObject: frameSemaphore.
		frameSemaphore := nil.
	].

	self primShutdownDecoder.
	self class unregister: self.
! !

Object subclass: #ExternalMediaHandle
	instanceVariableNames: 'objectID manager time'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-InternalExternalMedia'!

!ExternalMediaHandle commentStamp: '<historical>' prior: 0!
Instance variables:
	objectID 	<TObjectID>			Identifies the internal/external aspects of the resource.
	manager	<ExternalMediaHandleManager>
	time		<SmallInteger>		Most recent time that the resource was used.!

!ExternalMediaHandle class methodsFor: 'instance creation' stamp: 'jcg 6/13/2006 20:49'!
objectID: oid
	^ self new objectID: oid! !

!ExternalMediaHandle methodsFor: 'initialize' stamp: 'jcg 7/27/2006 12:20'!
destroy
	"Subclasses should extend."
	manager ifNotNil: [manager privateRemoveHandle: objectID].
! !

!ExternalMediaHandle methodsFor: 'initialize' stamp: 'jcg 6/14/2006 22:07'!
manager: anExternalMediaHandleManager
	manager := anExternalMediaHandleManager
	! !

!ExternalMediaHandle methodsFor: 'accessing' stamp: 'jcg 6/13/2006 20:50'!
objectID
	^ objectID
! !

!ExternalMediaHandle methodsFor: 'initialize' stamp: 'jcg 6/13/2006 20:50'!
objectID: oid
	objectID := oid! !

!ExternalMediaHandle methodsFor: 'accessing' stamp: 'jcg 6/13/2006 20:50'!
time
	^ time
! !

!ExternalMediaHandle methodsFor: 'accessing' stamp: 'jcg 6/13/2006 20:51'!
time: newTime
	time := newTime
! !

ExternalMediaHandle subclass: #ExternalMPEGHandle
	instanceVariableNames: 'player buffer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-MPEG'!

!ExternalMPEGHandle methodsFor: 'accessing' stamp: 'jcg 6/14/2006 17:15'!
audioChannelCountFor: streamIndex
	| result |
	result := buffer audioChannels: streamIndex.
	result = -1 ifTrue: [self error: 'cannot get channel count for stream index ', streamIndex].
	^ result! !

!ExternalMPEGHandle methodsFor: 'accessing' stamp: 'jcg 6/15/2006 19:43'!
audioGetCurrentSampleFor: streamIndex
	^ buffer audioGetSample: streamIndex! !

!ExternalMPEGHandle methodsFor: 'actions' stamp: 'jcg 6/15/2006 20:01'!
audioReadSamplesFor: streamIndex to: soundBuffers
	| result |
	result := buffer audioReadBuffer: soundBuffers first stream: streamIndex channel: 0.
	(result == -1 or: [soundBuffers size == 1]) ifTrue: [^ result].
	^ buffer audioReReadBuffer: soundBuffers second stream: streamIndex channel: 1.
	! !

!ExternalMPEGHandle methodsFor: 'accessing' stamp: 'jcg 6/14/2006 17:44'!
audioSampleCountFor: streamIndex
	^ buffer audioSamples: streamIndex! !

!ExternalMPEGHandle methodsFor: 'accessing' stamp: 'jcg 6/14/2006 17:45'!
audioSampleRateFor: streamIndex
	^ buffer audioSampleRate: streamIndex! !

!ExternalMPEGHandle methodsFor: 'accessing' stamp: 'jcg 6/15/2006 19:45'!
audioSetCurrentSampleFor: streamIndex to: sampleNum
	^ buffer audioSetSample: sampleNum stream: streamIndex! !

!ExternalMPEGHandle methodsFor: 'accessing' stamp: 'jcg 6/14/2006 17:03'!
audioStreamCount
	^ buffer totalAudioStreams! !

!ExternalMPEGHandle methodsFor: 'initialize' stamp: 'jcg 7/27/2006 12:12'!
destroy
	super destroy.
	player close.
	player := buffer := nil! !

!ExternalMPEGHandle methodsFor: 'initialize' stamp: 'hrs 7/7/2006 19:04'!
initializeWithBytes: bytes
	player ifNotNil: [self error: 'already initialized'].
	player := MPEGPlayer2 new.
	buffer := MPEGFile openBuffer: bytes.
	player dataSource: buffer.
! !

!ExternalMPEGHandle methodsFor: 'accessing' stamp: 'jcg 6/14/2006 17:17'!
videoFrameCountFor: streamIndex
	^ buffer videoFrames: streamIndex! !

!ExternalMPEGHandle methodsFor: 'accessing' stamp: 'jcg 6/14/2006 17:40'!
videoFrameExtentFor: streamIndex
	"Answer the extent (width/height) of each video frame in the specified stream."
	^ (self videoFrameWidthFor: streamIndex) @ (self videoFrameHeightFor: streamIndex)! !

!ExternalMPEGHandle methodsFor: 'accessing' stamp: 'jcg 6/14/2006 17:40'!
videoFrameHeightFor: streamIndex
	"Answer the height of each video frame in the specified stream."
	^ buffer videoFrameHeight: streamIndex! !

!ExternalMPEGHandle methodsFor: 'accessing' stamp: 'jcg 6/14/2006 17:17'!
videoFrameRateFor: streamIndex
	^ buffer videoFrameRate: streamIndex! !

!ExternalMPEGHandle methodsFor: 'accessing' stamp: 'jcg 6/14/2006 17:41'!
videoFrameWidthFor: streamIndex
	"Answer the width of each video frame in the specified stream."
	^ buffer videoFrameWidth: streamIndex! !

!ExternalMPEGHandle methodsFor: 'accessing' stamp: 'jcg 6/14/2006 23:22'!
videoGetCurrentFrameFor: streamIndex
	^ buffer videoGetFrame: streamIndex! !

!ExternalMPEGHandle methodsFor: 'actions' stamp: 'jcg 6/14/2006 23:27'!
videoReadFrameFrom: streamIndex into: aForm
	^ buffer videoReadFrameInto: aForm stream: streamIndex! !

!ExternalMPEGHandle methodsFor: 'accessing' stamp: 'jcg 6/14/2006 23:22'!
videoSetCurrentFrameFor: streamIndex to: frameNum
	^ buffer videoSetFrame: frameNum stream: streamIndex! !

!ExternalMPEGHandle methodsFor: 'accessing' stamp: 'jcg 6/14/2006 17:03'!
videoStreamCount
	^ buffer totalVideoStreams! !

Object subclass: #ExternalMediaHandleManager
	instanceVariableNames: 'handles lru epoch currentTime inactivityThreshold'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-InternalExternalMedia'!

!ExternalMediaHandleManager commentStamp: 'jcg 7/27/2006 12:21' prior: 0!
Instance variables:
	handles 		<KeyedSet>			The ExternalMediaHandles managed by this manager.
	lru				<Heap>				Keeps track of least-recently-used handle was used.
	epoch			<SmallInteger>		Time that manager was created.
	currentTime		<SmallInteger>		Reset at the beginning of each frame.
	inactivityThreshold <SmallInteger>	Destroy handles that have been inactive for this long.

NOTE: removal from an arbitrary position in the Heap could be made MUCH faster if each handle kept track of it's index in the heap (thus avoiding a linear scan).  However, arbitrary removals are infrequent.  It is much more common that the Heap needs to be re-sorted because handles' times have been updated; we optimize this by only re-sorting once per frame.

NOTE: we're not very good about removing destroyed handles from the LRU heap.!

!ExternalMediaHandleManager class methodsFor: 'islands' stamp: 'jcg 6/14/2006 22:20'!
howToPassAsArgument
	^#passByIdentity:! !

!ExternalMediaHandleManager class methodsFor: 'class initialization' stamp: 'hrs 7/15/2006 14:16'!
initialize
	"We do this here rather than in the list at IslandArgumentCopier class>>initialize because 	OpenAL-Base is usually installed/updated AFTER Islands-Kernel."
	(IslandArgumentCopier classPool at: #PassByIdentityRoots) addIfNotPresent: self.! !

!ExternalMediaHandleManager methodsFor: 'accessing' stamp: 'jcg 6/14/2006 22:12'!
at: key ifAbsentPut: aBlock
	| handle newHandle |
	handle := handles at: key ifAbsentPut: 
										[newHandle := aBlock value.
										newHandle manager: self.
										newHandle].
	handle time: currentTime.
	^ handle! !

!ExternalMediaHandleManager methodsFor: 'accessing' stamp: 'jcg 6/14/2006 22:05'!
at: key ifAbsent: aBlock
	^ handles at: key ifAbsent: aBlock! !

!ExternalMediaHandleManager methodsFor: 'rendering' stamp: 'jcg 6/13/2006 23:25'!
beginFrame
	currentTime := RealTime millisecondClockValue.! !

!ExternalMediaHandleManager methodsFor: 'accessing' stamp: 'jcg 7/27/2006 12:18'!
destroyHandle: key
	| handle |
	
	"Need to fix this to track resource allocation (eg: total memory used) either here, or in 'handle destroy'.  Or at least remove from LRU."
	self flag: #jcg.

	handle := self at: key ifAbsent: [^ self].
	handle destroy! !

!ExternalMediaHandleManager methodsFor: 'rendering' stamp: 'jcg 6/13/2006 23:34'!
endFrame
	| h |
	lru reSort.

	"Destroy inactive resources."
	[(h := lru firstOrNil) notNil 
		and: [(RealTime milliseconds: currentTime since: h time) >= inactivityThreshold]]
			whileTrue:
				[lru removeFirst destroy]
! !

!ExternalMediaHandleManager methodsFor: 'initialize' stamp: 'jcg 6/14/2006 22:54'!
initialize
	handles := KeyedSet keyBlock: [:hndl | hndl objectID].
	lru := Heap sortBlock: [:hndl1 :hndl2 | hndl1 time <= hndl2 time].
	epoch := currentTime := RealTime millisecondClockValue.
	inactivityThreshold := 300000. "five minutes"
! !

!ExternalMediaHandleManager methodsFor: 'private' stamp: 'jcg 7/27/2006 12:19'!
privateRemoveHandle: key
	handles removeKey: key ifAbsent: []! !

Object subclass: #FrameDecoder
	instanceVariableNames: 'targetTForm form decoder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-Video'!

!FrameDecoder commentStamp: 'jcg 5/1/2006 17:52' prior: 0!
Takes JPEG input, and decodes to frames.  Placeholder for a more general codec framework.!

!FrameDecoder methodsFor: 'decode' stamp: 'jcg 5/3/2006 22:49'!
decode: bytes
	decoder uncompress: bytes into: form.
	targetTForm setupForm: form.
! !

!FrameDecoder methodsFor: 'initialize' stamp: 'jcg 5/1/2006 17:53'!
extent: e
	form := Form extent: e depth: 32.! !

!FrameDecoder methodsFor: 'initialize' stamp: 'jcg 5/1/2006 17:55'!
initialize
	super initialize.
	decoder := JPEGReadWriter2 new.! !

!FrameDecoder methodsFor: 'initialize' stamp: 'jcg 5/3/2006 22:48'!
targetTForm: tform
	targetTForm := tform! !

Object subclass: #FrameGrabber
	instanceVariableNames: ''
	classVariableNames: 'Height TheGrabber Width'
	poolDictionaries: ''
	category: 'Wisconsin-Video-Mac'!

!FrameGrabber commentStamp: '<historical>' prior: 0!
This provides primitive calls to the QuickTime Sequence Grabber plugin.!

!FrameGrabber class methodsFor: 'as yet unclassified' stamp: 'jcg 10/13/2005 11:23'!
getBits: bits
	self shouldNotImplement.   "Use VideoGrabber and subclasses"
	TheGrabber isNil ifTrue: [ TheGrabber := FrameGrabber new ].
	TheGrabber primGetBits: bits
! !

!FrameGrabber class methodsFor: 'as yet unclassified' stamp: 'jcg 10/13/2005 11:23'!
sourceHeight
	self shouldNotImplement.   "Use VideoGrabber>>height"
	^Height! !

!FrameGrabber class methodsFor: 'as yet unclassified' stamp: 'jcg 10/13/2005 11:23'!
sourceWidth
	self shouldNotImplement.   "Use VideoGrabber>>width"
	^Width! !

!FrameGrabber class methodsFor: 'as yet unclassified' stamp: 'jcg 10/13/2005 11:22'!
startWidth: w height: h
	self shouldNotImplement.   "Use VideoGrabber and subclasses"
	TheGrabber isNil ifTrue: [ TheGrabber := FrameGrabber new ].
	Width := w.
	Height := h.
	TheGrabber primStartGrabberWidth: w height: h! !

!FrameGrabber class methodsFor: 'as yet unclassified' stamp: 'PLD 10/29/2004 12:54'!
stop
	TheGrabber isNil ifTrue: [ TheGrabber := FrameGrabber new ].
	TheGrabber primStopGrabber! !

!FrameGrabber methodsFor: 'primitives' stamp: 'jcg 10/13/2005 12:01'!
primGetBits: bits
	<primitive: 'getBits' module: 'FrameGrabberPlugin'>
	self error: 'failed to get bits'.
! !

!FrameGrabber methodsFor: 'primitives' stamp: 'jcg 10/13/2005 12:02'!
primSourceHeight
	<primitive: 'sourceHeight' module: 'FrameGrabberPlugin'>
	self error: 'failed to read height'.! !

!FrameGrabber methodsFor: 'primitives' stamp: 'jcg 10/13/2005 12:02'!
primSourceWidth
	<primitive: 'sourceWidth' module: 'FrameGrabberPlugin'>
	self error: 'failed to read width'.! !

!FrameGrabber methodsFor: 'primitives' stamp: 'jcg 10/13/2005 12:02'!
primStartGrabberWidth: w height: h
	<primitive: 'startFrameGrabber' module: 'FrameGrabberPlugin'>
	self error: 'failed to start grabber'.! !

!FrameGrabber methodsFor: 'primitives' stamp: 'jcg 10/13/2005 12:02'!
primStopGrabber
	<primitive: 'stopFrameGrabber' module: 'FrameGrabberPlugin'>
	self error: 'failed to stop grabber'.! !

Object subclass: #InternalMedia
	instanceVariableNames: 'objectID'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-InternalExternalMedia'!

!InternalMedia methodsFor: 'private' stamp: 'jcg 6/14/2006 17:57'!
createHandle
	| handle |
	handle := self handleClass objectID: objectID copy.
	self initializeHandle: handle.
	^ handle! !

!InternalMedia methodsFor: 'private' stamp: 'jcg 7/27/2006 12:08'!
destroyHandle
	| manager |
	manager := self externalMediaHandleManager ifNil: [^ self].
	manager destroyHandle: self objectID
		! !

!InternalMedia methodsFor: 'private' stamp: 'jcg 6/14/2006 08:45'!
externalMediaHandleManager
	[^ self island controller externalMediaHandleManager]
		on: Error
		do: [:err | Transcript show: 'InternalMedia>>externalMediaHandleManager  :  ', err. ^ nil]! !

!InternalMedia methodsFor: 'private' stamp: 'jcg 6/14/2006 08:50'!
handle
	| manager |
	manager := self externalMediaHandleManager ifNil: [^ nil].
	^ manager
			at: self objectID
			ifAbsentPut: [self createHandle]! !

!InternalMedia methodsFor: 'private' stamp: 'jcg 6/14/2006 08:53'!
handleClass
	self subclassResponsibility! !

!InternalMedia methodsFor: 'initialize' stamp: 'jcg 6/14/2006 13:58'!
initialize
	super initialize.
	objectID := TObjectID new.
! !

!InternalMedia methodsFor: 'private' stamp: 'jcg 6/14/2006 08:54'!
initializeHandle: myHandle
	self subclassResponsibility! !

InternalMedia subclass: #TMediaMPEG
	instanceVariableNames: 'bytes videoStreams audioStreams'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-MPEG'!

!TMediaMPEG commentStamp: 'jcg 6/14/2006 23:26' prior: 0!
NOT THREAD SAFE!!!!!!

InternalMPEG stores the bytes (or acts as a placeholder for another InternalMPEG that stores the bytes) that an ExternalMPEGHandle knows how to decode into audio samples and video frames.




Acting as a placeholder is currently not implemented.  When it is, it will work much like TForm: the placeholder contains a SHA hash for the bytes that it uses to look up the hi-res version of the movie in something akin to the TFormManager.  When the hi-res version isn't found, the placeholder responds to messages with no-ops (should probably notify clients that no-op has occured).  Eventually, the placeholder can contain a low-resolution version of the media so that the user can at least see something until the hi-res version arrives.
!

!TMediaMPEG class methodsFor: 'accessing' stamp: 'jcg 6/14/2006 22:02'!
containerClass
	^ TMPEGWindow! !

!TMediaMPEG class methodsFor: 'instance creation' stamp: 'jcg 6/14/2006 21:59'!
newOn: island from: fileStream
	| media |
	media := island future new: self.
	media future bytes: fileStream contents.
	^ media! !

!TMediaMPEG class methodsFor: 'instance creation' stamp: 'jcg 6/14/2006 18:01'!
openFile: filePath
	| fileStream contents |
	fileStream := StandardFileStream oldFileNamed: filePath.
	fileStream binary.
	contents := fileStream contents.
	fileStream close.
	^ self withBytes: contents! !

!TMediaMPEG class methodsFor: 'instance creation' stamp: 'jcg 6/14/2006 14:02'!
withBytes: byteArray
	^ super new bytes: byteArray! !

!TMediaMPEG methodsFor: 'accessing-cached' stamp: 'jcg 6/14/2006 17:48'!
audioChannelCountFor: streamIndex
	"Number of channels in stream.  See #bytes:"
	^ (audioStreams at: streamIndex+1) third! !

!TMediaMPEG methodsFor: 'hacks' stamp: 'jcg 6/15/2006 19:50'!
audioChunkSize
	"Answer the number of samples for 0.1 sec of sound."
	audioStreams size == 0 ifTrue: [^ 0].
	^ ((self audioSampleRateFor: 0) * 0.1) rounded
! !

!TMediaMPEG methodsFor: 'hacks' stamp: 'jcg 6/15/2006 19:12'!
audioPeriod
	^ 100 ! !

!TMediaMPEG methodsFor: 'actions' stamp: 'jcg 6/15/2006 19:56'!
audioReadSampleNum: sampleNum into: soundBuffers
	"Read a chunk of audio samples of the desired size, starting at 'sampleNum'.  Answer true if successful, otherwise false."
	| h pos |
	(h := self handle) ifNil: [^ false].
	pos := h audioGetCurrentSampleFor: 0.	"assume only one video stream"
	pos == -1 ifTrue: [^ false].				"something wrong with read... no audio stream?"

	"Set the current position, if necessary."
	sampleNum == pos ifFalse: 
		[(h audioSetCurrentSampleFor: 0 to: sampleNum)  == -1 ifTrue: [^ false]].

	^ (h audioReadSamplesFor: 0 to: soundBuffers) ~~ -1! !

!TMediaMPEG methodsFor: 'accessing-cached' stamp: 'jcg 6/14/2006 17:48'!
audioSampleCountFor: streamIndex
	"Total number of samples.  See #bytes:"
	^ (audioStreams at: streamIndex+1) first! !

!TMediaMPEG methodsFor: 'accessing-cached' stamp: 'jcg 6/14/2006 17:48'!
audioSampleRateFor: streamIndex
	"Sample rate in kHz.  See #bytes:"
	^ (audioStreams at: streamIndex+1) second! !

!TMediaMPEG methodsFor: 'accessing-cached' stamp: 'jcg 6/14/2006 17:49'!
audioStreamCount
	^ audioStreams size! !

!TMediaMPEG methodsFor: 'initialize' stamp: 'jcg 6/14/2006 18:00'!
bytes: byteArray
	| handleExists h |

	bytes ifNotNil: [self error: 'InternalMPEG: already initialized'].
	bytes := byteArray.

	"This is a hack so that we can read metadata (total number of frames, audio samples per second, etc.) for the MPEG even if we are currently operating in the ocean (and therefore can't create a handle in the non-existent ExternalMediaHandleManager)."
	handleExists := true.
	h := self handle ifNil: [handleExists := false. self createHandle].
	
	"Store just the information that is needed for users to compute frame times."
	videoStreams := Array new: h videoStreamCount.
	videoStreams withIndexDo: 
		[:ignore :i | videoStreams 
						at: i 
						put:	{
								h videoFrameCountFor: i-1.		"total number of frames"
								h videoFrameRateFor: i-1.		"frames/second"
								h videoFrameExtentFor: i-1.		"width@height"
							}
		].

	audioStreams := Array new: h audioStreamCount.
	audioStreams withIndexDo:
		[:ignore :i | audioStreams
						at: i
						put:	{
								h audioSampleCountFor: i-1.		"total number of samples"
								h audioSampleRateFor: i-1.		"sample rate in kHz"
								h audioChannelCountFor: i-1.	"number of channels in stream"
							}
		].

	handleExists ifFalse: [h destroy].! !

!TMediaMPEG methodsFor: 'private' stamp: 'jcg 6/14/2006 14:22'!
handleClass
	^ ExternalMPEGHandle! !

!TMediaMPEG methodsFor: 'private' stamp: 'jcg 6/14/2006 14:23'!
initializeHandle: myHandle
	myHandle initializeWithBytes: bytes! !

!TMediaMPEG methodsFor: 'acccessing' stamp: 'jcg 6/14/2006 22:03'!
objectID
	^ objectID copy! !

!TMediaMPEG methodsFor: 'accessing-cached' stamp: 'jcg 6/14/2006 17:53'!
videoFrameCountFor: streamIndex
	"Total number of frames.  See #bytes:"
	^ (videoStreams at: streamIndex+1) first! !

!TMediaMPEG methodsFor: 'accessing-cached' stamp: 'jcg 6/14/2006 17:54'!
videoFrameExtentFor: streamIndex
	"Size (width@height) of each frame.  See #bytes:"
	^ (videoStreams at: streamIndex+1) third! !

!TMediaMPEG methodsFor: 'accessing-cached' stamp: 'jcg 6/14/2006 17:54'!
videoFrameRateFor: streamIndex
	"Frame rate (frames/second).  See #bytes:"
	^ (videoStreams at: streamIndex+1) second! !

!TMediaMPEG methodsFor: 'hacks' stamp: 'jcg 6/14/2006 23:49'!
videoPeriod
	videoStreams size == 0 ifTrue: [^ nil].
	^ 1000.0 / videoStreams first second! !

!TMediaMPEG methodsFor: 'actions' stamp: 'jcg 6/14/2006 23:29'!
videoReadFrameNum: frameNum into: aForm
	"Read the desired frame into the provided Form.  Answer true if successful, otherwise false."
	| h pos |
	(h := self handle) ifNil: [^ false].
	pos := h videoGetCurrentFrameFor: 0.		"assume only one video stream"
	pos == -1 ifTrue: [^ false].				"something wrong with read... no video stream?"

	"Set the current position, if necessary."
	frameNum == pos ifFalse: 
		[(h videoSetCurrentFrameFor: 0 to: frameNum)  == -1 ifTrue: [^ false]].

	^ (h videoReadFrameFrom: 0 into: aForm) ~~ -1
	! !

!TMediaMPEG methodsFor: 'accessing-cached' stamp: 'jcg 6/14/2006 17:49'!
videoStreamCount
	^ videoStreams size! !

Object subclass: #KidsFirst
	instanceVariableNames: ''
	classVariableNames: 'FrameCache'
	poolDictionaries: ''
	category: 'Wisconsin-KidsFirst'!

!KidsFirst commentStamp: 'jcg 8/21/2006 22:53' prior: 0!
Utility and configuration methods for KidsFirst Croquet.!

!KidsFirst class methodsFor: 'frame cache' stamp: 'jcg 8/21/2006 22:54'!
clearFrameCache
	FrameCache := nil.! !

!KidsFirst class methodsFor: 'frame cache' stamp: 'jcg 8/21/2006 22:55'!
frameCache
	^ FrameCache ifNil: [FrameCache := IdentityDictionary new]! !

Object subclass: #LiveMediaSource
	instanceVariableNames: 'source sourceID listeners'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-Media'!

LiveMediaSource subclass: #LiveAudioSource
	instanceVariableNames: 'codec'
	classVariableNames: 'Current'
	poolDictionaries: ''
	category: 'Wisconsin-Audio'!

!LiveAudioSource class methodsFor: 'singleton access' stamp: 'jcg 5/10/2006 00:30'!
clearSingleton
	Current ifNotNil: [Current removeAllListeners].
	Current := nil! !

!LiveAudioSource class methodsFor: 'singleton access' stamp: 'jcg 5/10/2006 00:16'!
current
	^ Current ifNil: [Current := LiveAudioSource new].! !

!LiveAudioSource class methodsFor: 'class initialization' stamp: 'jcg 5/10/2006 00:16'!
initialize
	"Force creation of LiveAudioSource that will be saved so it will maintain the same sourceID."
	self current.  ! !

!LiveAudioSource methodsFor: 'private' stamp: 'jcg 5/10/2006 16:02'!
codec
	"This must match the codec in TMediaStreamingSpeaker.  Later, add a protocol for updating codecs on the fly."
	codec ifNil: [codec := ADPCMCodec newBitsPerSample: 4].
	^ codec! !

!LiveAudioSource methodsFor: 'private' stamp: 'hrs 7/26/2006 10:02'!
createSource
	self log: 'creating sound input stream'.
	source := SignallingSoundInputStream new.
	source bufferSize: 512.
	source recordLevel: 1.0.  "this works for iSight input."
	self runScript: #updateListeners when: {source. #bufferAvailable}.
	source startRecording.! !

!LiveAudioSource methodsFor: 'private' stamp: 'jcg 5/10/2006 15:44'!
getUpdateValue
	"Answer the data that should be passed to each listener to update itself."
	^ self codec encodeSoundBufferNoReset: self source nextBufferOrNil ! !

!LiveAudioSource methodsFor: 'private' stamp: 'jcg 5/10/2006 14:37'!
keyForListener: streamingSpeakerFarRef
	"Answer the key used to look up the listener."
	^ streamingSpeakerFarRef myName copy! !

!LiveAudioSource methodsFor: 'private' stamp: 'jcg 5/10/2006 16:05'!
noMoreListeners
	source ifNotNil: 
		[self log: 'stopping recording'.
		[source stopRecording. source := nil] fork]
! !

!LiveAudioSource methodsFor: 'private' stamp: 'jcg 5/10/2006 14:37'!
updateListener: listener with: updateValue
	listener future decode: updateValue! !

!LiveMediaSource class methodsFor: 'connecting' stamp: 'jcg 5/10/2006 00:09'!
attemptConnectionTo: srcID from: listener
	self current attemptConnectionTo: srcID from: listener! !

!LiveMediaSource class methodsFor: 'connecting' stamp: 'jcg 5/10/2006 00:08'!
attemptDisconnectionFrom: camID from: listener
	self current attemptDisconnectionFrom: camID from: listener! !

!LiveMediaSource class methodsFor: 'singleton access' stamp: 'jcg 5/10/2006 00:07'!
current
	self subclassResponsibility! !

!LiveMediaSource class methodsFor: 'class initialization' stamp: 'jcg 5/10/2006 00:12'!
initialize
	Smalltalk addToShutDownList: self! !

!LiveMediaSource class methodsFor: 'system shutdown' stamp: 'jcg 5/10/2006 00:14'!
shutDown: quitting
	self allSubInstancesDo: [:lms | lms removeAllListeners]! !

!LiveMediaSource methodsFor: 'connecting' stamp: 'jcg 5/10/2006 00:20'!
attemptConnectionTo: srcID from: listener
	sourceID = srcID ifFalse: [^ self "This isn't the right source for the listener"].
	listeners at: (self keyForListener: listener) put: listener.
	self source startRecording.
	! !

!LiveMediaSource methodsFor: 'connecting' stamp: 'jcg 5/10/2006 00:21'!
attemptDisconnectionFrom: srcID from: listener
	sourceID = srcID ifFalse: [^ self "This isn't the right source for the listener"].
	self removeListenerWithKey: (self keyForListener: listener)! !

!LiveMediaSource methodsFor: 'private' stamp: 'hrs 6/13/2006 14:06'!
broadcast: aBlock
	listeners copy keysAndValuesDo: 
		[:key :listener | 
		[aBlock value: listener]
			on: Error
			do:	[:err | 
				"If island has no controller, it must be snapshotting, which is OK."
				"Otherwise, remove the listener."
				(listener island get: #controller) ifNotNil:
					[self log: 'removing listener due to: ', err.
					self removeListenerWithKey: key]]].
! !

!LiveMediaSource methodsFor: 'private' stamp: 'jcg 5/9/2006 23:46'!
createSource
	self subclassResponsibility! !

!LiveMediaSource methodsFor: 'private' stamp: 'jcg 5/10/2006 14:25'!
getUpdateValue
	"Answer the data that should be passed to each listener to update itself."
	self subclassResponsibility! !

!LiveMediaSource methodsFor: 'initialize' stamp: 'hrs 7/11/2006 19:42'!
initialize
	super initialize.
	sourceID := Island default new: TObjectID.
	listeners := Dictionary new.! !

!LiveMediaSource methodsFor: 'private' stamp: 'jcg 5/10/2006 00:22'!
keyForListener: videoDecoderFarRef
	"Answer the key used to look up the listener."
	self subclassResponsibility! !

!LiveMediaSource methodsFor: 'private' stamp: 'jcg 5/10/2006 15:36'!
listeners
	"For debugging."
	^ listeners! !

!LiveMediaSource methodsFor: 'private' stamp: 'jcg 5/10/2006 00:00'!
log: aString
	true ifTrue: [Transcript show: self class printString, ': ', aString; cr].! !

!LiveMediaSource methodsFor: 'private' stamp: 'jcg 5/10/2006 00:04'!
noMoreListeners
	"This is called when the last listener has left."
	self subclassResponsibility! !

!LiveMediaSource methodsFor: 'private' stamp: 'jcg 5/10/2006 00:11'!
removeAllListeners
	listeners := Dictionary new.
	self noMoreListeners! !

!LiveMediaSource methodsFor: 'private' stamp: 'jcg 5/10/2006 00:03'!
removeListenerWithKey: aKey
	listeners removeKey: aKey ifAbsent: [^ self].
	self log: listeners size printString, ' listeners left'.
	listeners isEmpty ifTrue: [self noMoreListeners]! !

!LiveMediaSource methodsFor: 'accessing' stamp: 'jcg 5/9/2006 23:46'!
source
	source ifNil: [self createSource].
	^ source! !

!LiveMediaSource methodsFor: 'accessing' stamp: 'jcg 5/9/2006 23:41'!
sourceID
	^ sourceID! !

!LiveMediaSource methodsFor: 'private' stamp: 'hrs 6/13/2006 14:07'!
updateListeners
	| updateValue |
	updateValue := self getUpdateValue.
	self broadcast: [:listener | self updateListener: listener with: updateValue].
! !

!LiveMediaSource methodsFor: 'private' stamp: 'jcg 5/10/2006 14:24'!
updateListener: listener with: updateValue
	self subclassResponsibility! !

LiveMediaSource subclass: #LiveVideoSource
	instanceVariableNames: ''
	classVariableNames: 'Current'
	poolDictionaries: ''
	category: 'Wisconsin-Video'!

!LiveVideoSource commentStamp: 'jcg 5/5/2006 01:32' prior: 0!
This is a video source that feeds objects (currently only TLiveVideoWindows, but will eventually be arbitrary TForms) in a 3D space.

Each instance has it's own 'cameraID'.  The intention is for the LiveVideoSource to be a singleton (use the class-side method #current); we assume that the typical Croquet *user* will only use one Smalltalk image, and therefore have a unique cameraID.  This allows us to reconnect the LiveVideoSource to video sinks (i.e. TLiveVideoWindows).  For example, consider a typical scenario a user joins a persistent world, creates a video window linked to her webcam, later shuts her computer down for the night, and rejoins the world the next day.  This framework will reconnect the video source and sink.  This framework also supports copying and pasting video windows, even into spaces on different Islands.!

!LiveVideoSource class methodsFor: 'singleton access' stamp: 'jcg 5/10/2006 00:30'!
clearSingleton
	Current ifNotNil: [Current removeAllListeners].
	Current := nil! !

!LiveVideoSource class methodsFor: 'singleton access' stamp: 'jcg 5/3/2006 23:58'!
current
	^ Current ifNil: [Current := LiveVideoSource new].! !

!LiveVideoSource class methodsFor: 'class initialization' stamp: 'jcg 5/10/2006 00:16'!
initialize
	"Force creation of LiveVideoSource that will be saved so it will maintain the same sourceID."
	self current.  ! !

!LiveVideoSource methodsFor: 'accessing' stamp: 'jcg 5/9/2006 23:48'!
camera
	"Another name for the video source."
	^ self source! !

!LiveVideoSource methodsFor: 'private' stamp: 'hrs 6/13/2006 14:19'!
createSource
	| extent |
	self log: 'creating camera'.
	source := VideoGrabber new.
	extent := source width @ source height.
	self broadcast: [:listener | listener future extent: extent].
	self runScript: #updateListeners when: {source. #frameChanged}.! !

!LiveVideoSource methodsFor: 'private' stamp: 'jcg 5/10/2006 00:06'!
destroyCamera
	"If we had a smarter VideoGrabber that actually stopped grabbing frames (not just one that stops broadcasting updates), then we could use #stopRecording instead of #destroyCamera.  This works quite well anyway."
	self flag: #jcg.
	source ifNotNilDo: 
		[:cam |
		self log: 'destroying camera'.
		[source := nil. cam destroy] forkAt: (Processor activePriority - 1)]! !

!LiveVideoSource methodsFor: 'private' stamp: 'jcg 5/10/2006 14:34'!
getUpdateValue
	"Answer the data that should be passed to each listener to update itself."
	^ self camera jpegBytes! !

!LiveVideoSource methodsFor: 'private' stamp: 'jcg 5/10/2006 00:20'!
keyForListener: videoDecoderFarRef
	"Answer the key used to look up the listener."
	^ videoDecoderFarRef myName copy! !

!LiveVideoSource methodsFor: 'private' stamp: 'jcg 5/10/2006 00:04'!
noMoreListeners
	self destroyCamera! !

!LiveVideoSource methodsFor: 'private' stamp: 'jcg 5/10/2006 14:24'!
updateListener: listener with: updateValue
	listener future decode: updateValue! !

Object subclass: #MPEGPlayer2
	instanceVariableNames: 'form startTime clockBias frameRate lastDelay noSound sampleRate audioPlayerProcess videoPlayerProcess playerProcessPriority soundQueue timeCheck semaphoreForSound errorForSoundStart volume dataSource'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-MPEG'!

!MPEGPlayer2 commentStamp: 'jcg 8/5/2006 12:25' prior: 0!
Derived from:

V1.01 johnmci@smalltalkconsulting.com Nov 8th 2000
A Simple MPEG Player for playing MPEG3 audio or video 

| foo |
foo _ MpegPlayer playFile: 'my.mpg'.
foo playStream: 0. "To play both audio and video, stream #0 "

foo playAudioStream: 0 "To play audio stream".
foo playVideoStream: 0 "To play video stream"
foo playStreamWaitTilDone: 0 "To play audio/video as currrent process"

or 
	| foo |
	foo _ MPEGPlayer playFile: 'my.mpg' onForm: Display.
	foo playStream: 0.
	To play full screen.
!

!MPEGPlayer2 class methodsFor: 'file suffixes' stamp: 'jcg 4/19/2006 23:49'!
registeredAudioFileSuffixes
    "Answer the file extensions for which MPEGPlayer registers audio services with FileList."
     "MPEGPlayer registeredAudioFileSuffixes"

     ^{ 'mp3'.  }

	! !

!MPEGPlayer2 class methodsFor: 'file suffixes' stamp: 'jcg 4/19/2006 23:49'!
registeredVideoFileSuffixes
    "Answer the file extensions for which MPEGPlayer registers video services with FileList."
     "MPEGPlayer registeredVideoFileSuffixes"

     ^{ 'mpg'. 'mpeg'. 'jmv'. }

	! !

!MPEGPlayer2 methodsFor: 'access to attributes' stamp: 'jcg 4/20/2006 08:59'!
audioChannels: streamIndex
	^self dataSource audioChannels: streamIndex! !

!MPEGPlayer2 methodsFor: 'access to attributes' stamp: 'jcg 4/20/2006 08:59'!
audioSampleRate: streamIndex
	^self dataSource audioSampleRate: streamIndex! !

!MPEGPlayer2 methodsFor: 'access to attributes' stamp: 'jcg 4/20/2006 08:59'!
audioSamples: streamIndex
	^self dataSource audioSamples: streamIndex
! !

!MPEGPlayer2 methodsFor: 'play controls' stamp: 'jcg 4/19/2006 23:48'!
backAudio: aNumber forStream: aStream
	self forwardAudio: (0-aNumber) forStream: aStream! !

!MPEGPlayer2 methodsFor: 'play controls' stamp: 'jcg 4/19/2006 23:48'!
backVideo: aNumber forStream: aStream
	self forwardVideo: (0-aNumber) forStream: aStream! !

!MPEGPlayer2 methodsFor: 'delay' stamp: 'jcg 4/20/2006 21:01'!
calculateDelayGivenFrame: frame stream: streamIndex
	| estimated current delta |

	current := self elapsedTimeForStream: streamIndex.
	estimated := ((frame asFloat / self frameRate) * 1000) asInteger  - (self clockBiasForStream: streamIndex).
	delta := estimated - current.
	delta > 33  ifTrue: 
		[self lastDelay: (delta + self lastDelay) // 2. 
		 (Delay forMilliseconds: self lastDelay) wait].
	delta < -33  ifTrue: 
		[self lastDelay: self lastDelay // 2.
		 self decideToSkipAFrame: delta averageWait: current//frame stream: streamIndex].
	! !

!MPEGPlayer2 methodsFor: 'delay' stamp: 'jcg 4/20/2006 21:01'!
calculateDelayToSoundGivenFrame: frame stream: streamIndex
	| current delta buffers estimatedAudio estimatedVideo |

	current :=  (self elapsedTimeForStream: streamIndex) + (self clockBiasForStream: streamIndex).
	buffers := (self soundQueue sounds size - 1 ) max: 0.
	buffers = 0 ifTrue: [^self].
	estimatedAudio :=  ((self currentAudioSampleForStream: streamIndex) 
			- (buffers * self sampleRate // 10) 
			- self soundQueue currentSound samplesRemaining) * 1000 / self sampleRate.
	estimatedAudio := estimatedAudio - 0000.
	estimatedVideo := ((frame asFloat / self frameRate) * 1000) asInteger.
	delta := estimatedVideo - estimatedAudio.
	delta > 100  ifTrue: 
		[self lastDelay < delta ifTrue: [self lastDelay: self lastDelay + (((delta-self lastDelay)/10) max: 1)].
		(Delay forMilliseconds: self lastDelay) wait].
	delta < -100  ifTrue: 
		[self lastDelay: ((self lastDelay - 10) max: 1).
		 self decideToSkipAFrame: delta averageWait: current//frame stream: streamIndex].
! !

!MPEGPlayer2 methodsFor: 'utility' stamp: 'jcg 4/20/2006 13:57'!
changed
	self synchronousSignal: #videoChanged with: self! !

!MPEGPlayer2 methodsFor: 'utility' stamp: 'jcg 4/19/2006 23:49'!
checkForm: aStream
	| y x |

	self form notNil ifTrue: [^self].
	y := self videoFrameHeight: aStream.
	x := self videoFrameWidth: aStream.
	self form:  (Form extent: x@y depth: 32)
! !

!MPEGPlayer2 methodsFor: 'access' stamp: 'jcg 4/19/2006 23:48'!
clockBias
	^clockBias! !

!MPEGPlayer2 methodsFor: 'access' stamp: 'jcg 4/20/2006 10:15'!
clockBiasForStream: streamIndex
	^self clockBias at: streamIndex + 1.! !

!MPEGPlayer2 methodsFor: 'access' stamp: 'jcg 4/20/2006 10:15'!
clockBiasForStream: streamIndex put: aValue
	self clockBias at: streamIndex + 1 put: aValue! !

!MPEGPlayer2 methodsFor: 'private' stamp: 'jcg 4/19/2006 23:48'!
clockBias: aArray
	clockBias := aArray! !

!MPEGPlayer2 methodsFor: 'initialize-release' stamp: 'jcg 4/20/2006 08:24'!
close
	self dataSource closeFile! !

!MPEGPlayer2 methodsFor: 'audio' stamp: 'jcg 4/20/2006 10:18'!
createSoundFrom: streamIndex 
	| snds channels |
	
	snds := OrderedCollection new.
	channels := self audioChannels: 0.
	1 to: channels do: [:c | snds add: (self readSoundChannel: c - 1 stream: streamIndex)].
	channels = 1
		ifTrue:[^ MixedSound new
				add: (snds at: 1) pan: 0.5 volume: volume;
				
				yourself]
		ifFalse: [
			^ MixedSound new
				add: (snds at: 1) pan: 0.0 volume: volume;
				add: (snds at: 2) pan: 1.0 volume: volume;
				yourself].! !

!MPEGPlayer2 methodsFor: 'access to attributes' stamp: 'jcg 4/20/2006 09:01'!
currentAudioLocationInPercent: streamIndex
	^ ((self currentAudioSampleForStream: streamIndex)/(self audioSamples: streamIndex)) asFloat
! !

!MPEGPlayer2 methodsFor: 'access' stamp: 'jcg 4/20/2006 10:15'!
currentAudioSampleForStream: streamIndex
	^self dataSource audioGetSample: streamIndex! !

!MPEGPlayer2 methodsFor: 'access' stamp: 'jcg 4/20/2006 10:15'!
currentAudioSampleForStream: streamIndex put: aNumber
	self dataSource audioSetSample: aNumber stream: streamIndex! !

!MPEGPlayer2 methodsFor: 'access to attributes' stamp: 'jcg 4/20/2006 08:24'!
currentExternalLocationInPercent
	"Warning this might not return what you want, it gets percentage based on audio, or video stream based on last usage, because we buffer audio it may give incorrect information when playing mpeg movies"
	^self dataSource getPercentage! !

!MPEGPlayer2 methodsFor: 'access to attributes' stamp: 'jcg 4/20/2006 09:02'!
currentLocationInPercent: streamIndex

	self hasVideo ifTrue: [^ self currentVideoLocationInPercent: streamIndex].
	self hasAudio ifTrue: [^ self currentAudioLocationInPercent: streamIndex].

! !

!MPEGPlayer2 methodsFor: 'access' stamp: 'jcg 4/20/2006 10:15'!
currentVideoFrameForStream: streamIndex
	^self dataSource videoGetFrame: streamIndex! !

!MPEGPlayer2 methodsFor: 'access' stamp: 'jcg 4/20/2006 10:15'!
currentVideoFrameForStream: streamIndex put: aNumber
	self dataSource videoSetFrame: aNumber stream: streamIndex! !

!MPEGPlayer2 methodsFor: 'access to attributes' stamp: 'jcg 4/20/2006 09:01'!
currentVideoLocationInPercent: streamIndex
	^ ((self currentVideoFrameForStream: streamIndex)/(self videoFrames: streamIndex)) asFloat
! !

!MPEGPlayer2 methodsFor: 'access' stamp: 'jcg 4/20/2006 08:29'!
dataSource
	^ dataSource! !

!MPEGPlayer2 methodsFor: 'access' stamp: 'jcg 4/20/2006 11:25'!
dataSource: anMPEGDataSourceOrNil
	dataSource == anMPEGDataSourceOrNil ifTrue: [^ self "Source hasn't changed; do nothing"].
	self stop "playing audio/video from the current data source".
	dataSource := anMPEGDataSourceOrNil.
	self lastDelay: 10.
	dataSource 
		ifNotNil: 
			[self startTime: (Array new: self totalVideoStreams).
			self clockBias: (Array new: self totalVideoStreams withAll: 0)]
		ifNil:
			[self startTime: nil.
			self clockBias: nil].! !

!MPEGPlayer2 methodsFor: 'delay' stamp: 'jcg 4/20/2006 10:19'!
decideToSkipAFrame: delta averageWait: aWaitTime stream: streamIndex
	| estimatedFrames |

	delta abs > aWaitTime ifTrue: 
		[estimatedFrames := ( delta abs / (1000 / self frameRate)) asInteger.
		self videoDropFrames:  estimatedFrames stream: streamIndex].! !

!MPEGPlayer2 methodsFor: 'access' stamp: 'jcg 4/20/2006 21:00'!
elapsedTimeForStream: streamIndex
	^ Time millisecondsSince: (self startTimeForStream: streamIndex)! !

!MPEGPlayer2 methodsFor: 'access to attributes' stamp: 'jcg 4/20/2006 09:03'!
endOfAudio: streamIndex
	^self dataSource endOfAudio: streamIndex
! !

!MPEGPlayer2 methodsFor: 'access to attributes' stamp: 'jcg 4/20/2006 09:03'!
endOfVideo: streamIndex
	^self dataSource endOfVideo: streamIndex
! !

!MPEGPlayer2 methodsFor: 'access' stamp: 'jcg 4/19/2006 23:48'!
errorForSoundStart: aValueInMilliseconds
	errorForSoundStart := aValueInMilliseconds
! !

!MPEGPlayer2 methodsFor: 'access' stamp: 'jcg 4/20/2006 08:26'!
fileName
	^self dataSource fileName! !

!MPEGPlayer2 methodsFor: 'access' stamp: 'jcg 4/20/2006 08:36'!
form
	^ form! !

!MPEGPlayer2 methodsFor: 'access' stamp: 'jcg 4/19/2006 23:48'!
form: aForm
	form := aForm! !

!MPEGPlayer2 methodsFor: 'play controls' stamp: 'jcg 4/19/2006 23:48'!
forwardAudio: aNumber forStream: aStream
	| newLocation |

	self hasAudio ifFalse: [^self].
	newLocation := (((self currentAudioSampleForStream: aStream) + aNumber) min: (self audioSamples: aStream)) max: 0 .
	self currentAudioSampleForStream: aStream put: newLocation! !

!MPEGPlayer2 methodsFor: 'play controls' stamp: 'jcg 4/19/2006 23:48'!
forwardVideo: aNumber forStream: aStream
	| newLocation |

	self hasVideo ifFalse: [^self].
	newLocation := (((self currentVideoFrameForStream: aStream) + aNumber) min: (self videoFrames: aStream)) max: 0.
	self currentVideoFrameForStream: aStream put: newLocation.
! !

!MPEGPlayer2 methodsFor: 'access' stamp: 'jcg 4/19/2006 23:48'!
frameRate
	^frameRate! !

!MPEGPlayer2 methodsFor: 'access' stamp: 'jcg 4/19/2006 23:48'!
frameRate: aRate
	frameRate := aRate! !

!MPEGPlayer2 methodsFor: 'access to attributes' stamp: 'jcg 4/20/2006 08:26'!
getTimeCode
	^self dataSource getTimeCode! !

!MPEGPlayer2 methodsFor: 'access to attributes' stamp: 'jcg 4/20/2006 08:26'!
getTOC: timecode doStreams: streams
	^self dataSource getTOC: timecode doStreams: streams
! !

!MPEGPlayer2 methodsFor: 'access to attributes' stamp: 'jcg 4/20/2006 08:26'!
hasAudio
	^self dataSource hasAudio
	! !

!MPEGPlayer2 methodsFor: 'access to attributes' stamp: 'jcg 4/20/2006 08:26'!
hasVideo
	^self dataSource hasVideo! !

!MPEGPlayer2 methodsFor: 'initialize-release' stamp: 'jcg 4/20/2006 08:52'!
initialize

	super initialize.
	self playerProcessPriority: Processor userSchedulingPriority.
	self dataSource: nil.
	volume := 1.0.
	errorForSoundStart := 500.
	semaphoreForSound := Semaphore new.
! !

!MPEGPlayer2 methodsFor: 'initialize-release' stamp: 'jcg 4/19/2006 23:48'!
initializeWithFileName: aPath morph: aMorphic
	self initialize: aPath.
	self morph: aMorphic.
	^self! !

!MPEGPlayer2 methodsFor: 'initialize-release' stamp: 'jcg 4/20/2006 08:54'!
initialize: aPath
	"Separate initialization from changing the data source that the player is playing from."
	self shouldNotImplement.



	"self halt.
	self isBuffer ifTrue: 
		[external := MPEGFile openBuffer: buffer]
	 ifFalse: 
		[(MPEGFile isFileValidMPEG: aPath) ifFalse: [^nil].
		external := MPEGFile openFile: aPath.].
	self playerProcessPriority: Processor userSchedulingPriority.
	self lastDelay: 10.
	volume := 1.0.
	errorForSoundStart := 500.
	semaphoreForSound := Semaphore new.
	self startTime: (Array new: self totalVideoStreams).
	self clockBias: (Array new: self totalVideoStreams withAll: 0)."! !

!MPEGPlayer2 methodsFor: 'access' stamp: 'jcg 4/19/2006 23:48'!
isBuffer
	^isBuffer == true! !

!MPEGPlayer2 methodsFor: 'play controls' stamp: 'jcg 4/20/2006 10:41'!
isPlaying
	^ audioPlayerProcess notNil or: [videoPlayerProcess notNil]! !

!MPEGPlayer2 methodsFor: 'access' stamp: 'jcg 4/19/2006 23:48'!
lastDelay
	^lastDelay! !

!MPEGPlayer2 methodsFor: 'access' stamp: 'jcg 4/19/2006 23:48'!
lastDelay: aNumber
	lastDelay := aNumber! !

!MPEGPlayer2 methodsFor: 'access' stamp: 'jcg 4/19/2006 23:48'!
noSound
	^noSound! !

!MPEGPlayer2 methodsFor: 'access' stamp: 'jcg 4/19/2006 23:48'!
noSound: flag
	noSound := flag! !

!MPEGPlayer2 methodsFor: 'play' stamp: 'jcg 4/20/2006 20:49'!
playAudioStreamNoSeek: streamIndex

	self hasAudio ifFalse: [^self].
	self setupStream: streamIndex.
	self startAudioPlayerProcess: streamIndex.! !

!MPEGPlayer2 methodsFor: 'play' stamp: 'jcg 4/20/2006 10:21'!
playAudioStreamWaitTilDone: streamIndex

	self hasAudio ifFalse: [^self].
	self setupStream: streamIndex.
	self privatePlayAudioStream: streamIndex.! !

!MPEGPlayer2 methodsFor: 'play' stamp: 'jcg 4/20/2006 10:21'!
playAudioStream: streamIndex

	self hasAudio ifFalse: [^self].
	self setupStream: streamIndex.
	self startAudioPlayerProcess: streamIndex.! !

!MPEGPlayer2 methodsFor: 'access' stamp: 'jcg 4/19/2006 23:48'!
playerProcessPriority
	^playerProcessPriority! !

!MPEGPlayer2 methodsFor: 'access' stamp: 'jcg 4/19/2006 23:48'!
playerProcessPriority: aNumber
	playerProcessPriority := aNumber! !

!MPEGPlayer2 methodsFor: 'play' stamp: 'jcg 4/20/2006 10:21'!
playStreamWaitTilDone: streamIndex
	self noSound: self hasAudio not.
	self privatePlayVideoStream: streamIndex.! !

!MPEGPlayer2 methodsFor: 'play' stamp: 'jcg 4/20/2006 10:21'!
playStream: streamIndex
	self noSound: self hasAudio not.
	self startVideoPlayerProcess: streamIndex
! !

!MPEGPlayer2 methodsFor: 'play' stamp: 'jcg 4/20/2006 10:21'!
playVideoStreamWaitTilDone: streamIndex
	self noSound: true.
	self privatePlayVideoStream: streamIndex

! !

!MPEGPlayer2 methodsFor: 'play' stamp: 'jcg 4/20/2006 10:21'!
playVideoStream: streamIndex
	self noSound: true.
	self startVideoPlayerProcess: streamIndex

! !

!MPEGPlayer2 methodsFor: 'private-audio' stamp: 'jcg 4/20/2006 10:49'!
privatePlayAudioStream: streamIndex
	| number |

	number := 5.
	self soundQueue: (QueueSound new startTime: 0).
	[number + 2 timesRepeat: [self soundQueue add: (self createSoundFrom: streamIndex)].
	self soundQueue play.
	semaphoreForSound signal.
	[	[self soundQueue sounds size > number] whileTrue: [(Delay forMilliseconds: 100) wait].
		self soundQueue add: (self createSoundFrom: streamIndex).
		(self endOfAudio: streamIndex) ifTrue: [audioPlayerProcess := nil. ^self]
	] repeat] on: Error do: [audioPlayerProcess := nil]! !

!MPEGPlayer2 methodsFor: 'private' stamp: 'jcg 4/20/2006 21:04'!
privatePlayVideoStream: streamIndex
	| location bias |

	self hasVideo ifFalse: 
		[self timeCheck: 0@0.
		^self].
	self checkForm: streamIndex.
	self frameRate: (self videoFrameRate: streamIndex).
	location := self currentVideoFrameForStream: streamIndex.
	bias := (1/self frameRate*location*1000) asInteger.
	self clockBiasForStream: streamIndex put: bias.
	self videoLoop: streamIndex.

	self flag: #jcg.  "Debugging?  Doesn't seem to be used elsewhere."
	self timeCheck: (((self elapsedTimeForStream: streamIndex) + bias)/1000.0) @ ((self videoFrames: streamIndex) / self frameRate).

	videoPlayerProcess := nil! !

!MPEGPlayer2 methodsFor: 'audio' stamp: 'jcg 6/5/2006 21:21'!
readSoundChannel: aChannel stream: streamIndex
	| buffer result samples |

	samples := (self sampleRate // 10)  min: 
		((self audioSamples: streamIndex) - (self currentAudioSampleForStream: streamIndex)).
	(samples == 0) ifTrue: [self error: 'Mpeg at end of stream, toss error, catch up high']. 
	buffer := SoundBuffer newMonoSampleCount: samples.

	"The following code presumes that channel 0 is always read first; other channels are re-reading."
	aChannel = 0 
		ifTrue: [result := self dataSource audioReadBuffer: buffer stream: 
					streamIndex channel: aChannel]
		ifFalse: [result := self dataSource audioReReadBuffer: buffer stream: 
					streamIndex channel: aChannel].
	^SampledSound samples: buffer samplingRate: self sampleRate.
! !

!MPEGPlayer2 methodsFor: 'play controls' stamp: 'jcg 4/19/2006 23:48'!
recalculateNewSampleLocationForStream: aStream givenFrame: aFrame
	| estimated |

	self hasAudio ifFalse: [^self].
	estimated := (aFrame / (self videoFrames: aStream) * (self audioSampleRate: aStream)) asInteger.
	self currentAudioSampleForStream: aStream put: estimated.! !

!MPEGPlayer2 methodsFor: 'access' stamp: 'jcg 4/19/2006 23:48'!
sampleRate
	^sampleRate! !

!MPEGPlayer2 methodsFor: 'access' stamp: 'jcg 4/19/2006 23:48'!
sampleRate: aRate
	sampleRate := aRate! !

!MPEGPlayer2 methodsFor: 'play controls' stamp: 'jcg 4/20/2006 08:27'!
seekToHere: aPercentage forStream: aStream
	"Alternate method is to seek all video/audio for stream to a certain percentage using the primitive, but I think your mpeg must have timecodes!! otherwise endless loop"
	self dataSource seekPercentage: aPercentage! !

!MPEGPlayer2 methodsFor: 'play controls' stamp: 'jcg 4/20/2006 08:27'!
seekVideoAudioBasedOnFrame: aFrame forStream: aStream
	self dataSource hasVideo ifTrue: 
		[self currentVideoFrameForStream: aStream put:  aFrame].
	self recalculateNewSampleLocationForStream: aStream givenFrame: aFrame! !

!MPEGPlayer2 methodsFor: 'play controls' stamp: 'jcg 4/19/2006 23:48'!
setLocation: aPercentage forStream: aStream
	self hasAudio ifTrue: [self currentAudioSampleForStream: aStream put: ((self audioSamples: aStream) * aPercentage) asInteger]. 
	self hasVideo ifTrue: [self currentVideoFrameForStream: aStream put: ((self videoFrames: aStream) * aPercentage) asInteger].! !

!MPEGPlayer2 methodsFor: 'access to attributes' stamp: 'jcg 4/20/2006 08:28'!
setMMX: aBoolean
	self dataSource setMMX: aBoolean! !

!MPEGPlayer2 methodsFor: 'audio' stamp: 'jcg 4/20/2006 10:19'!
setupStreamNoSeek: streamIndex
	self sampleRate: (self audioSampleRate: streamIndex).
	SoundPlayer startPlayerProcessBufferSize:  8192 "(SoundPlayer bufferMSecs * self sampleRate) // 1000"
		rate: self sampleRate stereo: ((self  audioChannels: streamIndex) > 1).
! !

!MPEGPlayer2 methodsFor: 'audio' stamp: 'jcg 4/20/2006 20:48'!
setupStream: streamIndex
	self sampleRate: (self audioSampleRate: streamIndex).
	SoundPlayer 
		startPlayerProcessBufferSize:  8192 "(SoundPlayer bufferMSecs * self sampleRate) // 1000"
		rate: self sampleRate 
		stereo: (self audioChannels: streamIndex) > 1.
! !

!MPEGPlayer2 methodsFor: 'access' stamp: 'jcg 4/19/2006 23:48'!
soundQueue
	^soundQueue! !

!MPEGPlayer2 methodsFor: 'access' stamp: 'jcg 4/19/2006 23:48'!
soundQueue: aQueue
	soundQueue := aQueue! !

!MPEGPlayer2 methodsFor: 'audio' stamp: 'jcg 4/20/2006 14:41'!
startAudioPlayerProcess: streamIndex
	"If we already have an audio process running, don't start a new one."

	audioPlayerProcess ifNotNil: [^ self].
	audioPlayerProcess := [self privatePlayAudioStream: streamIndex] 
														forkAt: Processor userInterruptPriority
! !

!MPEGPlayer2 methodsFor: 'access' stamp: 'jcg 4/19/2006 23:48'!
startTime
	^startTime! !

!MPEGPlayer2 methodsFor: 'access' stamp: 'jcg 4/20/2006 10:15'!
startTimeForStream: streamIndex
	^self startTime at: streamIndex + 1! !

!MPEGPlayer2 methodsFor: 'access' stamp: 'jcg 4/20/2006 10:16'!
startTimeForStream: streamIndex put: aNumber
	^self startTime at: streamIndex + 1 put: aNumber! !

!MPEGPlayer2 methodsFor: 'private' stamp: 'jcg 4/19/2006 23:48'!
startTime: aArray
	startTime := aArray! !

!MPEGPlayer2 methodsFor: 'video' stamp: 'jcg 4/20/2006 13:15'!
startVideoPlayerProcess: streamIndex
	"If we already have a video process running, don't start a new one."

	videoPlayerProcess ifNotNil: [^ self].
	videoPlayerProcess := [self privatePlayVideoStream: streamIndex] 
															forkAt: self playerProcessPriority! !

!MPEGPlayer2 methodsFor: 'play controls' stamp: 'jcg 4/20/2006 10:34'!
stop
	videoPlayerProcess ifNotNil: 
		[videoPlayerProcess terminate. 
		videoPlayerProcess := nil].
	audioPlayerProcess ifNotNil: 
		[audioPlayerProcess terminate. 
		audioPlayerProcess := nil.
		SoundPlayer stopPlayingAll]! !

!MPEGPlayer2 methodsFor: 'initialize-release' stamp: 'jcg 4/19/2006 23:48'!
stopAndClose
	self stop.
	self close
! !

!MPEGPlayer2 methodsFor: 'access' stamp: 'jcg 4/19/2006 23:48'!
timeCheck
	^timeCheck! !

!MPEGPlayer2 methodsFor: 'access' stamp: 'jcg 4/19/2006 23:48'!
timeCheck: aNumber
	timeCheck := aNumber! !

!MPEGPlayer2 methodsFor: 'access to attributes' stamp: 'jcg 4/20/2006 08:28'!
totalVideoStreams
	^self dataSource totalVideoStreams
! !

!MPEGPlayer2 methodsFor: 'audio' stamp: 'jcg 4/20/2006 10:19'!
updateSoundStream: streamIndex! !

!MPEGPlayer2 methodsFor: 'access to attributes' stamp: 'jcg 4/20/2006 09:03'!
videoDropFrames: aNumberOfFrames stream: streamIndex
	^self dataSource videoDropFrames: aNumberOfFrames stream: streamIndex! !

!MPEGPlayer2 methodsFor: 'access to attributes' stamp: 'jcg 4/20/2006 09:03'!
videoFrameHeight: streamIndex
	^self dataSource videoFrameHeight: streamIndex
! !

!MPEGPlayer2 methodsFor: 'access to attributes' stamp: 'jcg 4/20/2006 09:03'!
videoFrameRate: streamIndex
	^self dataSource videoFrameRate: streamIndex! !

!MPEGPlayer2 methodsFor: 'access to attributes' stamp: 'jcg 4/20/2006 09:03'!
videoFrames: streamIndex
	^self dataSource videoFrames: streamIndex
! !

!MPEGPlayer2 methodsFor: 'access to attributes' stamp: 'jcg 4/20/2006 09:03'!
videoFrameWidth: streamIndex
	^self dataSource videoFrameWidth: streamIndex
! !

!MPEGPlayer2 methodsFor: 'video' stamp: 'jcg 4/20/2006 21:09'!
videoLoop: streamIndex
	| location | 

	self noSound ifFalse: 
		[self playAudioStreamNoSeek: streamIndex.
		semaphoreForSound wait.
		(Delay forMilliseconds: errorForSoundStart) wait].
	self startTimeForStream: streamIndex put: Time millisecondClockValue.

	[self dataSource videoReadFrameInto: self form stream: streamIndex.
	self changed.
	location := (self currentVideoFrameForStream: streamIndex)+1.
	true 
			ifTrue: [self calculateDelayGivenFrame: location stream: streamIndex]
			ifFalse: [self calculateDelayToSoundGivenFrame: location stream: streamIndex].
	(self endOfVideo: streamIndex)  ifTrue: [^self]] repeat.! !

!MPEGPlayer2 methodsFor: 'access to attributes' stamp: 'jcg 4/20/2006 09:04'!
videoPreviousFrame: streamIndex
	^self dataSource videoPreviousFrame: streamIndex
! !

!MPEGPlayer2 methodsFor: 'access to attributes' stamp: 'jcg 4/20/2006 08:28'!
videoSetCPUs: aNumber
	^self dataSource videoSetCPUs: aNumber
! !

!MPEGPlayer2 methodsFor: 'access' stamp: 'jcg 4/19/2006 23:48'!
volume: aVolume
	volume := aVolume! !

!Object methodsFor: '*Wisconsin-hacks' stamp: 'hrs 7/19/2006 11:03'!
copyOntoIsland: dstIsland
	| serializedSelf |
	serializedSelf := TIslandCopier new export: self.
	^ TIslandCopier new import: serializedSelf to: dstIsland
	! !

Object subclass: #TMedia
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-Media'!

!TMedia commentStamp: 'hrs 5/1/2006 17:15' prior: 0!
See #on:island: class method.!

!TMedia class methodsFor: 'accessing' stamp: 'jcg 7/26/2006 22:05'!
mediaClassFor: input
	| suffix |
	suffix := self suffix: input.
	(#('ase' 'mdl') includes: suffix) ifTrue: [^TMediaMesh].
	(#('png' 'bmp' 'jpg' 'gif' 'tif' 'jpeg') includes: suffix) ifTrue: [^TMediaImage].
	(#('mp3' 'mpeg' 'mpg') includes: suffix) ifTrue: [^TMPEGMovie].
	self notYetImplemented.
	^nil  "anybody but us, which would recurse."! !

!TMedia class methodsFor: 'instance creation' stamp: 'hrs 5/2/2006 14:48'!
newOn: island from: file

	"Allows for a great deal of flexibility in handling various media types.
	This can potentially handle handle cached 'immutables' (texture, mesh) and streaming
	(you start to play from a texture before it has all arrived).
	"

	| mediaClass media containerClass container |

	mediaClass := self mediaClassFor: file.
	mediaClass ifNil: [^nil].
	media := mediaClass newOn: island from: file.
	
	containerClass := mediaClass containerClass.
	container := containerClass newOn: island from: media.
	^container.! !

!TMedia class methodsFor: 'accessing' stamp: 'hrs 5/2/2006 09:36'!
suffix: input
	| name |
	name := input asUrl asString.
	^(FileList suffixOf: name) asLowercase.! !

Object subclass: #TMoviePlayer
	instanceVariableNames: 'movie time objectID videoTarget audioSources state frame'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-Movie'!

!TMoviePlayer methodsFor: 'private' stamp: 'jcg 8/6/2006 00:34'!
codecFor: resolvedMovie
	"Find or create the appropriate codec for the given movie."
	| codec manager | 
	manager := frame ocean handleManager.
	codec := manager at: objectID ifAbsent: [nil].
	codec ifNotNil: 
		[codec movieID = resolvedMovie sha ifFalse: 
			["A codec already exists, but not for this movie (perhaps hi-res movie arrived)."
			codec destroy.
			codec := nil]].
	codec ifNil: 
		["Must generate a new codec."
		codec := manager at: objectID ifAbsentPut: [resolvedMovie codecClass new].
		codec initFromMovie: resolvedMovie.
		codec target: (TSharedMediaCache default resolve: videoTarget distance: 0).
		codec movieTime: time].
	^ codec
! !

!TMoviePlayer methodsFor: 'initialize' stamp: 'jcg 7/28/2006 03:39'!
frame: aTFrame
	frame := aTFrame! !

!TMoviePlayer methodsFor: 'initialize' stamp: 'jcg 7/28/2006 05:16'!
initialize
	super initialize.
	objectID := TObjectID new.

	videoTarget := TForm new 
							bShrinkFit: true;
							bMipmap: true;
							setupForm: (Form extent: 2@2 depth: 32).
	videoTarget bThumb: true.
	videoTarget cacheRef: TMovieTargetFormCacheRef new.

	audioSources := { TStreamingSoundSource new.  TStreamingSoundSource new }.

	self stop.
! !

!TMoviePlayer methodsFor: 'testing' stamp: 'jcg 7/21/2006 19:53'!
isPaused
	^ state == #paused! !

!TMoviePlayer methodsFor: 'testing' stamp: 'jcg 7/21/2006 19:53'!
isPlaying
	^ state == #playing! !

!TMoviePlayer methodsFor: 'testing' stamp: 'jcg 7/21/2006 19:53'!
isStopped
	^ state == #stopped! !

!TMoviePlayer methodsFor: 'private' stamp: 'jcg 7/28/2006 11:32'!
loopTime
	"Time in milliseconds for each iteration of the #playLoop.  Make it loop about as fast as video frame rate."
	
	"Performance may be sensitive to how this value is chosen.  For instance, a value of 50ms for a particular MPEG file actually resulted in significantly degraded performance.  It is hypothesized that this is due to the expense of explicitly seeking within the file, since the decoding of frames (in general) depends on the values of previous frames.  If the frequency defined here is slightly lower than the movie frame rate, we will have the situation where the 'desired frame' to decode is 2 greater than the previous (already decoded) 'desired frame'.  In this case, it would be cheaper to explicitly decode the intermediate frame rather than using LibMPEG's 'seek' functionality; this heuristic could be put into the code, but not now."
	self flag: #jcg.

	^ 40 "25 frames/sec"! !

!TMoviePlayer methodsFor: 'accessing' stamp: 'jcg 7/18/2006 20:23'!
movie
	^ movie! !

!TMoviePlayer methodsFor: 'accessing' stamp: 'jcg 7/21/2006 20:05'!
movie: movieOrNil
	movie == movieOrNil ifTrue: [^ self].
	self stop.
	movie := movieOrNil! !

!TMoviePlayer methodsFor: 'actions' stamp: 'jcg 7/21/2006 19:58'!
pause
	self isPlaying ifFalse: [^ self "only pause a movie that is already playing"].
	state := #paused.
	self notYetImplemented.  "need to actually pause the movie"! !

!TMoviePlayer methodsFor: 'actions' stamp: 'jcg 7/28/2006 03:54'!
play
	self isPlaying ifTrue: [^ self].
	movie ifNil: [^ self "can't play no movie"].
	frame ifNil: [^ self "need for spatialized sound, also for workaround for initialization bug"].
	state := #playing.
	self playLoop! !

!TMoviePlayer methodsFor: 'actions' stamp: 'jcg 7/28/2006 03:32'!
playFromBeginning
	self stop.
	time := 0.0.
	self play! !

!TMoviePlayer methodsFor: 'private' stamp: 'jcg 8/6/2006 00:44'!
playLoop
	"This loop decodes/plays audio (if it is within 'earshot'), and also sets the time in the codec so that it can lazily decode video upon demand."
	| isAudible dist refDist rolloff gain movieToUse codec |
	self isPlaying ifFalse: [^ self].
	time > movie duration ifTrue: [^ self stop].

	isAudible := movie hasAudio.

	"We resolve the movie even if we're not sure it's in earshot, because it might be soon."
	dist := frame ocean localAvatarDistanceToFrame: frame.
	movieToUse := TSharedMediaCache default resolve: movie distance: dist.
	codec := self codecFor: movieToUse.
	codec movieTime: time.

	"If the sound is out of earshot, don't play it."
	isAudible ifTrue:
		["We assume the use of OpenAL's 'Inverse Distance Clamped' sound attenuation model."
		refDist := audioSources first referenceDistance.
		rolloff := audioSources first rolloffFactor.
		gain := refDist / (refDist + (rolloff * (dist - refDist))).
		gain < 0.01 ifTrue: [isAudible := false]].

	"Actually decode the sound."
	isAudible ifTrue: 
		[audioSources do: [:src | src
								position: frame globalPosition;
								direction: frame lookAt].
		codec 
			decodeAudio: movieToUse
			fromTime: time
			duration: self loopTime
			onto: audioSources].

	"Prepare for the next time through the loop."
	time := time + self loopTime.
	(self future: self loopTime) playLoop! !

!TMoviePlayer methodsFor: 'private' stamp: 'jcg 7/28/2006 06:00'!
postImportFromIslandCopier: copier
	objectID := TObjectID new! !

!TMoviePlayer methodsFor: 'actions' stamp: 'jcg 7/28/2006 04:14'!
stop
	self isStopped ifTrue: [^ self].
	state := #stopped.
	time := 0.0.
	movie ifNil: [^ self "nothing else to do"].! !

!TMoviePlayer methodsFor: 'accessing' stamp: 'jcg 7/28/2006 05:47'!
videoExtent
	movie ifNil: [^ 1@1].
	^ movie videoExtent! !

!TMoviePlayer methodsFor: 'accessing' stamp: 'jcg 7/28/2006 02:43'!
videoTarget
	^ videoTarget! !

Object subclass: #TMPEGPlayer
	instanceVariableNames: 'window period position sequence isPlaying'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-MPEG'!

TMPEGPlayer subclass: #TMPEGAudioPlayer
	instanceVariableNames: 'sources sourceOffsets'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-MPEG'!

!TMPEGAudioPlayer methodsFor: 'private' stamp: 'jcg 6/15/2006 23:25'!
doPlayAction
	| chunkSize buffers success |

	chunkSize := self mpeg audioChunkSize.
	buffers := sources collect: [:s | SoundBuffer newMonoSampleCount: chunkSize].

	success := self mpeg audioReadSampleNum: position into: buffers.
	success ifFalse:
				[Transcript show: 'TMPEGAudioPlayer>>doPlayAction    error'; cr.
				isPlaying := false.
				^ self].
 
	
	"Should take source offsets into account (so that we have spatial separation between channels for stereo streams."
	self flag: #jcg.
	sources do: [:src | src 
						position: window globalPosition;
						direction: window lookAt].

	sources with: buffers do: [:src :buf | src addBufferData: buf].
	buffers := nil.
	position := position + chunkSize.
! !

!TMPEGAudioPlayer methodsFor: 'initialize' stamp: 'jcg 6/15/2006 19:13'!
initializePeriod
	period := self mpeg audioPeriod! !

!TMPEGAudioPlayer methodsFor: 'actions' stamp: 'jcg 6/15/2006 20:18'!
play
	self mpeg audioStreamCount == 0 ifTrue: [^ self].
	sources do: [:src | src play].
	super play.! !

!TMPEGAudioPlayer methodsFor: 'actions' stamp: 'jcg 6/15/2006 20:14'!
stop
	super stop.
	sources do: [:src | src stop].! !

!TMPEGAudioPlayer methodsFor: 'initialize' stamp: 'jcg 6/15/2006 21:46'!
window: aTMPEGWindow
	| channelCount |

	super window: aTMPEGWindow.
	self mpeg audioStreamCount == 0 ifTrue: [^ self].
	channelCount := self mpeg audioChannelCountFor: 0.

	channelCount == 1 ifTrue: 
		[sources := {TStreamingSoundSource new}.
		sourceOffsets := {0.0}.
		^ self].

	channelCount == 2 ifTrue: 
		[sources := {TStreamingSoundSource new. TStreamingSoundSource new}.
		sources do: [:src | src
							gain: 1.0;
							coneOuterGain: 0.3;
							coneInnerAngle: 135.0;
							referenceDistance: 5.0;
							samplingRate: (self mpeg audioSampleRateFor: 0)].
		sourceOffsets := {-1.0. 1.0}.
		^ self].

	self error: 'unexpected channelCount: ', channelCount.! !

!TMPEGPlayer methodsFor: 'private' stamp: 'jcg 6/15/2006 18:58'!
continuePlaying
	isPlaying ifFalse: [^ self].
	self doPlayAction.
	isPlaying ifFalse: [^ self].
	(self future: period) continuePlaying! !

!TMPEGPlayer methodsFor: 'initialize' stamp: 'jcg 6/14/2006 15:38'!
destroy
	self notYetImplemented! !

!TMPEGPlayer methodsFor: 'private' stamp: 'jcg 6/14/2006 23:10'!
doPlayAction
	self subclassResponsibility! !

!TMPEGPlayer methodsFor: 'initialize' stamp: 'jcg 6/14/2006 23:06'!
initialize
	super initialize.
	isPlaying := false! !

!TMPEGPlayer methodsFor: 'initialize' stamp: 'jcg 6/14/2006 15:31'!
initializePeriod
	"How long between video-frames/audio-samples?"
	self subclassResponsibility! !

!TMPEGPlayer methodsFor: 'accessing' stamp: 'jcg 6/14/2006 15:42'!
mpeg
	^ window mpeg! !

!TMPEGPlayer methodsFor: 'actions' stamp: 'jcg 6/14/2006 23:09'!
play
	isPlaying ifTrue: [^ self].
	isPlaying := true.
	self continuePlaying.
	! !

!TMPEGPlayer methodsFor: 'actions' stamp: 'jcg 6/14/2006 23:52'!
rewind
	position := 0! !

!TMPEGPlayer methodsFor: 'actions' stamp: 'jcg 6/14/2006 23:54'!
stop
	isPlaying := false! !

!TMPEGPlayer methodsFor: 'initialize' stamp: 'jcg 6/14/2006 23:43'!
window: aTMPEGWindow
	window ifNotNil: [self error: 'window is already set'].
	window := aTMPEGWindow.
	sequence := 0.
	position := 0.
	self initializePeriod.! !

TMPEGPlayer subclass: #TMPEGVideoPlayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-MPEG'!

!TMPEGVideoPlayer methodsFor: 'private' stamp: 'jcg 6/15/2006 22:55'!
doPlayAction
	| target success |

	target := window targetTForm.
	success := self mpeg videoReadFrameNum: position into: target form.
	success 
		ifTrue: [target updateAll]
		ifFalse: 
			[Transcript show: 'TMPEGVideoPlayer>>doPlayAction    error'; cr.
			isPlaying := false].
	position := position + 1.! !

!TMPEGVideoPlayer methodsFor: 'initialize' stamp: 'jcg 6/14/2006 23:38'!
initializePeriod
	period := self mpeg videoPeriod! !

!TMPEGVideoPlayer methodsFor: 'actions' stamp: 'jcg 6/15/2006 19:15'!
play
	self mpeg videoStreamCount == 0 ifTrue: [^ self].
	super play.! !

Object subclass: #TOceanProxy
	instanceVariableNames: 'harness'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin'!

!TOceanProxy commentStamp: 'jcg 8/1/2006 22:39' prior: 0!
Sometimes objects on an island need to access objects in the ocean.  We've been adding iVars to the controller to access things like the clipboard and OpenAL, but it is becoming a pain.  We could simply allow access to the harness, but don't wish to promote that as a satisfactory approach (Prinicple of Least Authority, and all that jazz).

Eventually, we think that it would be useful for all TIslandControllers to reference a TOceanProxy, but for now, we're limiting it to WisconsinControllers.!

!TOceanProxy class methodsFor: 'instance creation' stamp: 'jcg 8/1/2006 22:39'!
forHarness: aHarness
	^ self new harness: aHarness! !

!TOceanProxy class methodsFor: 'instance creation' stamp: 'jcg 8/1/2006 22:39'!
howToPassAsArgument
	^#passByIdentity:! !

!TOceanProxy class methodsFor: 'as yet unclassified' stamp: 'hrs 8/5/2006 15:12'!
initialize
	(IslandArgumentCopier classPool at: #PassByIdentityRoots) addIfNotPresent: self.! !

!TOceanProxy methodsFor: 'accessing' stamp: 'jcg 8/1/2006 22:42'!
clipboard
	^ [harness clipboard] on: MessageNotUnderstood do: [:err | ^ nil]! !

!TOceanProxy methodsFor: 'accessing' stamp: 'jcg 8/5/2006 12:18'!
handleManager
	^ harness handleManager! !

!TOceanProxy methodsFor: 'initialize' stamp: 'jcg 8/1/2006 22:42'!
harness: aCroquetHarness
	harness := aCroquetHarness! !

!TOceanProxy methodsFor: 'accessing' stamp: 'jcg 8/1/2006 22:46'!
localAvatarDistanceToFrame: aFrame
	^ ((self localAvatarIsInSpace: aFrame root) and: [harness avatar replica isResolved]) 
			ifFalse: [1000000.0 "really really far"]
			ifTrue: [(harness avatar globalPosition - aFrame globalPosition) length]! !

!TOceanProxy methodsFor: 'accessing' stamp: 'jcg 8/1/2006 22:44'!
localAvatarIsInSpace: aSpace
	harness ifNil:[^false].
	^ (harness avatar currentSpace valueOn: self island) == aSpace! !

!TOceanProxy methodsFor: 'accessing' stamp: 'jcg 8/2/2006 00:30'!
userID
	^ [harness userID] on: MessageNotUnderstood do: [:err | ^ nil]! !

Object subclass: #TransientHandle
	instanceVariableNames: 'objectID manager time'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-InternalExternalMedia'!

!TransientHandle commentStamp: 'jcg 7/13/2006 23:59' prior: 0!
A TransientHandle is a reference to a resource that cannot persist between shutdown/restart of a Squeak image, but can always be reconstructed from a more permanent resource.  Examples are low-level OpenGL, OpenAL, and MPEG resources.

Instance variables:
	objectID 	<TObjectID>			Identifies the internal/external aspects of the resource.
	manager	<TransientHandleManager>
	time		<SmallInteger>		Most recent time that the resource was used.!

TransientHandle subclass: #TMovieCodec
	instanceVariableNames: 'target movieID movieTime audioStreams videoStreams'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-Movie-Decoding'!

!TMovieCodec methodsFor: 'decoding' stamp: 'jcg 7/26/2006 19:32'!
decodeAudio: movie fromSample: startSample count: sampleCount rate: sampleRate onto: audioSources
	self subclassResponsibility! !

!TMovieCodec methodsFor: 'decoding' stamp: 'jcg 7/28/2006 04:26'!
decodeAudio: movie fromTime: startMsecs duration: duration onto: audioSources

	| sampleRate startSample endSample sampleCount |
	sampleRate := movie audioSampleRate.
	startSample := (startMsecs * sampleRate / 1000.0) floor.
	endSample := ((startMsecs + duration) * sampleRate / 1000.0) floor.
	sampleCount := endSample - startSample.
	self 
		decodeAudio: movie 
		fromSample: startSample 
		count: sampleCount
		rate: sampleRate 
		onto: audioSources
! !

!TMovieCodec methodsFor: 'decoding' stamp: 'jcg 7/28/2006 04:32'!
frameAboutToRender
	self subclassResponsibility
! !

!TMovieCodec methodsFor: 'initialize' stamp: 'jcg 7/28/2006 04:05'!
initFromMovie: movie
	"Subclasses should extend this method.  We don't know whether 'movie' lives in the ocean or on the island; we must assume the latter.  Therefore, subclasses MUST NOT retain a reference to the movie or any object that it (transitively) refers to."
	movieID := movie sha.
	audioStreams := movie audioStreams deepCopy.
	videoStreams := movie videoStreams deepCopy.! !

!TMovieCodec methodsFor: 'accessing' stamp: 'jcg 7/21/2006 23:31'!
movieID
	^ movieID! !

!TMovieCodec methodsFor: 'accessing' stamp: 'jcg 7/25/2006 23:42'!
movieTime: msecs
	movieTime := msecs! !

!TMovieCodec methodsFor: 'private' stamp: 'jcg 7/20/2006 01:02'!
privateDestroy
	"Subclasses may want to extend."
	super privateDestroy.
	target codec: nil.
	! !

!TMovieCodec methodsFor: 'initialize' stamp: 'jcg 7/28/2006 05:19'!
target: aTMovieTargetTForm
	| videoExtent |
	target := aTMovieTargetTForm.
	videoExtent := videoStreams isEmpty 
									ifTrue: [2@2]
									ifFalse: [videoStreams first third asSmallerPowerOfTwo].
	target setupForm: (Form extent: videoExtent depth: 32).
	target codec: self.	"So that the target can access the codec for video decoding."! !

TMovieCodec subclass: #TMPEGMovieCodec
	instanceVariableNames: 'mpegPlayer mpegBuffer decodeBuffer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-Movie-Decoding'!

!TMPEGMovieCodec commentStamp: '<historical>' prior: 0!
Wraps John McIntosh's MPEG support.!

!TMPEGMovieCodec methodsFor: 'decoding' stamp: 'jcg 7/28/2006 11:24'!
decodeAudio: movie fromSample: startSample count: sampleCount rate: sampleRate onto: audioSources
	| pos result |
	(decodeBuffer isNil or: [decodeBuffer size ~~ sampleCount]) ifTrue: 
		["Need new decode buffer."
		decodeBuffer := SoundBuffer newMonoSampleCount: sampleCount].

	pos := mpegBuffer audioGetSample: 0.
	pos == startSample ifFalse: [mpegBuffer audioSetSample: startSample stream: 0].

	result := mpegBuffer audioReadBuffer: decodeBuffer stream: 0 channel: 0.
	result == -1 ifTrue: [self error: 'MPEG decode error'].
	audioSources first addBufferData: decodeBuffer samplingRate: sampleRate.

	result := mpegBuffer audioReReadBuffer: decodeBuffer stream: 0 channel: 1.
	result == -1 ifTrue: [self error: 'MPEG decode error'].
	audioSources second addBufferData: decodeBuffer samplingRate: sampleRate.
! !

!TMPEGMovieCodec methodsFor: 'decoding' stamp: 'jcg 7/30/2006 06:05'!
frameAboutToRender 
	| desiredFrame currentFrame frameDifference decodeTime |
	videoStreams isEmpty ifTrue: [^ self].
	desiredFrame := (videoStreams first second * movieTime / 1000.0) rounded.
	currentFrame := mpegBuffer videoGetFrame: 0.
	frameDifference := desiredFrame - currentFrame.

	frameDifference == 0 ifTrue: [^ self "we previously decoded the desired frame"].
decodeTime := 
[
	frameDifference == 1 ifFalse: [mpegBuffer videoSetFrame: desiredFrame-1 stream: 0].
	mpegBuffer videoReadFrameInto: target form stream: 0.
] timeToRun.

	target updateAll.! !

!TMPEGMovieCodec methodsFor: 'initialize' stamp: 'jcg 7/26/2006 19:40'!
initFromMovie: movie
	super initFromMovie: movie.
	mpegPlayer := MPEGPlayer2 new.
	mpegBuffer := MPEGFile openBuffer: movie bytes.
	mpegPlayer dataSource: mpegBuffer.! !

TMovieCodec subclass: #TPlaceholderMovieCodec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-Movie-Decoding'!

!TPlaceholderMovieCodec methodsFor: 'decoding' stamp: 'jcg 7/30/2006 00:33'!
decodeAudio: movie fromSample: startSample count: sampleCount rate: sampleRate onto: audioSources
	"Do nothing."! !

!TPlaceholderMovieCodec methodsFor: 'decoding' stamp: 'jcg 7/30/2006 00:38'!
frameAboutToRender
	| cycleTime tmp gray |

	"Cycle once every 5 seconds."
	cycleTime := 5000.
	tmp := (Time millisecondClockValue \\ cycleTime) asFloat.
	tmp > (cycleTime / 2) ifTrue: [tmp := cycleTime - tmp].
	gray := Color gray: tmp / (cycleTime / 2).
	target form fillColor: gray.
	target updateAll! !

!TransientHandle methodsFor: 'initialize' stamp: 'jcg 7/30/2006 01:56'!
destroy
	"Subclasses should extend."
	manager remove: objectID.
	self privateDestroy.
	manager := nil.
	! !

!TransientHandle methodsFor: 'initialize' stamp: 'jcg 6/14/2006 22:07'!
manager: anExternalMediaHandleManager
	manager := anExternalMediaHandleManager
	! !

!TransientHandle methodsFor: 'accessing' stamp: 'jcg 6/13/2006 20:50'!
objectID
	^ objectID
! !

!TransientHandle methodsFor: 'initialize' stamp: 'jcg 6/13/2006 20:50'!
objectID: oid
	objectID := oid! !

!TransientHandle methodsFor: 'private' stamp: 'jcg 7/20/2006 00:56'!
privateDestroy
	"Subclasses should extend.  Free any resources used by the handle."
	! !

!TransientHandle methodsFor: 'accessing' stamp: 'jcg 6/13/2006 20:50'!
time
	^ time
! !

!TransientHandle methodsFor: 'accessing' stamp: 'jcg 6/13/2006 20:51'!
time: newTime
	time := newTime
! !

Object subclass: #TransientHandleManager
	instanceVariableNames: 'handles lru epoch currentTime inactivityThreshold'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-InternalExternalMedia'!

!TransientHandleManager commentStamp: 'jcg 7/14/2006 17:52' prior: 0!
The TransientHandleManager manages (you guessed it) TransientHandles... see that class's comment.

It will be this class or a subclass that is responsible for managing handles for OpenGL, OpenAL, and others.

It is not clear whether all types of resources should be lumped into one manager, or if separate (sub-)instances should be used for each "type" of resource.  What is even meant by "type" in this context?  It could conceivably be as fine-grained as all OpenGL textures in one manager, all vertex buffers in another.  Or maybe all resources that require CPU memory in one, and GPU memory in another.  Or something different.

Instance variables:
	handles 		<KeyedSet>			The ExternalMediaHandles managed by this manager.
	lru				<Heap>				Keeps track of least-recently-used handle was used.
	epoch			<SmallInteger>		Time that manager was created.
	currentTime		<SmallInteger>		Reset at the beginning of each frame.
	inactivityThreshold <SmallInteger>	Destroy handles that have been inactive for this long.

NOTE: removal from an arbitrary position in the Heap could be made MUCH faster if each handle kept track of it's index in the heap (thus avoiding a linear scan).  However, arbitrary removals are infrequent.  It is much more common that the Heap needs to be re-sorted because handles' times have been updated; we optimize this by only re-sorting once per frame.
!

!TransientHandleManager class methodsFor: 'islands' stamp: 'jcg 6/14/2006 22:20'!
howToPassAsArgument
	^#passByIdentity:! !

!TransientHandleManager class methodsFor: 'class initialization' stamp: 'jcg 7/20/2006 01:04'!
initialize
	"TransientHandleManager initialize"
	Smalltalk addToShutDownList: self.! !

!TransientHandleManager class methodsFor: 'class initialization' stamp: 'jcg 7/21/2006 00:12'!
shutDown
	self allSubInstancesDo: [:mgr | mgr destroyAll]! !

!TransientHandleManager methodsFor: 'accessing' stamp: 'jcg 7/21/2006 23:54'!
at: key ifAbsentPut: aBlock
	| handle newHandle |
	handle := handles at: key ifAbsentPut: 
										[newHandle := aBlock value.
										newHandle manager: self.
										newHandle objectID: key copy.
										newHandle].
	handle time: currentTime.
	^ handle! !

!TransientHandleManager methodsFor: 'accessing' stamp: 'jcg 6/14/2006 22:05'!
at: key ifAbsent: aBlock
	^ handles at: key ifAbsent: aBlock! !

!TransientHandleManager methodsFor: 'rendering' stamp: 'jcg 6/13/2006 23:25'!
beginFrame
	currentTime := RealTime millisecondClockValue.! !

!TransientHandleManager methodsFor: 'initialize' stamp: 'jcg 7/20/2006 01:03'!
destroyAll
	handles do: [:h | h privateDestroy].
	self initialize.! !

!TransientHandleManager methodsFor: 'rendering' stamp: 'jcg 6/13/2006 23:34'!
endFrame
	| h |
	lru reSort.

	"Destroy inactive resources."
	[(h := lru firstOrNil) notNil 
		and: [(RealTime milliseconds: currentTime since: h time) >= inactivityThreshold]]
			whileTrue:
				[lru removeFirst destroy]
! !

!TransientHandleManager methodsFor: 'initialize' stamp: 'jcg 6/14/2006 22:54'!
initialize
	handles := KeyedSet keyBlock: [:hndl | hndl objectID].
	lru := Heap sortBlock: [:hndl1 :hndl2 | hndl1 time <= hndl2 time].
	epoch := currentTime := RealTime millisecondClockValue.
	inactivityThreshold := 300000. "five minutes"
! !

!TransientHandleManager methodsFor: 'private' stamp: 'jcg 7/20/2006 00:59'!
remove: key
	handles removeKey: key! !

Object subclass: #VideoGrabber
	instanceVariableNames: 'form jpegBytes minFrameTime loopProc'
	classVariableNames: 'Current'
	poolDictionaries: ''
	category: 'Wisconsin-Video'!

!VideoGrabber commentStamp: '<historical>' prior: 0!
This provides a wrapper for dual platform (mac = 0/pc = 1) video from a camera.  It uses Yoshiki Oshima's pc video capture package, and Clotho's quicktime package for mac!

VideoGrabber subclass: #VideoGrabberDummy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-Video'!

!VideoGrabberDummy commentStamp: 'jcg 12/26/2005 13:29' prior: 0!
Used if we don't know what kind of video grabber to use for this platform, or if there is an error initializing the video grabber.!

!VideoGrabberDummy methodsFor: 'initialize' stamp: 'jcg 12/26/2005 13:30'!
ensureInitialized
	form ifNotNil: [^ self].  "already initialized"
	form := Form extent: self defaultExtent depth: 32.
	form fill: form boundingBox fillColor: Color red! !

!VideoGrabberDummy methodsFor: 'private' stamp: 'jcg 12/26/2005 13:35'!
privateUpdateForm
	! !

VideoGrabber subclass: #VideoGrabberMacOSX
	instanceVariableNames: 'grabber'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-Video'!

!VideoGrabberMacOSX methodsFor: 'initialize' stamp: 'jcg 10/13/2005 11:50'!
destroy
	super destroy.
	grabber ifNil: [^ self "already destroyed"].
	grabber primStopGrabber.
	grabber := nil.! !

!VideoGrabberMacOSX methodsFor: 'initialize' stamp: 'jcg 10/13/2005 11:49'!
ensureInitialized
	form ifNotNil: [^ self].  "already initialized"
	form := Form extent: self defaultExtent depth: 32.
	form fillBlack.
	grabber := FrameGrabber new.
	grabber primStartGrabberWidth: form width height: form height! !

!VideoGrabberMacOSX methodsFor: 'private' stamp: 'jcg 12/21/2005 21:42'!
privateUpdateForm
	grabber primGetBits: form bits! !

VideoGrabber subclass: #VideoGrabberWin32
	instanceVariableNames: 'dshow'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-Video'!

!VideoGrabberWin32 methodsFor: 'initialize' stamp: 'jcg 10/13/2005 11:50'!
destroy
	super destroy.
	dshow ifNil: [^ self].
	dshow shutdownDecoder.
	dshow := nil.
! !

!VideoGrabberWin32 methodsFor: 'initialize' stamp: 'jcg 10/13/2005 11:21'!
ensureInitialized
	form ifNotNil: [^ self].  "already initialized"
	form := Form extent: self defaultExtent depth: 32.
	form fillBlack.

	dshow := DShowVideoController new.
	dshow
		createFrameSemaphore;
		initializeDecoder;
		checkForError.
	
(Delay forSeconds: 2) wait.	"blech"
	dshow
		decoderShowWindow: false;
		checkForError.
	
(Delay forSeconds: 1) wait.	"blech"
	dshow 
		decoderRun;
		checkForError.
! !

!VideoGrabberWin32 methodsFor: 'private' stamp: 'jcg 12/21/2005 21:43'!
privateUpdateForm
"        Transcript show: 'trying to call request capture/n'."
	dshow decoderRequestCapture.
"        Transcript show: 'requested capture, waiting for semaphore/n'."
	dshow frameSemaphore wait.
"        Transcript show: 'done waiting copying frame now.../n'."
	dshow decoderCopyLastCapturedFrameInto: form.
		! !

!VideoGrabber class methodsFor: 'singleton access' stamp: 'jcg 12/26/2005 12:11'!
current
	"We assume that callers always want an active video grabber."
	
	Current ifNil: 
		[Current := VideoGrabber new.
		Current updateForm].
	^ Current! !

!VideoGrabber class methodsFor: 'singleton access' stamp: 'jcg 10/6/2005 11:29'!
destroyCurrent
	Current ifNotNil:
		[Current destroy.
		Current := nil]
	! !

!VideoGrabber class methodsFor: 'class initialization' stamp: 'jcg 10/6/2005 11:20'!
initialize
	Smalltalk addToShutDownList: self! !

!VideoGrabber class methodsFor: 'instance creation' stamp: 'jcg 12/26/2005 13:28'!
new
	"Answer an instance of the proper subclass for the current platform."
	| grabber |
	self == VideoGrabber ifFalse: [^ self basicNew initialize].
	[grabber := self platformClass new] on: Error do: [grabber := VideoGrabberDummy new].
	^ grabber! !

!VideoGrabber class methodsFor: 'instance creation' stamp: 'jcg 10/13/2005 10:51'!
platformClass
	| platformName |
	platformName := Smalltalk platformName.
	platformName = 'unix' ifTrue: 
		[Smalltalk windowSystemName = 'Quartz'
			ifTrue: [platformName := 'Mac OS'  "fall through to Mac OS case"]
			ifFalse: [^ nil "not yet implemented"]].
	platformName = 'Mac OS' ifTrue: [^ VideoGrabberMacOSX].
	platformName = 'Win32' ifTrue: [^ VideoGrabberWin32].
	^ nil! !

!VideoGrabber class methodsFor: 'system shutdown' stamp: 'jcg 10/6/2005 11:28'!
shutDown
	self destroyCurrent! !

!VideoGrabber class methodsFor: 'singleton access' stamp: 'jcg 10/6/2005 13:56'!
step
	Current ifNotNil: [Current updateForm].! !

!VideoGrabber methodsFor: 'defaults' stamp: 'jcg 10/13/2005 12:43'!
defaultExtent
	^ 160@120! !

!VideoGrabber methodsFor: 'initialize' stamp: 'jcg 5/1/2006 15:44'!
destroy
	"Subclasses should extend this method."
	self stopRecording.
 	form := nil.! !

!VideoGrabber methodsFor: 'initialize' stamp: 'jcg 10/6/2005 11:42'!
ensureInitialized
	self subclassResponsibility! !

!VideoGrabber methodsFor: 'accessing' stamp: 'jcg 10/6/2005 11:50'!
extent
	^ form extent! !

!VideoGrabber methodsFor: 'accessing' stamp: 'jcg 10/6/2005 11:50'!
form
	^ form! !

!VideoGrabber methodsFor: 'accessing' stamp: 'jcg 10/13/2005 11:22'!
height
	^ form height! !

!VideoGrabber methodsFor: 'initialize' stamp: 'jcg 5/1/2006 15:43'!
initialize
	minFrameTime := 100.
	self ensureInitialized.! !

!VideoGrabber methodsFor: 'accessing' stamp: 'jcg 12/26/2005 10:17'!
jpegBytes
	"Lazily create jpegBytes only if someone wants them."
	jpegBytes ifNil: [jpegBytes := JPEGReadWriter2 new compress: form quality: 70].
	^ jpegBytes
! !

!VideoGrabber methodsFor: 'private' stamp: 'jcg 12/21/2005 21:42'!
privateUpdateForm
	self subclassResponsibility! !

!VideoGrabber methodsFor: 'private' stamp: 'jcg 5/1/2006 15:49'!
recordLoop
	| delay |
	delay := Delay forMilliseconds: minFrameTime.
	[
		self updateForm.
		delay wait.
	] repeat! !

!VideoGrabber methodsFor: 'accessing' stamp: 'jcg 10/6/2005 12:11'!
scaledForm
	^ form scaledToSize: 72@72! !

!VideoGrabber methodsFor: 'actions' stamp: 'jcg 5/1/2006 15:46'!
startRecording
	loopProc ifNotNil: [^ self "Already recording"].
	loopProc := [self recordLoop] forkAt: Processor lowIOPriority! !

!VideoGrabber methodsFor: 'actions' stamp: 'jcg 5/1/2006 15:47'!
stopRecording
	loopProc ifNotNil: [loopProc terminate. loopProc := nil].! !

!VideoGrabber methodsFor: 'updating' stamp: 'jcg 5/1/2006 15:42'!
updateForm
	"Update the form from the camera, recording the current time."
	self privateUpdateForm.
	jpegBytes := nil.
	self synchronousSignal: #frameChanged with: self.
! !

!VideoGrabber methodsFor: 'accessing' stamp: 'jcg 10/13/2005 11:22'!
width
	^ form width! !

Object subclass: #WisconsinRouterUser
	instanceVariableNames: 'userName userNameHash passwordHash facetNames'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin'!

!WisconsinRouterUser class methodsFor: 'instance creation' stamp: 'jcg 4/12/2006 14:48'!
guestNamed: username password: password
	^ self new
			name: username password: password;
			facetNames: WisconsinParticipant guestFacetNames;
			yourself! !

!WisconsinRouterUser class methodsFor: 'instance creation' stamp: 'jcg 5/21/2006 17:39'!
localCacheNamed: username password: password
	^ self new
			name: username password: password;
			facetNames: WisconsinParticipant localCacheFacetNames;
			yourself! !

!WisconsinRouterUser class methodsFor: 'instance creation' stamp: 'jcg 4/12/2006 14:50'!
participantNamed: username password: password
	^ self new
			name: username password: password;
			facetNames: WisconsinParticipant participantFacetNames;
			yourself! !

!WisconsinRouterUser class methodsFor: 'instance creation' stamp: 'jcg 4/12/2006 14:52'!
serverNamed: username password: password
	^ self new
			name: username password: password;
			facetNames: WisconsinParticipant serverFacetNames;
			yourself! !

!WisconsinRouterUser methodsFor: 'accessing' stamp: 'jcg 4/12/2006 14:54'!
facetNames
	^ facetNames! !

!WisconsinRouterUser methodsFor: 'initialize' stamp: 'jcg 4/12/2006 14:42'!
facetNames: fNames
	facetNames := fNames! !

!WisconsinRouterUser methodsFor: 'initialize' stamp: 'jcg 4/13/2006 17:09'!
name: name password: password
	userName := name.
	userNameHash := TCryptoRandom hashMessage: userName.
	password isString
		ifTrue:[passwordHash := TCryptoRandom hashMessage: password] 
		ifFalse:[passwordHash := password].! !

!WisconsinRouterUser methodsFor: 'accessing' stamp: 'jcg 4/12/2006 14:39'!
passwordHash
	^ passwordHash! !

!WisconsinRouterUser methodsFor: 'accessing' stamp: 'jcg 4/12/2006 14:53'!
userName
	^ userName! !

!WisconsinRouterUser methodsFor: 'accessing' stamp: 'jcg 4/12/2006 14:53'!
userNameHash
	^ userNameHash! !

Object subclass: #XrfbServerMaker
	instanceVariableNames: 'outerMorph teaWorld world'
	classVariableNames: 'HttpServerHostAddress HttpServerPassword HttpServerPortNumber'
	poolDictionaries: ''
	category: 'Wisconsin-Xrfb'!

!XrfbServerMaker commentStamp: 'strick 1/17/2006 01:11' prior: 0!
RFBServerMaker is the squeak client object that makes HTTP requests to the VncServer.py (currently an HTTP server written in Python), which allocates RFB servers for the sake of VDesktopTablet.

The four services available:

  * rpcEcho: aString        -- just for testing

  * rpcLaunchServerForDocumentUrl: aUrlString objectId: anIdString   
							-- request launching a new server (or connecting to existing one)

  * rpcListServers             -- status display

  * rpcShutdownAllServers       -- shut down everything

Configure the location of the server with these hardcoded methods, or define them to get from somewhere else:

  * httpServerHostAddress       -- answers the host address, as a string

  * httpServerPortNumber      -- answers the port number, as an Integer

Internally, requests are made with a HTTP GET command, with one verb '/echo', '/launch', '/list', or '/shutdown', and any arguments are in the query portion of the URL.
Results are in trivial XML, with either #answer tags or #error tags at the second level, e.g.
     '<results> <answer>42</answer> </results'
or
	'<failure> <error>Server cannot fork another process</error> </failure>'
!

!XrfbServerMaker methodsFor: 'as yet unclassified' stamp: 'strick 2/11/2006 03:56'!
doSomething: aVerb


	| request reply answers infos errors text |

	request := '/', aVerb.

	reply := self httpGetWithCommand: request.

	[
		answers := self getDataFromXml: reply withTag: #answer.
		infos := self getDataFromXml: reply withTag: #info.
		errors := self getDataFromXml: reply withTag: #error.
	] on: XrfbHttpReplyException do: [ :ex |
		errors := { ex messageText }
	].

	text := 'ANSWERS: ', answers asString, '
INFOS: ', infos asString, '
ERRORS: ', errors asString.

	text := ''.
	answers ifNotNil: [ answers do: [ :x | text := text, x asString, String cr ] ].
	infos ifNotNil: [ infos do: [ :x | text := text, '-- ', x asString, String cr ] ].
	errors ifNotNil: [ errors do: [ :x | text := text, '***ERROR*** ', x asString, String cr ] ].

	( text = '' ) ifTrue: [ text = 'OKAY.' ].
 
	^ text.
! !

!XrfbServerMaker methodsFor: 'as yet unclassified' stamp: 'strick 1/12/2006 01:02'!
getAnswersFromXml: xml
	
	| errorList answerList |

	"first, look for any #error tags"
	errorList := self getDataFromXml: xml withTag: #error.

	"if there are any, report them as error"
	(errorList size > 0) ifTrue: [
		self error:
			(errorList inject: 'request failed' into: [ :z :e | z, ' : ', e ]) 
	].

	"otherwise, look for answers"
	answerList := self getDataFromXml: xml withTag: #answer.

	"should always be at least one"
	(answerList size < 1) ifTrue: [
		self error: 'request failed: no answers'
	].

	"return the list of answers.  (if you expect only one, take first)"
	^ answerList
! !

!XrfbServerMaker methodsFor: 'as yet unclassified' stamp: 'strick 2/11/2006 02:49'!
getDataFromXml: someXml withTag: aTag

	| z document | 

	z := OrderedCollection new. 

	[
		document := XMLDOMParser
					parseDocumentFrom: 
						(ReadStream on: someXml).
	] on: SAXException do: [ :ex |
		XrfbHttpReplyException new signal: 
				'An error occurred while trying to contact the Xrfb Desktop Server.
------------------------------------------
Most likely, either the Xrfb server is not running,
it is not reachable due to a firewall,
or the Host, Port, or Password is not configured correctly.
(Use the menu "Tools" >> "Xrfb Desktops Control Panel" >> "Configure" )
-------------------------------------------
',  someXml.
		^ nil
	].

	document tagsNamed: aTag do: [:x | 
		z add: x characterData
	].

	^ z! !

!XrfbServerMaker methodsFor: 'as yet unclassified' stamp: 'strick 1/10/2006 20:44'!
httpGetWithAbsoluteUrl: anAbsoluteUrl

	"
	self new httpGetWithAbsoluteUrl: 'http://google.com/'
	"

	^ (Url absoluteFromText: anAbsoluteUrl) retrieveContents content! !

!XrfbServerMaker methodsFor: 'as yet unclassified' stamp: 'strick 2/6/2006 23:51'!
httpGetWithCommand: aCommand 

	"aCommand is of form  /verb?query=stuff

	self new httpGetWithCommand: '/echo?wish=
	"

	| absoluteUrl |
	aCommand first = $/ ifFalse: [
		self error: 'aCommand should begin with /'
	].

	absoluteUrl := 
		'http://', 
		self httpServerHostAddress, ':', 
		self httpServerPortNumber asString, '/', 
		self httpServerPassword,
		 aCommand.

	^ self httpGetWithAbsoluteUrl: absoluteUrl
! !

!XrfbServerMaker methodsFor: 'as yet unclassified' stamp: 'hrs 4/30/2006 15:08'!
httpServerHostAddress

	^ HttpServerHostAddress ifNil: [ 'croquetlinux.doit.wisc.edu' ]! !

!XrfbServerMaker methodsFor: 'as yet unclassified' stamp: 'strick 2/11/2006 01:17'!
httpServerHostAddress: newAddress

	HttpServerHostAddress := newAddress! !

!XrfbServerMaker methodsFor: 'as yet unclassified' stamp: 'strick 2/11/2006 01:20'!
httpServerPassword

	^ HttpServerPassword ifNil: [ 'zzzzzz' ]! !

!XrfbServerMaker methodsFor: 'as yet unclassified' stamp: 'strick 2/11/2006 01:17'!
httpServerPassword: newPassword

	HttpServerPassword := newPassword

	! !

!XrfbServerMaker methodsFor: 'as yet unclassified' stamp: 'strick 2/11/2006 01:21'!
httpServerPortNumber

	^ HttpServerPortNumber ifNil: [ 5899 ]
! !

!XrfbServerMaker methodsFor: 'as yet unclassified' stamp: 'strick 2/11/2006 01:18'!
httpServerPortNumber: newPortNumber

	HttpServerPortNumber := newPortNumber! !

!XrfbServerMaker methodsFor: 'as yet unclassified' stamp: 'strick 2/10/2006 23:15'!
rpcCleanServers

	| request reply |

	request := '/clean'.

	reply := self httpGetWithCommand: request.

	^ self getAnswersFromXml: reply! !

!XrfbServerMaker methodsFor: 'as yet unclassified' stamp: 'strick 2/6/2006 23:28'!
rpcEcho: stuff

	"A service of the RfbServerServer, for testing upness "

	| request reply |

	"The /echo verb expects one query thing named 'what' "

	request := '/echo?what=', stuff encodeForHTTP.

	reply := self httpGetWithCommand: request.

	"expect only one answer, to take the first"

	^ (self getAnswersFromXml: reply) first! !

!XrfbServerMaker methodsFor: 'as yet unclassified' stamp: 'strick 2/6/2006 23:28'!
rpcLaunchServerForDocumentUrl: aDocumentUrl objectId: anId

	| request reply |

	request := '/launch?id=', anId encodeForHTTP, '&url=', aDocumentUrl encodeForHTTP.

	reply := self httpGetWithCommand: request.

	^ (self getAnswersFromXml: reply) first! !

!XrfbServerMaker methodsFor: 'as yet unclassified' stamp: 'strick 2/6/2006 23:28'!
rpcListServers

	| request reply |

	request := '/list'.

	reply := self httpGetWithCommand: request.

	^ self getAnswersFromXml: reply! !

!XrfbServerMaker methodsFor: 'as yet unclassified' stamp: 'strick 2/6/2006 23:28'!
rpcShutdownAllServers

	| request reply |

	request := '/shutdown'.

	reply := self httpGetWithCommand: request.

	self getAnswersFromXml: reply! !

TMessageRouter subclass: #WisconsinRouter
	instanceVariableNames: 'users'
	classVariableNames: 'Dispatcher'
	poolDictionaries: ''
	category: 'Wisconsin'!

!WisconsinRouter commentStamp: 'jcg 4/12/2006 14:56' prior: 0!
Instance Variables:
	users	- 	Dictionary<Symbol->WisconsinRouterUser>!

WisconsinRouter subclass: #WisconsinCacheRouter
	instanceVariableNames: 'uploaders bitCache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-Cache'!

!WisconsinCacheRouter commentStamp: '<historical>' prior: 0!
Instance Variables:
	"those who have notified of their willingness to upload the specified resource."
	uploaders	-	Dictionary<SHA hash->OrderedCollection<WisconsinCacheRouterClient>>!

!WisconsinCacheRouter class methodsFor: 'accessing' stamp: 'jcg 5/21/2006 15:06'!
defaultRouterID
	^ TObjectID readHexFrom: '691dbd2a025dff8865e51f772a15ece6'! !

!WisconsinCacheRouter class methodsFor: 'accessing' stamp: 'jcg 5/21/2006 15:07'!
defaultUsernamePassword
	^ {'global'. 'cache'}! !

!WisconsinCacheRouter methodsFor: 'private' stamp: 'jcg 8/4/2006 14:03'!
cache: resource to: sha
	bitCache cache: resource to: sha.
! !

!WisconsinCacheRouter methodsFor: 'private' stamp: 'jcg 8/4/2006 00:04'!
findResource: sha
	^ bitCache find: sha! !

!WisconsinCacheRouter methodsFor: 'initialize' stamp: 'jcg 8/4/2006 00:04'!
initialize
	super initialize.
	uploaders := Dictionary new.
	bitCache := TFileBitCache new.
	bitCache location: 'cache-global'! !

!WisconsinCacheRouter methodsFor: 'initialize' stamp: 'jcg 5/21/2006 16:47'!
initializeFacets
	"Initialize standard facets"
	| facetName selector facet |

	"We don't use the same facets as the superclass."
	"super initializeFacets."

	#(join leave notify upload request) do:[:symbol|
		facetName := (symbol,'Facet') asSymbol.
		selector := (symbol,':from:') asSymbol.
		facet := self addMessageFacet: selector.
		facets at: facetName put: facet.
	].
! !

!WisconsinCacheRouter methodsFor: 'actions' stamp: 'jcg 5/21/2006 17:03'!
join: data from: aClient
	"aClient wants to use the global cache"
	| requestFacet serveFacet responseFacet |
	requestFacet := data copyFrom: 1 to: 16.
	serveFacet := data copyFrom: 17 to: 32.
	responseFacet := data copyFrom: 33 to: 48.
	aClient requestFacet: requestFacet.
	aClient serveFacet: serveFacet.
	aClient outQueue nextPut: (TDatagram facet: responseFacet data: ByteArray new).
	self logMessage: 'JOIN: ', (self printClient: aClient).! !

!WisconsinCacheRouter methodsFor: 'server' stamp: 'jcg 5/21/2006 19:39'!
newMessageRouterClient
	^ WisconsinCacheRouterClient new! !

!WisconsinCacheRouter methodsFor: 'actions' stamp: 'jcg 5/31/2006 23:14'!
notify: data from: aClient
	| size sha col |
	size := data unsignedLongAt: 1 bigEndian: true.
	sha := (ByteString basicNew: size) replaceFrom: 1 to: size with: data startingAt: 5.

	(self findResource: sha) ifNotNil: [^ self "we have already cached the resource"].

	col := uploaders at: sha ifAbsentPut: [OrderedCollection new].
	col addLast: aClient.
	col size > 1 ifTrue: [^ self "we are already loading from someone else"].

	"Request the resource from the client."
	aClient outQueue nextPut: (TDatagram facet: aClient requestFacet data: data)
! !

!WisconsinCacheRouter methodsFor: 'actions' stamp: 'jcg 5/31/2006 23:14'!
request: data from: aClient
	"Send the requested resource to the client (or an empty ByteArray if the resource is not found)."
	| size sha resource |
	size := data unsignedLongAt: 1 bigEndian: true.
	sha := (ByteString basicNew: size) replaceFrom: 1 to: size with: data startingAt: 5.
	resource := self findResource: sha.
	resource ifNil: [resource := ByteArray new: 0].
	
	aClient outQueue nextPut: (TDatagram facet: aClient serveFacet data: data, resource).! !

!WisconsinCacheRouter methodsFor: 'actions' stamp: 'jcg 5/31/2006 23:14'!
upload: data from: aClient
	| size sha resource |
	size := data unsignedLongAt: 1 bigEndian: true.
	sha := (ByteString basicNew: size) replaceFrom: 1 to: size with: data startingAt: 5.
	resource := data copyFrom: 5+size to: data size.
	self cache: resource to: sha.
	uploaders removeKey: sha.  "If nothing is there, then it is right to kill the client."
! !

!WisconsinRouter class methodsFor: 'accessing' stamp: 'hrs 4/21/2006 18:12'!
dispatcher
	^Dispatcher! !

!WisconsinRouter class methodsFor: 'accessing' stamp: 'hrs 6/4/2006 20:20'!
logDirectory
	| fd |
	fd := FileDirectory default directoryNamed: 'router-logs'.
	fd assureExistence.
	^fd! !

!WisconsinRouter class methodsFor: 'running' stamp: 'hrs 4/18/2006 16:18'!
runRouters
	^self runRouters: WisconsinParticipant defaultRouterPort! !

!WisconsinRouter class methodsFor: 'running' stamp: 'hrs 4/18/2006 16:18'!
runRouters: port
	| serverName |
	serverName := UIManager default request: 
										'Enter user name for running interactivity server'.
	^self runRouters: port
		serverName: serverName
		serverPassword: (UIManager default requestPassword: 
										'Enter password for ', serverName storeString).! !

!WisconsinRouter class methodsFor: 'running' stamp: 'hrs 6/4/2006 20:20'!
runRouters: port serverName: serverName serverPassword: serverPassword
	| router |

	Dispatcher ifNotNil: [^nil].
	Dispatcher := TExampleDispatcher new.
	Dispatcher listenOn: port.
	Dispatcher autoCreate: false.

	router := WisconsinCacheRouter new.
	router autoStop: false.
	router log: (self logDirectory forceNewFileNamed: 'cache.log').
	router logMessage: 'Starting'.
	router addUser: (WisconsinRouterUser localCacheNamed: 'global' password: 'cache').
	Dispatcher addRouter: router id: WisconsinCacheRouter defaultRouterID.

	WisconsinParticipant worlds do: 
		[:ctrl |
		router := self new.
		router 
			autoStop: false;
			log: (self logDirectory forceNewFileNamed: ctrl name, '.log');
			logMessage: 'Starting';
			addGuest: 'guest' password: 'guest';
			addParticipant: 'howard' password: 'stearns';
			addParticipant: 'joshua' password: 'gargus';
			addParticipant: 'jack' password: 'keel';
			addParticipant: 'everyone' password: 'else';
			addServer: serverName password: serverPassword.
			Dispatcher addRouter: router id: ctrl islandID.
		].
	^NetNameResolver localAddressString
! !

!WisconsinRouter class methodsFor: 'running' stamp: 'jcg 4/13/2006 15:35'!
shutDownRouters
	Dispatcher ifNotNil:
		[Dispatcher destroy.
		Dispatcher := nil]! !

!WisconsinRouter methodsFor: 'users' stamp: 'jcg 4/12/2006 15:12'!
addGuest: name password: password
	self addUser: (WisconsinRouterUser guestNamed: name password: password)! !

!WisconsinRouter methodsFor: 'users' stamp: 'jcg 4/12/2006 15:12'!
addParticipant: name password: password
	self addUser: (WisconsinRouterUser participantNamed: name password: password)! !

!WisconsinRouter methodsFor: 'users' stamp: 'jcg 4/12/2006 15:11'!
addServer: name password: password
	self addUser: (WisconsinRouterUser serverNamed: name password: password)! !

!WisconsinRouter methodsFor: 'private' stamp: 'jcg 4/12/2006 15:11'!
addUser: user
	| userLoginFacet |
	userLoginFacet := TCryptoRandom arc4: user userNameHash key: user passwordHash.
	users at: user userNameHash put: user.
	facets at: userLoginFacet put: (self messageFacetNamed: #login:from:)! !

!WisconsinRouter methodsFor: 'actions' stamp: 'jcg 4/27/2006 20:55'!
beContentServer: data from: aClient
	"Mark aClient as a content server, e.g., a participant trusted to provide data such as textures"
	aClient serveContentFacet: (data copyFrom: 1 to: 16).
	self logMessage: (self printClient: aClient), ': new content server'.! !

!WisconsinRouter methodsFor: 'initialize' stamp: 'hrs 7/18/2006 14:16'!
destroy
	self logMessage: 'Shutdown'.
	log ifNotNil: [log close.].
	super destroy.! !

!WisconsinRouter methodsFor: 'initialize' stamp: 'jcg 4/12/2006 14:56'!
initialize
	super initialize.
	users := Dictionary new.! !

!WisconsinRouter methodsFor: 'initialize' stamp: 'hrs 6/3/2006 16:43'!
initializeFacets
	"Initialize standard facets"
	| facetName selector facet |
	super initializeFacets.
	#(requestContent beContentServer setRouterTime requestCache) do:[:symbol|
		facetName := (symbol,'Facet') asSymbol.
		selector := (symbol,':from:') asSymbol.
		facet := self addMessageFacet: selector.
		facets at: facetName put: facet.
	].
! !

!WisconsinRouter methodsFor: 'actions' stamp: 'hrs 5/6/2006 12:48'!
login: data from: aClient
	"Basically the same as TSimpleRouter, except that the client only receives the subset of facets that they are authorized for."
	"aClient wants to login, e.g., authenticate itself. Format:
		[ 1 .. 16] MD5 hash of user name
		[17 .. 32] RC4 encrypted session key
		[33 .. 48] RC4 encrypted listFacets id
	Once session key is established it will be used for both directions.
	"
	| userHash user passHash sessionKey listFacet cypher result |
	userHash := data copyFrom: 1 to: 16.
	user := users at: userHash ifAbsent: [^ self error: 'Unknown user with hash: ', userHash].
	passHash := user passwordHash.
	
	sessionKey := data copyFrom: 17 to: 32.
	listFacet := data copyFrom: 33 to: 48.

	"Decrypt session key and list facet"
	cypher := TARC4Cypher key: passHash.
	cypher process: sessionKey.
	cypher process: listFacet.
	aClient recvCypher: (TARC4Cypher key: sessionKey).
	aClient sendCypher: (TARC4Cypher key: sessionKey).

	"And list the facets for this client."
	result := user facetNames collect: [:fName | fName 
													ifNil: [TObjectID nilObjectID] 
													ifNotNil: [facets at: fName]].
	result := result injectFirstInto: [:res :fid | res, fid].
	aClient outQueue nextPut: (TDatagram facet: listFacet data: result).! !

!WisconsinRouter methodsFor: 'initialize' stamp: 'hrs 6/4/2006 20:41'!
logMessage: aString
	| mtime |
	"Like super, but with date and time. 
	(DateAndTime>>asString never really prints milliseconds, so let's not waste time here)."
	log ifNotNil: [
		mtime := DateAndTime now.
		log cr.
		mtime printYMDOn: log.
		log nextPut: $T.
		mtime printHMSOn: log.
		log
			nextPutAll: ' : ';
			nextPutAll: aString;
			flush
		].! !

!WisconsinRouter methodsFor: 'server' stamp: 'jcg 4/27/2006 20:56'!
newMessageRouterClient
	^WisconsinMessageRouterClient new! !

!WisconsinRouter methodsFor: 'actions' stamp: 'hrs 6/3/2006 19:32'!
requestCache: data from: aClient
	"aClient wants to cache (snapshot) the island to disk"
	| answerFacet answerData |
	answerFacet := data copyFrom: 1 to: 16.
	answerData := data copyFrom: 17 to: data size.
	aClient outQueue nextPut: (TDatagram facet: answerFacet data: answerData).! !

!WisconsinRouter methodsFor: 'actions' stamp: 'jcg 4/27/2006 21:27'!
requestContent: data from: aClient
	"aClient wants to receive some data (such as a texture) from a peer"
	| serverList any facet resID |
	"Get the response facet"
	facet := data copyFrom: 1 to: 16.
	resID := data copyFrom: 17 to: data size.
	aClient receiveContentFacet: facet.
	self logMessage: 'REQUEST CONTENT ', (self printClient: aClient), ' -- ', (self printHex: resID).
	"Find a server, e.g., a client with a serve content facet"
	serverList := clients select:[:each| each serveContentFacet notNil].
	"But exclude the client itself - since he asked for the sync he doesn't have it."
	serverList := serverList copyWithout: aClient.
	serverList isEmpty ifTrue:["no trusted servers"
		self logMessage: 'REQUEST CONTENT NO SERVERS FOR ', (self printClient: aClient).
		clients do:[:each| self logMessage: '		', (self printClient: each)].
		^aClient requestContentReply: ByteArray new from: nil
	].
	"choose a server at random for now"
	any := serverList atRandom.
	self logMessage: 'REQUEST CONTENT: ', (self printHex: resID), ' --> ', (self printClient: any).

	"and invoke the sync facet on the server"
	facet := any addMessageFacet: (MessageSend receiver: aClient selector: #requestContentReply:from:).
	any outQueue nextPut: (TDatagram facet: any serveContentFacet data: facet, resID).
! !

!WisconsinRouter methodsFor: 'actions' stamp: 'hrs 5/7/2006 11:26'!
setRouterTime: data from: aClient
	| time |
	"#doubleAt: is not platform-neutral"
	time := Float basicNew: 2.
	time basicAt: 1 put: (data unsignedLongAt: 1 bigEndian: true).
	time basicAt: 2 put: (data unsignedLongAt: 5 bigEndian: true).

	self timeStamp: time.! !

!TAvatarReplica methodsFor: '*Wisconsin-hacks' stamp: 'hrs 7/15/2006 14:48'!
copyCarrying
	| data | 		
	data :=  carrying ifNotNil: [
		"We can't have the carried objects pointing back to the avatar when we serialize them."
			self removeChild: carrying.
			TIslandCopier new export: carrying.
			].
	"We don't want #addToNewSpace:=>#carryingDrop to leave this stuff on the old island."
	carrying := nil.
	^data! !

!TAvatarReplica methodsFor: '*Wisconsin-hacks' stamp: 'hrs 5/14/2006 11:56'!
isCarryingA: aClass
	self carryingDo: [:obj | (obj isKindOf: aClass) ifTrue: [^true]].
	^false.! !

!TAvatarReplica methodsFor: '*Wisconsin-hacks' stamp: 'hrs 7/19/2006 12:03'!
restoreCarrying: newCarrying
	carrying ifNotNil: [self removeChild: carrying. carrying := nil.].
	newCarrying ifNotNil: [self addChild: (carrying := newCarrying)].
			! !

!TAvatarReplica methodsFor: '*Wisconsin-hacks' stamp: 'hrs 5/11/2006 20:18'!
serializeMaterial
	^self costume serializeMaterial.! !

TestCase subclass: #XrfbServerMakerTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-Xrfb'!

!XrfbServerMakerTests commentStamp: 'strick 1/17/2006 01:14' prior: 0!
SUnit Tests for RfbServerMaker.

PRINT IT:
	RfbServerMakerTests buildSuite run


PREREQUISITE:

    An VncServer.py (currently written in Python) must be running at the address returned by RfbServerMaker>>httpServerHostAddress and RfbServerMaker>>httpServerPortNumber.

!

!XrfbServerMakerTests methodsFor: 'as yet unclassified' stamp: 'strick 1/12/2006 19:09'!
testBogus

	"
	self new testBogus
	"

	
"	self should: [
		RfbServerMaker new httpGetWithPath: '/bogus'
	] raise: Exception.
"
"
	| gotError |
	gotError := false.
	[
		RfbServerMaker new httpGetWithPath: '/bogus'
	] on: Exception do: [
		gotError := true
	].

	self assert: gotError.
"

"*********** I don't know how to write this negativd test *************"


	^ #ok! !

!XrfbServerMakerTests methodsFor: 'as yet unclassified' stamp: 'strick 2/2/2006 23:36'!
testEcho

	"
	self new testEcho
	"

	| answer x |

	"The /echo verb should echo back the query stuff in some manner."

	x :=  'pb&j?=peanutButter+Jelly', (Character value: 1) asString, (Character value: 250) asString.

	answer := XrfbServerMaker new rpcEcho: x.

	self assert: ( x = answer ).
 
	^ #ok! !

!XrfbServerMakerTests methodsFor: 'as yet unclassified' stamp: 'strick 2/6/2006 23:30'!
testLaunch

	"
	self new testLaunch
	"

	| answer x |


	x :=  'http://www.google.com'.

	answer := XrfbServerMaker new rpcLaunchServerForDocumentUrl: x objectId: 'testId'.

	self assert: answer isAllDigits.
 
	^ #ok! !

!XrfbServerMakerTests methodsFor: 'as yet unclassified' stamp: 'strick 2/7/2006 16:39'!
testSetPassword

	self assert:
		'abcdefg' = (
			XrfbClient new
				setPassword: 'abc','defg';
				requestPassword: 'sample label for user'
		) 
! !

TMorphicForm subclass: #WisconsinMorphicForm
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-Media'!

!WisconsinMorphicForm methodsFor: 'as yet unclassified' stamp: 'hrs 5/16/2006 12:42'!
expandClass: aClassOrSymbol
	^(aClassOrSymbol isKindOf: Symbol) 
		ifTrue: [Smalltalk at: aClassOrSymbol]
		ifFalse: aClassOrSymbol! !

!WisconsinMorphicForm methodsFor: 'render' stamp: 'hrs 5/16/2006 15:30'!
liveUpdate
	| host |
	"Same as superclass (except as noted), but with receiver expanding symbols to classes."
	myFarRef ifNil:[^nil].
	MorphHosts ifNil:[MorphHosts := Dictionary new].
	host := MorphHosts at: myFarRef ifAbsent:[
		"Trigger creation of host"
		MorphHosts at: myFarRef put: nil.
		WorldState addDeferredUIMessage:(MessageSend
			receiver: (self expandClass: constructor receiver ) 
			selector: constructor selector
			arguments: constructor arguments, {worldExtent. myFarRef}).
		nil].
	host ifNotNil:[
		"This part is ours. It ensures that we trigger the right script."
		"I don't think we can do this within postImportFromIslandCopier:."
		myEventMap isEmpty ifTrue: [
			WorldState addDeferredUIMessage: (MessageSend
				receiver: host
				selector: #runScript:when: 
				arguments: {#onEvent2D:. {myFarRef. #morphicEvent2D}}
				)].
		"Update the world"
		WorldState addDeferredUIMessage: (MessageSend receiver: host selector: #update).
	].! !

!WisconsinMorphicForm methodsFor: 'islands' stamp: 'hrs 7/18/2006 13:31'!
postImportFromIslandCopier: ignore
	self island asFarRef: self.! !

!WisconsinMorphicForm methodsFor: 'islands' stamp: 'hrs 7/18/2006 13:32'!
prepareToExportOnIslandCopier: exporter
	super prepareToExportOnIslandCopier: exporter.
	self flag: #FIXME. "This is not adequate. On unpickling, the new object isn't hooked up.
	It is not clear how/if it should be."
	self myEventMap: IdentityDictionary new.
! !

TWindowButtons subclass: #WisconsinButtons
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-UI'!

!WisconsinButtons methodsFor: 'accessing' stamp: 'hrs 7/23/2006 16:55'!
initializeWithFrame: frame extent: ext

	| tframe tframe2 |

"----------------------- goto button -----------------"
	tframe := TButton createNewWithFileName: (FileDirectory pathFromURI: 'Content/Widgets/arrow.ASE') scale: 1.0.
	gotoButton := TButton new initializeWithFrame: tframe.
	gotoButton target: frame action: #gotoFrame:.

"----------------------- kill button ------------------"
	tframe := TButton createNewWithFileName: (FileDirectory pathFromURI: 'Content/Widgets/cross.ASE') scale: 0.5.
	killButton := TButton new initializeWithFrame: tframe.
	killButton rotationAroundZ: 45.0.
	killButton target: frame action: #cut:.

"---------------------- open close button ---------------"
	tframe := TButton createNewWithFileName: (FileDirectory pathFromURI: 'Content/Widgets/cross.ASE') scale: 0.5.
	tframe2 :=  TButton createNewWithFileName: (FileDirectory pathFromURI: 'Content/Widgets/minus.ASE') scale: 0.5.
	openButton := TButton new initializeSwitchWithFrame: tframe
		frame2: tframe2.
	openButton target: frame action:#openContents.
	openButton target2: frame action2:#closeContents.

"------------------------ grab button --------------------"
	tframe := TButton createNewWithFileName: (FileDirectory pathFromURI: 'Content/Widgets/HandOpen.ASE') scale: 0.6.
	tframe2 := TButton createNewWithFileName: (FileDirectory pathFromURI: 'Content/Widgets/HandClosed.ASE') scale: 0.6.
	grabButton := TButton new initializeSwitchWithFrame: tframe frame2:tframe2.
	grabButton target: frame action: #grabFrame:.
	grabButton target2: frame action2: #releaseFrame:. 
	grabButton rotationAroundZ: 180.0.

"--------------------- camera button -----------------------"
"	tframe := TButton createNewWithFileName: (FileDirectory pathFromURI: 'Content/Widgets/camera.ASE') scale: 0.6.
	cameraButton := TButton new initializeWithFrame:tframe.
	cameraButton target: frame action: #snapshotWindow:.
"	"we need a dummy TButton here, because things refer to it."
	cameraButton := TButton new initializeWithFrame: TGroup new. 

	extent := ext.
	self addChild: grabButton.
	self addChild: gotoButton.
	self addChild: killButton.
	self addChild: openButton.
	self addChild: cameraButton.
	self showOpenButton.  "Match the actual default state of frame."
	self extent: extent.
	^self
! !

!WisconsinButtons methodsFor: 'accessing' stamp: 'hrs 7/23/2006 16:56'!
initializeWithWindow: win extent: ext
	^self initializeWithFrame: win extent: ext.
! !

TMessageRouterClient subclass: #WisconsinMessageRouterClient
	instanceVariableNames: 'serveContentFacet receiveContentFacet'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin'!

!WisconsinMessageRouterClient methodsFor: 'accessing' stamp: 'jcg 4/27/2006 21:25'!
receiveContentFacet
	^ receiveContentFacet! !

!WisconsinMessageRouterClient methodsFor: 'accessing' stamp: 'jcg 4/27/2006 21:25'!
receiveContentFacet: fid
	receiveContentFacet := fid! !

!WisconsinMessageRouterClient methodsFor: 'actions' stamp: 'jcg 4/27/2006 21:29'!
requestContentReply: data from: aClient
	"Reply with content data"
	router logMessage: 'REQUEST CONTENT: ', (router printClient: self), '  <-- ', data size asStringWithCommas,' bytes'.
	self outQueue nextPut: (TDatagram facet: receiveContentFacet data: data).
	receiveContentFacet := nil.! !

!WisconsinMessageRouterClient methodsFor: 'accessing' stamp: 'jcg 4/27/2006 20:34'!
serveContentFacet
	^ serveContentFacet! !

!WisconsinMessageRouterClient methodsFor: 'accessing' stamp: 'jcg 4/27/2006 20:34'!
serveContentFacet: fid
	serveContentFacet := fid! !

TeaBackingMorph subclass: #WisconsinNavMorph
	instanceVariableNames: 'counterClockwise forward clockwise left back right counterClockwise2 forward2 clockwise2 left2 back2 right2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-UI'!

!WisconsinNavMorph commentStamp: 'hrs 4/21/2006 13:36' prior: 0!
With special thanks to CITRIS and Orion Elenzil.
The idea for this kind of navigation, and the png's, are stolen from them.!

!WisconsinNavMorph methodsFor: 'initialize' stamp: 'hrs 4/25/2006 10:03'!
addButton: name center: center size: n action: aMessageName
	| m |
	m := (WisconsinNavButton withForm: (Form fromFileNamed: (FileDirectory fullPathForURI: 'Content/Textures/', name))).
	m extent: n@n.
	m center: center.
	m action: aMessageName.
	self addMorph: m.
	^m! !

!WisconsinNavMorph methodsFor: 'initialize' stamp: 'hrs 4/21/2006 15:56'!
initialize
	| n b delta |
	n := 30.
	super initialize.
	self color: Color transparent.
	self extent: (5*n) @ (3.5*n).   "3 x 2 grid + n/2@n/2 on each side"
	delta := 1.5*n. "Edges are n/2 appar. Centers are 1.5*n apart."
	b := self addButton: 'turn ccw.png' center: n@n size: n action: #rotateLeft.
	b := self addButton: 'move forward.png' center: b center + (delta@0) size: n action: #forward.
	b := self addButton: 'turn cw.png' center: b center + (delta@0) size: n action: #rotateRight.
	b := self addButton: 'move right.png' center: b center + (0@delta) size: n action: #right.
	b := self addButton: 'move back.png' center: b center - (delta@0) size: n action: #back.
	b := self addButton: 'move left.png' center: b center - (delta@0) size: n action: #left.
	
	
	
	
! !

!WisconsinNavMorph methodsFor: 'as yet unclassified' stamp: 'jcg 4/28/2006 11:55'!
snapToEdgeIfAppropriate
	self position: self owner bottomRight - self extent. ! !

TForm subclass: #TMovieTargetForm
	instanceVariableNames: 'codec dirty'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-Movie-Decoding'!

!TMovieTargetForm commentStamp: '<historical>' prior: 0!
A TMovieTargetForm is a TForm that movie video is decoded into.  When it is about to be bound, it notifies its codec, which can choose to decode a frame or not.  In this way, we don't bother decoding video frames that aren't rendered.

'dirty'	- 	general-purpose flag meaning that the OGLTextureHandle must be recreated!

!TMovieTargetForm methodsFor: 'initialize' stamp: 'jcg 7/28/2006 15:03'!
codec: aCodecOrNil
	codec := aCodecOrNil.
	dirty := true.! !

!TMovieTargetForm methodsFor: 'initialize' stamp: 'jcg 7/28/2006 15:03'!
initialize
	super initialize.
	dirty := false.! !

!TMovieTargetForm methodsFor: 'usage' stamp: 'jcg 7/28/2006 15:04'!
prepareForBinding: texManager
	"Let the codec do something if it wants."
	dirty ifTrue: [texManager deleteTexture: self].
	codec ifNotNil: [codec frameAboutToRender]! !

!TTerrainQuadTree methodsFor: '*Wisconsin-hacks' stamp: 'hrs 4/23/2006 10:30'!
contents
	^frameChildren first! !

CroquetParticipantWithMenu subclass: #WisconsinParticipant
	instanceVariableNames: 'entry address port nav'
	classVariableNames: 'OldWindowButtonsClass RouterAddress RouterPort'
	poolDictionaries: ''
	category: 'Wisconsin-UI'!

!WisconsinParticipant class methodsFor: 'accessing' stamp: 'hrs 6/2/2006 13:47'!
defaultRouterAddress
	^ RouterAddress ifNil: [
		WisconsinRouter dispatcher 
			ifNotNil: [NetNameResolver localAddressString] 
			ifNil: ['atsosxprod.doit.wisc.edu']
		]! !

!WisconsinParticipant class methodsFor: 'accessing' stamp: 'jcg 8/19/2006 21:17'!
defaultRouterAddress: addressString
	RouterAddress := addressString! !

!WisconsinParticipant class methodsFor: 'accessing' stamp: 'hrs 4/18/2006 16:39'!
defaultRouterPort
	^ RouterPort ifNil: [5910]! !

!WisconsinParticipant class methodsFor: 'parts bin' stamp: 'jcg 4/12/2006 15:55'!
descriptionForPartsBin
	^ self partName:	'Wisconsin Demo'
		categories:		#('Croquet')
		documentation:	'Standard Wisconsin introduction to Croquet..'
		sampleImageForm: self defaultForm.! !

!WisconsinParticipant class methodsFor: 'accessing' stamp: 'hrs 6/3/2006 16:42'!
guestFacetNames
	"Answer the names of the facets available to guests: those able to view but not affect the replicated simulation."
	^ #(joinFacet 
		nil "sendFacet" 
		syncFacet 
		heartbeatFacet 
		nil "beServerFacet" 
		leaveFacet
		requestContentFacet
		beContentServerFacet
		nil "setRouterTimeFacet"
		requestCacheFacet)! !

!WisconsinParticipant class methodsFor: 'accessing' stamp: 'jcg 5/21/2006 17:38'!
localCacheFacetNames
	"Answer the names of the facets available to local caches when connecting to the global cache."
	^ #(joinFacet 
		leaveFacet
		requestFacet
		notifyFacet
		uploadFacet)! !

!WisconsinParticipant class methodsFor: 'accessing' stamp: 'hrs 6/3/2006 16:42'!
participantFacetNames
	"Answer the names of the facets available to participants: those able to both view and affect the replicated simulation."
	^ #(joinFacet 
		sendFacet 
		syncFacet 
		heartbeatFacet 
		nil "beServerFacet" 
		leaveFacet
		requestContentFacet
		beContentServerFacet
		nil "setRouterTimeFacet"
		requestCacheFacet)! !

!WisconsinParticipant class methodsFor: 'accessing' stamp: 'hrs 6/3/2006 16:43'!
serverFacetNames
	"Answer the names of the facets available to servers: those authorized to make a copy of a snapshot of the simulation and send it to a newcomer."
	^ #(joinFacet 
		sendFacet 
		syncFacet 
		heartbeatFacet 
		beServerFacet 
		leaveFacet
		requestContentFacet
		beContentServerFacet
		setRouterTimeFacet
		requestCacheFacet)! !

!WisconsinParticipant class methodsFor: 'accessing' stamp: 'jcg 8/19/2006 21:18'!
setDefaultRouterAddress
	| addr |
	addr := UIManager default request: 'Enter IP address of default router'.
	addr = '' ifTrue: [RouterAddress := nil] ifFalse: [RouterAddress := addr].! !

!WisconsinParticipant class methodsFor: 'accessing' stamp: 'hrs 4/24/2006 16:27'!
worlds
	^{UWIntroWorld. DungeonWorld. MarsWorld. SpreadSheetWorld. T3BodyWorld. UnderwaterWorld. 
		WisconsinWorld. CritiquetWorld. QuiltersWorld. ForensicsWorld. 
		WisconsinNextWorld1. WisconsinNextWorld2}
! !

!WisconsinParticipant methodsFor: 'zoom navigator' stamp: 'hrs 7/23/2006 11:51'!
addZoomNavigator
	"Mostly like superclass method, but not quite."
	dock := WisconsinZoomNavigatorMorph new.
	dock position: self bounds bottomLeft.
	dock fullBounds. "need the layout!!"
	dock width: self width.
	self addMorph: dock.
	dock mouseLeave: nil.
	dock addSnapshotRoot.
	dock addToolsRoot.
	dock addAvatarRoot.
	dock addTool: TPainter.
! !

!WisconsinParticipant methodsFor: 'destroying' stamp: 'hrs 7/23/2006 17:04'!
delete
	super delete.
	TWindowButtons := OldWindowButtonsClass.
	OldWindowButtonsClass := nil.! !

!WisconsinParticipant methodsFor: 'accessing' stamp: 'hrs 4/23/2006 11:49'!
entry
	^entry ifNil: [self entryWorld: WisconsinWorld. entry].

! !

!WisconsinParticipant methodsFor: 'accessing' stamp: 'hrs 4/23/2006 07:53'!
entryWorld: aClass
	self entry: (TPostcard new routerAddress: nil
	    						id: aClass islandID name: aClass name asString
	    						viewpointName: #mainEntry).! !

!WisconsinParticipant methodsFor: 'accessing' stamp: 'hrs 4/20/2006 09:34'!
entry: aPostcard
	entry := aPostcard! !

!WisconsinParticipant methodsFor: 'accessing' stamp: 'jcg 4/14/2006 15:36'!
harness
	^harness! !

!WisconsinParticipant methodsFor: 'tweak rendering' stamp: 'hrs 4/21/2006 10:11'!
initializeTweakWorld
	self initializeTweakWorld: #UWMenuWorld.! !

!WisconsinParticipant methodsFor: 'tweak rendering' stamp: 'hrs 4/23/2006 08:03'!
mouseMove: evt
	"Sometimes happens before we get initialized!!"
	harness ifNil: [^false].
	^super mouseMove: evt.! !

!WisconsinParticipant methodsFor: 'accessing' stamp: 'hrs 4/20/2006 11:45'!
routerAddress
	^ address ifNil: [address := self class defaultRouterAddress]! !

!WisconsinParticipant methodsFor: 'accessing' stamp: 'hrs 4/20/2006 11:45'!
routerAddress: anAddressString
	address := anAddressString! !

!WisconsinParticipant methodsFor: 'accessing' stamp: 'hrs 4/20/2006 11:46'!
routerPort
	^ port ifNil: [port := self class defaultRouterPort].! !

!WisconsinParticipant methodsFor: 'accessing' stamp: 'hrs 4/20/2006 11:47'!
routerPort: anInteger
	port := anInteger! !

!WisconsinParticipant methodsFor: 'initialization' stamp: 'hrs 7/23/2006 17:03'!
setup
	| uname |

	"Pretty, evil, no?"
	OldWindowButtonsClass ifNil: [OldWindowButtonsClass := TWindowButtons].
	TWindowButtons := WisconsinButtons.  "for everyone, as long as this application is open!!"

	harness := WisconsinHarness new.
	harness addOverlay: self.

	"CroquetParticipantWithMenu removed the dock, just as things were getting layed out!!"	
	self addMorph: dock.
	dock position: self position.

	nav := (WisconsinNavMorph new).
	self addMorph: nav.
	"This is also the method that is automatically used after e.g., toggleFullScreen."
	nav snapToEdgeIfAppropriate. 
	harness avatar actOnThirdPerson.

	uname := (UIManager default request: 'Enter user name'
								initialAnswer: 'everyone').
	harness setupUser: uname 
		password: (uname= 'everyone' ifTrue: ['else'] 
						ifFalse: [UIManager default requestPassword: 'Enter password'])
		entry: self entry
		address: self routerAddress
		port: self routerPort.! !

!WisconsinParticipant methodsFor: 'actions' stamp: 'hrs 4/21/2006 16:39'!
toggleNavButtons
	(submorphs includes: nav) ifTrue: [self removeMorph: nav]
		ifFalse: [self addMorph: nav]. ! !

!TSpace methodsFor: '*Wisconsin-hacks' stamp: 'hrs 7/14/2006 18:42'!
addChild: aTFrame byUser: anAvatar
	| transform |
	transform := anAvatar globalTransform copy.
	transform translation: (transform translation - (5 * (anAvatar lookAt))).
	aTFrame localTransform: transform.
	super addChild: aTFrame byUser: anAvatar.! !

SoundInputStream subclass: #SignallingSoundInputStream
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-Audio'!

!SignallingSoundInputStream methodsFor: 'private' stamp: 'hrs 7/26/2006 10:01'!
emitBuffer: buffer
	super emitBuffer: buffer.
	self synchronousSignal: #bufferAvailable.
! !

TContact subclass: #WisconsinContact
	instanceVariableNames: 'worldClass harness'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin'!

!WisconsinContact methodsFor: 'initialization' stamp: 'jcg 4/13/2006 16:24'!
address: hostAddress port: hostPort id: uid name: nameString worldClass: wClass harness: h
	super address: hostAddress port: hostPort id: uid name: nameString.
	worldClass := wClass.
	harness := h! !

!WisconsinContact methodsFor: 'action' stamp: 'jcg 4/27/2006 21:32'!
beContentServer
	controller beContentServer.
! !

!WisconsinContact methodsFor: 'action' stamp: 'jcg 4/14/2006 15:40'!
beServer
	controller beServer.
! !

!WisconsinContact methodsFor: 'accessing' stamp: 'jcg 4/14/2006 15:41'!
cacheDirectory
	| fd |
	fd := FileDirectory default directoryNamed: 'cache'.
	fd assureExistence.
	^fd! !

!WisconsinContact methodsFor: 'accessing' stamp: 'jcg 4/14/2006 15:42'!
fileName
	^worldClass name,'.c3d'.! !

!WisconsinContact methodsFor: 'action' stamp: 'hrs 4/23/2006 14:12'!
informUser: aString during: aBlock
	aBlock value! !

!WisconsinContact methodsFor: 'action' stamp: 'hrs 5/6/2006 16:55'!
loadCachedIsland
	| fileName file data island |
	"Decide whether we need to recreate the island" 
	true "self enableIslandCache" ifTrue:[
		fileName := self fileName.
		file := [self cacheDirectory readOnlyFileNamed: fileName] 
			on: FileDoesNotExistException 
			do:[:ex| ex return: nil].
		Transcript show: 'file=', file; cr.
		file ifNotNil:[
			"Load island from file"
			file binary.
			[data := file contents] ensure:[file close].
			island := [controller installFromCache: data] on: Error do:[:ex|
				(UIManager default 
					chooseFrom: #('Ignore' 'Debug') 
					title: 'Could not load ', fileName,':\' withCRs, ex description) = 2
						ifTrue:[Processor activeProcess debug: ex signalerContext 
									title: ex description  full: true].
				ex return: nil.
			].
			Transcript show: 'island=', island; cr.
			island ifNotNil:[^true.].
		].
	].
	Transcript show: 'returning false'; cr.
	^false.
! !

!WisconsinContact methodsFor: 'action' stamp: 'jcg 4/14/2006 15:49'!
loadCachedOrCreateNewIsland
	| island  |
	self loadCachedIsland ifTrue: [^self].
	island := controller newIsland.
	island future id: id name: name.
	island future new: worldClass.
! !

!WisconsinContact methodsFor: 'action' stamp: 'jcg 4/13/2006 16:39'!
login
	| p |
	p := controller login: harness userName password: harness password.
	p wait.
! !

!WisconsinContact methodsFor: 'action' stamp: 'jcg 8/13/2006 02:52'!
newController
	controller := WisconsinController new.
	controller ocean: (TOceanProxy forHarness: harness)! !

!WisconsinContact methodsFor: 'action' stamp: 'hrs 6/26/2006 11:40'!
setupContact
	| p  |
	controller ifNotNil:[ ^ self ].
	self newController.
	controller connectTo: address port: port sessionID: id.

	self login.
	p := controller join. 	"request messages"
	p wait.

	WisconsinRouter dispatcher ifNotNilDo: [:dispatcher |
		dispatcher routers at: id ifPresent: [:router | controller backDoor: router].
		].

	self flag: #FIXME. "There's a problem here. What if two controllers are both approximately the 'first' 
	to reach a router that has no servers on it? Both will get nil from #sync. Both will create state, and
	both will be servers using the state they create. That's probably ok if both recreate from scratch by
	making a new instance of worldClass. But it is not so good if one uses a different cached .c3d file!!"

	self informUser: 'Synchronizing world.' during: [
		p := controller sync. 	"request replicated state"
		p wait.
		p result ifNil: [self loadCachedOrCreateNewIsland] ifNotNil: [controller install: p result].
		].

	self 
		beServer;
		beContentServer;
		startHeartbeat.
! !

!WisconsinContact methodsFor: 'action' stamp: 'jcg 4/14/2006 15:58'!
startHeartbeat
	"You can specialize TContact to define other behaviors."
	controller heartbeat: 20. "set heartbeat rate"
! !

!WisconsinContact methodsFor: 'accessing' stamp: 'jcg 4/14/2006 16:07'!
worldClass

	^worldClass! !

!WisconsinContact methodsFor: 'accessing' stamp: 'jcg 4/14/2006 16:07'!
worldClass: class

	worldClass := class.! !

TRectangle subclass: #THappyWithMyMaterialRectangle
	instanceVariableNames: 'materialSet'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-Video-Hacks'!

!THappyWithMyMaterialRectangle commentStamp: '<historical>' prior: 0!
Once I get a material, I am so happy that I wouldn't trade it for anything in the world.  Not even if a TWindow tries to give me one when I am its contents.!

!THappyWithMyMaterialRectangle methodsFor: 'initialize' stamp: 'jcg 8/19/2006 10:01'!
initialize
	materialSet := false.
	super initialize! !

!THappyWithMyMaterialRectangle methodsFor: 'accessing' stamp: 'jcg 8/19/2006 10:02'!
material: aTMaterial
	materialSet ifTrue: [^ self "I already have one, thanks"].
	materialSet := true.
	super material: aTMaterial.! !

TZoomNavigatorMorph subclass: #WisconsinZoomNavigatorMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-UI'!

!WisconsinZoomNavigatorMorph methodsFor: 'snapshot items' stamp: 'hrs 7/23/2006 11:53'!
addSnapshotRoot: thumb
	| image |
	"Almost exactly like our superclass method, but with a different label. Ugh."
	image := Form extent: thumb extent depth: 32.
	thumb displayOn: image.
	self drawName: 'Places' on: image.
	self addItem: (TSketchButtonMorph withForm: image)
		dragAction: nil
		clickAction: (MessageSend receiver: self selector: #addSnapshots).
! !

SketchMorph subclass: #WisconsinNavButton
	instanceVariableNames: 'action'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-UI'!

!WisconsinNavButton methodsFor: 'accessing' stamp: 'hrs 4/21/2006 15:54'!
action: aMessageName
	action := aMessageName! !

!WisconsinNavButton methodsFor: 'event handling' stamp: 'hrs 4/21/2006 15:14'!
handlesMouseDown: evt
	^true! !

!WisconsinNavButton methodsFor: 'event handling' stamp: 'hrs 4/21/2006 15:28'!
handlesMouseStillDown: evt
	^true! !

!WisconsinNavButton methodsFor: 'event handling' stamp: 'hrs 4/21/2006 15:16'!
mouseDown: evt
	| center |
	center := self center.
	self extent: 3/4*self extent.
	self center: center.! !

!WisconsinNavButton methodsFor: 'event handling' stamp: 'hrs 4/21/2006 15:19'!
mouseStillDownThreshold
	"Return the number of milliseconds after which mouseStillDown: should be sent"
	^20! !

!WisconsinNavButton methodsFor: 'event handling' stamp: 'hrs 4/27/2006 20:12'!
mouseStillDown: evt 
	self owner owner harness avatar perform: action.
	self owner owner harness avatar replica future fall.! !

!WisconsinNavButton methodsFor: 'event handling' stamp: 'hrs 4/21/2006 15:16'!
mouseUp: evt
	| center |
	center := self center.
	self extent: 4/3*self extent.
	self center: center.! !

TSimpleController subclass: #TBitCacheController
	instanceVariableNames: 'downloadPromise'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-Cache'!

!TBitCacheController commentStamp: 'jcg 5/21/2006 19:09' prior: 0!
Facets called by router:
#requestResource
#receiveResource
!

!TBitCacheController methodsFor: 'initialize' stamp: 'jcg 5/23/2006 00:01'!
clipboard: ignore
	"no-op"! !

!TBitCacheController methodsFor: 'private' stamp: 'jcg 5/21/2006 21:22'!
expectedFacets
	"These are the facets that we expect to receive from the server after we login."

	^ #(join leave request notify upload)! !

!TBitCacheController methodsFor: 'actions' stamp: 'jcg 5/21/2006 19:11'!
join
	"JOIN: Set up the necessary facets to talk to the global cache.  Mostly copied from the superclass implementation."
	| joinFacet respFacet p reqFacet recvFacet |
	"Create a promise so client code gets informed when join complete"
	joinPromise ifNotNil:[
		joinPromise onResolved: false.
		joinPromise := nil.
	].
	p := joinPromise := TPromise new.

	"Create a new request-upload facet (revoking the old one if necessary)"
	reqFacet := facets at: #requestResource ifAbsent: [nil].
	reqFacet ifNotNil: [self revokeMessageFacet: reqFacet].
	reqFacet := self addMessageFacet: #resourceRequested:from:.
	facets at: #requestResource put: reqFacet.

	"Create a new receive-resource facet (revoking the old one if necessary)"
	recvFacet := facets at: #receiveResource ifAbsent: [nil].
	recvFacet ifNotNil: [self revokeMessageFacet: recvFacet].
	recvFacet := self addMessageFacet: #receiveResource:from:.
	facets at: #receiveResource put: recvFacet.

	"Revoke prior response facet"
	respFacet := facets at: #joinComplete ifAbsent:[nil].
	respFacet ifNotNil:[self revokeMessageFacet: respFacet].
	respFacet := self addMessageFacet: #joinComplete:from:.
	facets at: #joinComplete put: respFacet.

	joinFacet := facets at: #join.
	connection outQueue nextPut: 
		(TDatagram facet: joinFacet data: reqFacet, recvFacet, respFacet).
	^p! !

!TBitCacheController methodsFor: 'actions' stamp: 'jcg 5/31/2006 23:12'!
notify: sha
	"Notify global cache that the a resource with the given SHA hash is available."
	| data notifyFacet |
	data := ByteArray new: 4 + sha size.
	data unsignedLongAt: 1 put: sha size bigEndian: true.
	data replaceFrom: 5 to: data size with: sha startingAt: 1.	
	notifyFacet := facets at: #notify.
	connection outQueue nextPut: (TDatagram facet: notifyFacet data: data)
! !

!TBitCacheController methodsFor: 'initialize' stamp: 'jcg 5/23/2006 00:01'!
openAL: ignore
	"no-op"! !

!TBitCacheController methodsFor: 'actions-facets' stamp: 'jcg 6/23/2006 19:50'!
receiveResource: data from: aConnection
	| size sha resource |
	size := data unsignedLongAt: 1 bigEndian: true.
	sha := (ByteString basicNew: size) replaceFrom: 1 to: size with: data startingAt: 5.
	resource := data copyFrom: 5+size to: data size.

	resource size == 0 ifTrue: [resource := nil].

	self critical: [
		downloadPromise ifNotNil: [downloadPromise onResolved: resource].
		downloadPromise := nil.
	].

	resource ifNotNil: [bitCache cache: resource to: sha].

! !

!TBitCacheController methodsFor: 'actions' stamp: 'jcg 5/31/2006 23:13'!
request: sha
	"Ask global cache for the resource with the given hash."
	| data requestFacet p |
	data := ByteArray new: 4 + sha size.
	data unsignedLongAt: 1 put: sha size bigEndian: true.
	data replaceFrom: 5 to: data size with: sha startingAt: 1.	
	requestFacet := facets at: #request.

	self critical: [
		downloadPromise ifNotNil: 
			[Transcript show: 'THERE IS ALREADY A DOWNLOAD PROMISE!!'; cr.
			downloadPromise onResolved: nil].
		p := downloadPromise := TPromise new.
	].

	connection outQueue nextPut: (TDatagram facet: requestFacet data: data).

	^ p
! !

!TBitCacheController methodsFor: 'actions-facets' stamp: 'jcg 6/23/2006 19:50'!
resourceRequested: data from: aConnection
	| size sha resource uploadFacet |
	size := data unsignedLongAt: 1 bigEndian: true.
	sha := (ByteString basicNew: size) replaceFrom: 1 to: size with: data startingAt: 5.

	resource := bitCache findLocally: sha.
	resource ifNil: 
		["We should only be asked for resources that we have notified the cache that we have."
		Transcript show: 'LOCAL CACHE ASKED FOR RESOURCE (',sha,') THAT IT DOES NOT HAVE'; cr.
		^ self].
	
	uploadFacet := facets at: #upload.
	connection outQueue nextPut: (TDatagram facet: uploadFacet data: data, resource)! !

TSimpleController subclass: #WisconsinSimpleController
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin'!

WisconsinSimpleController subclass: #WisconsinCacheController
	instanceVariableNames: 'downloadPromise'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-Cache'!

!WisconsinCacheController commentStamp: 'jcg 5/21/2006 19:09' prior: 0!
Facets called by router:
#requestResource
#receiveResource
!

!WisconsinCacheController methodsFor: 'initialize' stamp: 'jcg 5/23/2006 00:01'!
clipboard: ignore
	"no-op"! !

!WisconsinCacheController methodsFor: 'private' stamp: 'jcg 5/21/2006 21:22'!
expectedFacets
	"These are the facets that we expect to receive from the server after we login."

	^ #(join leave request notify upload)! !

!WisconsinCacheController methodsFor: 'initialize' stamp: 'hrs 7/19/2006 08:45'!
initialize
	super initialize.
	"This gives us an island that is not nil and is different from Island default.
	This way, when CroquetHarness>>renderWorld: goes around disabling TObjectID, 
	the cache controller can play, too, without error, and without breaking Island 
	default oid's."
	self island: TIsland new.! !

!WisconsinCacheController methodsFor: 'actions' stamp: 'jcg 5/21/2006 19:11'!
join
	"JOIN: Set up the necessary facets to talk to the global cache.  Mostly copied from the superclass implementation."
	| joinFacet respFacet p reqFacet recvFacet |
	"Create a promise so client code gets informed when join complete"
	joinPromise ifNotNil:[
		joinPromise onResolved: false.
		joinPromise := nil.
	].
	p := joinPromise := TPromise new.

	"Create a new request-upload facet (revoking the old one if necessary)"
	reqFacet := facets at: #requestResource ifAbsent: [nil].
	reqFacet ifNotNil: [self revokeMessageFacet: reqFacet].
	reqFacet := self addMessageFacet: #resourceRequested:from:.
	facets at: #requestResource put: reqFacet.

	"Create a new receive-resource facet (revoking the old one if necessary)"
	recvFacet := facets at: #receiveResource ifAbsent: [nil].
	recvFacet ifNotNil: [self revokeMessageFacet: recvFacet].
	recvFacet := self addMessageFacet: #receiveResource:from:.
	facets at: #receiveResource put: recvFacet.

	"Revoke prior response facet"
	respFacet := facets at: #joinComplete ifAbsent:[nil].
	respFacet ifNotNil:[self revokeMessageFacet: respFacet].
	respFacet := self addMessageFacet: #joinComplete:from:.
	facets at: #joinComplete put: respFacet.

	joinFacet := facets at: #join.
	connection outQueue nextPut: 
		(TDatagram facet: joinFacet data: reqFacet, recvFacet, respFacet).
	^p! !

!WisconsinCacheController methodsFor: 'actions' stamp: 'jcg 5/31/2006 23:12'!
notify: sha
	"Notify global cache that the a resource with the given SHA hash is available."
	| data notifyFacet |
	data := ByteArray new: 4 + sha size.
	data unsignedLongAt: 1 put: sha size bigEndian: true.
	data replaceFrom: 5 to: data size with: sha startingAt: 1.	
	notifyFacet := facets at: #notify.
	connection outQueue nextPut: (TDatagram facet: notifyFacet data: data)
! !

!WisconsinCacheController methodsFor: 'initialize' stamp: 'jcg 5/23/2006 00:01'!
openAL: ignore
	"no-op"! !

!WisconsinCacheController methodsFor: 'actions-facets' stamp: 'jcg 5/31/2006 23:13'!
receiveResource: data from: aConnection
	| size sha resource |
	size := data unsignedLongAt: 1 bigEndian: true.
	sha := (ByteString basicNew: size) replaceFrom: 1 to: size with: data startingAt: 5.
	resource := data copyFrom: 5+size to: data size.

	resource size == 0 ifTrue: [resource := nil].

	self critical: [
		downloadPromise ifNotNil: [downloadPromise onResolved: resource].
		downloadPromise := nil.
	].

	resource ifNotNil: [cacheManager cache: resource to: sha].

! !

!WisconsinCacheController methodsFor: 'actions' stamp: 'jcg 5/31/2006 23:13'!
request: sha
	"Ask global cache for the resource with the given hash."
	| data requestFacet p |
	data := ByteArray new: 4 + sha size.
	data unsignedLongAt: 1 put: sha size bigEndian: true.
	data replaceFrom: 5 to: data size with: sha startingAt: 1.	
	requestFacet := facets at: #request.

	self critical: [
		downloadPromise ifNotNil: 
			[Transcript show: 'THERE IS ALREADY A DOWNLOAD PROMISE!!'; cr.
			downloadPromise onResolved: nil].
		p := downloadPromise := TPromise new.
	].

	connection outQueue nextPut: (TDatagram facet: requestFacet data: data).

	^ p
! !

!WisconsinCacheController methodsFor: 'actions-facets' stamp: 'jcg 5/31/2006 23:13'!
resourceRequested: data from: aConnection
	| size sha resource uploadFacet |
	size := data unsignedLongAt: 1 bigEndian: true.
	sha := (ByteString basicNew: size) replaceFrom: 1 to: size with: data startingAt: 5.

	resource := cacheManager findLocally: sha.
	resource ifNil: 
		["We should only be asked for resources that we have notified the cache that we have."
		Transcript show: 'LOCAL CACHE ASKED FOR RESOURCE (',sha,') THAT IT DOES NOT HAVE'; cr.
		^ self].
	
	uploadFacet := facets at: #upload.
	connection outQueue nextPut: (TDatagram facet: uploadFacet data: data, resource)! !

WisconsinSimpleController subclass: #WisconsinController
	instanceVariableNames: 'restoringFromCache handleManager ocean'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin'!

!WisconsinController methodsFor: 'beServer' stamp: 'jcg 5/23/2006 22:22'!
beContentServer
	"If we don't have the appropriate facet from the router, then we must not be authorized to be a conent server."
	| serveFacet joinFacet |
	facets at: #beContentServer ifAbsent: [^ self]. 
	
	"This is basically the same as TRemoteController>>beServer"
	"Revoke the prior server facets"
	serveFacet := facets at: #serveContent ifAbsent: [nil].
	serveFacet ifNotNil: [self revokeMessageFacet: serveFacet].

	"Create a new #serveContent facet"
	serveFacet := self addMessageFacet: #serveContent:from:.
	facets at: #serveContent put: serveFacet.

	joinFacet := facets at: #beContentServer.
	connection outQueue nextPut: (TDatagram facet: joinFacet data: serveFacet).! !

!WisconsinController methodsFor: 'beServer' stamp: 'jcg 4/13/2006 22:31'!
beServer
	"If we don't have the appropriate facet from the router, then we must not be authorized to be a server."
	facets at: #beServer ifAbsent: [^ self]. 
	super beServer! !

!WisconsinController methodsFor: 'actions' stamp: 'hrs 6/8/2006 16:26'!
cacheTo: cacheDir archive: archiveDir

	"This is the external API, sent by our own harness.
	Sends a 'requestCache' message to the router, which will interleave it properly with
	other messages and send back a 'doCache' message to (only) us, upon which we'll do
	the work. As with #serve:from:, snapshotting must be done by the controller at a time
	when the controller is busy processing the message back from the router, and not 
	processing any other message. Else we get all sorts of cross-island references."

	| sendFacet answerFacet encoder |
	self logMessage: 'Requesting doCache.'.

	"Create a new unique facet for the router to use in in answering us."
	facets at: #doCache ifPresent: [:old | self revokeMessageFacet: old].
	answerFacet := self addMessageFacet: #doCache:from:.
	facets at: #doCache put: answerFacet.

	"Make our request."
	sendFacet := facets at: #requestCache.
	encoder := TMessageEncoder new.
	encoder nextPut: {cacheDir. archiveDir}.

	connection outQueue nextPut: (TDatagram facet: sendFacet 
										data: answerFacet, encoder contents).

	! !

!WisconsinController methodsFor: 'initialize' stamp: 'jcg 8/2/2006 00:17'!
clipboard
	^ ocean clipboard! !

!WisconsinController methodsFor: 'initialize' stamp: 'hrs 6/8/2006 16:34'!
destroy
	log ifNotNil: [log close]. 
	super destroy.! !

!WisconsinController methodsFor: 'actions' stamp: 'hrs 6/8/2006 16:27'!
doCache: data from: routerConnection

	"This is the message we get back from the router, initiated by actions in 
	#cacheTo:archive:.  Compare with #serve:from:"

	| args cacheDirectory archiveDirectory islandData islandName |
	self revokeMessageFacet: (facets at: #doCache).
	args := TMessageEncoder decode: data in: self island.
	cacheDirectory := args first.
	archiveDirectory := args second.
	islandName := island get: #name.
	self logMessage: 'Getting snapshot for cache.'.
	islandData := self snapshot.
	self logMessage: 'Snapshot for cache complete.'.
	self writeWorldData: islandData
		directory: cacheDirectory 
		name: islandName.
	self writeWorldData: islandData
		directory: archiveDirectory 
		name: islandName, (DateAndTime now asString copyReplaceAll: ':' with: '.').
	
! !

!WisconsinController methodsFor: 'private' stamp: 'hrs 6/3/2006 19:29'!
expectedFacets
	"These are the facets that we expect to receive from the server after we login (depending on our authorization level, we may not receive all of them)."

	^ #(join send sync heartbeat beServer leave requestContent 
			beContentServer setRouterTime requestCache)! !

!WisconsinController methodsFor: 'accessing' stamp: 'jcg 6/14/2006 08:46'!
externalMediaHandleManager
	^ handleManager! !

!WisconsinController methodsFor: 'initialize' stamp: 'jcg 6/14/2006 08:46'!
initialize
	super initialize.
	handleManager := ExternalMediaHandleManager new.! !

!WisconsinController methodsFor: 'initialize' stamp: 'hrs 5/6/2006 18:43'!
installFromCache: serializedIsland
	restoringFromCache := true.
	^[self install: serializedIsland] ensure: [restoringFromCache := false].
! !

!WisconsinController methodsFor: 'initialize' stamp: 'hrs 7/16/2006 11:39'!
install: data
	| time newIsland logMsg newTime nextMsg collectionRef |
	"This first part, up to 'Ug-lee', is a replacement for TRemoteController>>install:. 
	It is almost the same, but not quite." self flag: #FIXME. "This should be refactored."
	time := Time millisecondClockValue.
	newIsland := self restore: data.
	time := Time millisecondClockValue - time.
	log ifNotNil:[
		logMsg := 'STARTUP: ', data size asStringWithCommas, ' bytes ',
			'(', time printString, ' msecs) '.
		log cr; nextPutAll: logMsg; flush.
	].
	"Drop all messages before the islands time"
	newTime := newIsland send:[:obj| obj time].
	newIsland future time.  "ensure that there will be a message arriving from the network."
	[true] whileTrue:[
		nextMsg := networkQueue next.
		nextMsg time > newTime ifTrue:[
			"This is the first 'real' message arriving."
			newIsland send:[:obj| obj decodeScheduleAndExecute: nextMsg]. "execute it"
			^ island := newIsland. "install island"]. "done"
		"otherwise, silently skip the message"
	].
	"Ug-lee!!"
self critical: [
	collectionRef := island send: [:i | i lookup: #videoWindows ifAbsent: [nil]].
	collectionRef ifNotNilDo: 
		[:ref | ref send: [:collection | collection do: [:eachRef | (eachRef get: #isOpen) ifTrue: 			[eachRef send: [:each | each attemptCameraConnection]]]]].

	collectionRef := island send: [:i | i lookup: #streamingSpeakers ifAbsent: [nil]].
	collectionRef ifNotNilDo: 
		[:ref | ref send: [:collection | collection do: [:eachRef | (eachRef get: #isOpen) ifTrue: 			[eachRef send: [:each | each attemptAudioConnection]]]]].
]! !

!WisconsinController methodsFor: 'initialize' stamp: 'hrs 6/8/2006 16:15'!
logMessage: aString
	| mtime |
	"See WisconsinRouter>>logMessage:."
	log ifNotNil: [
		mtime := DateAndTime now.
		log cr.
		mtime printYMDOn: log.
		log nextPut: $T.
		mtime printHMSOn: log.
		log
			nextPutAll: ' : ';
			nextPutAll: aString;
			flush
		].! !

!WisconsinController methodsFor: 'initialize' stamp: 'jcg 8/1/2006 22:54'!
ocean
	^ ocean! !

!WisconsinController methodsFor: 'initialize' stamp: 'jcg 8/1/2006 22:54'!
ocean: aTOceanProxy
	ocean := aTOceanProxy! !

!WisconsinController methodsFor: 'actions' stamp: 'jcg 4/27/2006 22:49'!
requestContent: resID
	"REQUEST CONTENT: Request a copy of some resource from the router."
	| facet p |
	syncPromise ifNotNil:[^nil]. "sync in progress"
	p := syncPromise := TPromise new.
	"Revoke the prior syncFrom facet"
	facet := facets at: #requestContentFrom ifAbsent:[nil].
	facet ifNotNil:[self revokeMessageFacet: facet].
	"Create a new #requestContentFrom: facet"
	facet := self addMessageFacet: #requestContent:from:.
	facets at: #requestContentFrom put: facet.
	connection outQueue nextPut: (TDatagram facet: (facets at: #requestContent) data: facet, resID).
	^p! !

!WisconsinController methodsFor: 'actions' stamp: 'jcg 4/28/2006 01:04'!
requestContent: data from: aClient
	"Obtain data from connection."
	| facet |
	facet := facets at: #requestContentFrom.
	self revokeMessageFacet: facet.  "revoke requestContentFrom"
	syncPromise onResolved: (data size = 0 ifTrue:[nil] ifFalse:[data]).
	syncPromise := nil.! !

!WisconsinController methodsFor: 'accessing' stamp: 'jcg 8/4/2006 16:06'!
resourceSyncSelector
	"Answer the selector that should be used for the controller to sync a non-snapshot resource." 
	^ #requestContent:! !

!WisconsinController methodsFor: 'snapshot' stamp: 'hrs 5/6/2006 16:43'!
restore: data
	| newIsland |
	newIsland := super restore: data.
	restoringFromCache = true "not nil either" ifTrue: [self setRouterTime: (newIsland get: #time)].
	^newIsland.! !

!WisconsinController methodsFor: 'actions' stamp: 'jcg 4/28/2006 00:56'!
serveContent: data from: aClient
	"Just do it the same way."
	^ self serve: data from: aClient! !

!WisconsinController methodsFor: 'facet actions' stamp: 'hrs 6/8/2006 16:17'!
setRouterTime: aFloat
	| facet data |
	facet := facets at: #setRouterTime ifAbsent: [
		self logMessage: 'No authorization to set router time.'.
		^ self].
	data := ByteArray new: 8.
	"#doubleAt:put: is not platform-neutral"
	data unsignedLongAt: 1 put: (aFloat basicAt: 1) bigEndian: true.
	data unsignedLongAt: 5 put: (aFloat basicAt: 2) bigEndian: true.
	connection outQueue nextPut: (TDatagram facet: facet data: data).
	self logMessage: 'Request set router time to ', aFloat.

	! !

!WisconsinController methodsFor: 'initialize' stamp: 'jcg 8/2/2006 00:31'!
userID
	^ ocean userID! !

!WisconsinController methodsFor: 'actions' stamp: 'hrs 6/8/2006 16:16'!
writeWorldData: data directory: dir name: name
	| file |
	file := dir forceNewFileNamed: name, '.c3d'.
	[
		file binary.
		self logMessage: 'Caching ', file name.
		file nextPutAll: data
	] ensure:[file close].
	! !

!WisconsinSimpleController methodsFor: 'private' stamp: 'hrs 7/18/2006 14:19'!
expectedFacets
	"These are the facets that we expect to receive from the server after we login (depending on our authorization level, we may not receive all of them)."

	^ #(join send sync heartbeat beServer leave)! !

!WisconsinSimpleController methodsFor: 'actions' stamp: 'hrs 7/18/2006 14:20'!
listFacets: data from: aClient
	"Receive a list of invokable facets"
	| facet stream fid |
	connection sendCypher: (TARC4Cypher key: sessionKey).
	facet := facets at: #listFacets.
	self revokeMessageFacet: facet.  "revoke listFacets:from:"
	"Read facets"
	stream := data readStream.
	self expectedFacets do:[:facetName|
		fid := stream nextInto: TObjectID nilObjectID.
		fid isZero ifFalse:[facets at: facetName put: fid].
	].
	status := #ready. "to roll"
	loginPromise onResolved: true.
	loginPromise := nil.! !

TTexture subclass: #TMediaImage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-Media'!

!TMediaImage class methodsFor: 'instance creation' stamp: 'hrs 7/17/2006 20:38'!
connectContentsFrom: file intoContainer: myInstance
	| tform | 
	tform := TFormManager default addFile: file 
		 		mipmap: true shrinkFit: true extension: nil.
	^myInstance future asPictureFromForm: tform.
! !

!TMediaImage class methodsFor: 'accessing' stamp: 'hrs 5/11/2006 21:14'!
containerClass
	^TImageContainer! !

!TMediaImage methodsFor: 'initialize' stamp: 'jcg 7/8/2006 20:45'!
asPictureFromForm: aForm
	| tform size |
	size := aForm extent * 0.01.
	tform := TSharedMediaCache default 
									addForm: aForm 
									mipmap: true 
									shrinkFit: true 
									extension: nil.
	self initializeWithTForm: tform.
	self aspect: size y / size x asFloat. 
	self extent: size.
! !

!TMediaImage methodsFor: 'initialize' stamp: 'hrs 5/1/2006 16:58'!
initialize
	| mat |
	super initialize.
	mat := TMaterial new.
	mat ambientColor: #(1 1 1 0.99) asFloatArray.
	mat diffuseColor: #(1 1 1 0.99) asFloatArray.
	mat emissiveColor: #(1 1 1 0.99) asFloatArray.
	self material: mat.
! !

!TTexture methodsFor: '*Wisconsin-hacks' stamp: 'hrs 5/8/2006 21:09'!
asMaterialFor: aTFrame
	aTFrame texture: self.! !

!TTexture methodsFor: '*Wisconsin-hacks' stamp: 'hrs 5/8/2006 21:10'!
pasteOnto: target byUser: userAvtrRep
	target pasteMaterial: self.
! !

!TTexture methodsFor: '*Wisconsin-hacks' stamp: 'hrs 5/9/2006 13:32'!
serializeMaterial
	^self serializeYourself.! !

TMediaResource subclass: #TMovie
	instanceVariableNames: 'videoStreams audioStreams'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-Movie'!

!TMovie commentStamp: '<historical>' prior: 0!
This is an abstract base class for movie data (audio + video).  Like some other TMediaResources (such as TForms) an in-island TMovie may have a cache-ref to hi-res version stored outside the island.

The instance variables 'videoStreams' and 'audioStreams' store a specification of each available stream.  It is the responsibility of subclasses to populate these specifications.  Each stream is represented by an array (perhaps it would be desirable to create a TMovieStreamSpec, with subclasses for audio and video), where the values are interpreted as follows:

Video: Array of { durationInMilliseconds. framesPerSecond. nativeResolution }
Audio: Array of { durationInMilliseconds. sampleRateInHz. numberOfChannels "mono or stereo?" }

NOTE: We only use the first audio and video stream, since it allows us to simplify the API.  However, some movie types (MPEG for sure) support multiple A/V streams, so we record the information for completeness.!

!TMovie class methodsFor: 'accessing' stamp: 'jcg 7/26/2006 22:00'!
containerClass
	^ TMovieWindow! !

!TMovie methodsFor: 'accessing' stamp: 'jcg 7/21/2006 21:21'!
audioChannelCount
	audioStreams isEmpty ifTrue: [^ 0].
	^ audioStreams first third! !

!TMovie methodsFor: 'accessing' stamp: 'jcg 7/26/2006 19:13'!
audioSampleRate
	audioStreams isEmpty ifTrue: [^ -1].
	^ audioStreams first second! !

!TMovie methodsFor: 'accessing' stamp: 'jcg 7/26/2006 01:14'!
audioStreams
	"Answer a description of the audio streams in this movie (see class comment)."
	^ audioStreams! !

!TMovie methodsFor: 'accessing' stamp: 'jcg 7/22/2006 00:10'!
codecClass
	"Answer the codec class for this type of movie."
	self subclassResponsibility! !

!TMovie methodsFor: 'accessing' stamp: 'jcg 7/21/2006 21:25'!
duration
	"Answer the duration of the movie in milliseconds."
	self hasVideo ifTrue: [^ videoStreams first first].
	^ audioStreams first first! !

!TMovie methodsFor: 'testing' stamp: 'jcg 7/21/2006 21:23'!
hasAudio
	^ audioStreams size > 0! !

!TMovie methodsFor: 'testing' stamp: 'jcg 7/21/2006 21:23'!
hasVideo
	^ videoStreams size > 0! !

!TMovie methodsFor: 'accessing' stamp: 'jcg 7/30/2006 01:30'!
thumb
	| thumb |
	thumb := TPlaceholderMovie new.
	thumb audioStreams: audioStreams deepCopy videoStreams: videoStreams deepCopy.
	thumb cacheRef: self cacheRefToSelf.
	^ thumb! !

!TMovie methodsFor: 'accessing' stamp: 'jcg 7/28/2006 05:48'!
videoExtent
	^ videoStreams isEmpty 
						ifTrue: [1@1]
						ifFalse: [videoStreams first third]! !

!TMovie methodsFor: 'accessing' stamp: 'jcg 7/26/2006 01:14'!
videoStreams
	"Answer a description of the video streams in this movie (see class comment)."
	^ videoStreams! !

TMovie subclass: #TMPEGMovie
	instanceVariableNames: 'bytes cacheRefToSelf'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-Movie'!

!TMPEGMovie class methodsFor: 'instance creation' stamp: 'jcg 7/30/2006 01:20'!
newOn: island from: fileStream
	| bytes cachedMedia ref |
	bytes := fileStream contents.
	cachedMedia := TMPEGMovie withBytes: bytes.

	"Stash mpeg in the ocean for sharing, and ensure that the global cache has a copy of the bits."
	ref := cachedMedia cacheRefToSelf.
	TSharedMediaCache default substituteResource: cachedMedia cacheRef: ref.
	TSharedMediaCache default bitCache cache: bytes to: ref sha.

	^ cachedMedia thumb copyOntoIsland: island.! !

!TMPEGMovie class methodsFor: 'instance creation' stamp: 'jcg 7/22/2006 10:39'!
withBytes: byteArray
	^ super new bytes: byteArray! !

!TMPEGMovie methodsFor: 'accessing' stamp: 'jcg 7/22/2006 11:11'!
bytes
	^ bytes! !

!TMPEGMovie methodsFor: 'initialize' stamp: 'jcg 8/7/2006 18:45'!
bytes: byteArray
	| buf count rate extent channels |

	bytes ifNotNil: [self error: 'TMPEGMovie: already initialized'].
	bytes := byteArray.

	buf := MPEGFile openBuffer: byteArray.
	videoStreams := Array new: buf totalVideoStreams.
	1 to: videoStreams size do:
		[:i | 
		count := buf videoFrames: i-1.
		rate := buf videoFrameRate: i-1.
		extent := (buf videoFrameWidth: i-1) @ (buf videoFrameHeight: i-1).
		videoStreams at: i put: { count asFloat / rate * 1000. rate. extent }].

	audioStreams := Array new: buf totalAudioStreams.
	1 to: audioStreams size do:
		[:i |
		count := buf audioSamples: i-1.
		rate := buf audioSampleRate: i-1.
		channels := buf audioChannels: i-1.
		audioStreams at: i put: { count asFloat / rate * 1000. rate. channels }].

	buf finalize! !

!TMPEGMovie methodsFor: 'accessing' stamp: 'jcg 7/30/2006 01:26'!
cacheRefToSelf
	"Cache the result, since it can be slow to generate."
	cacheRefToSelf ifNil: 
		[cacheRefToSelf := TMPEGMovieCacheRef sha: (TSharedMediaCache generateSHA: bytes)].
	^ cacheRefToSelf copy! !

!TMPEGMovie methodsFor: 'accessing' stamp: 'jcg 7/22/2006 00:11'!
codecClass
	"Answer the codec class for this type of movie."
	^ TMPEGMovieCodec! !

TMovie subclass: #TPlaceholderMovie
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-Movie'!

!TPlaceholderMovie methodsFor: 'initialize' stamp: 'jcg 7/26/2006 21:57'!
audioStreams: aStreams videoStreams: vStreams
	audioStreams := aStreams.
	videoStreams := vStreams.! !

!TPlaceholderMovie methodsFor: 'accessing' stamp: 'jcg 7/22/2006 00:11'!
codecClass
	"Answer the codec class for this type of movie."
	^ TPlaceholderMovieCodec ! !

TTextureHackForm subclass: #TMorphicTexture
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-Media'!

!TMorphicTexture methodsFor: 'initialize' stamp: 'jcg 6/25/2006 17:23'!
constructor: constructor key: fakeSHA extent: worldExtent depth: anInteger
	| morphic |
	morphic := WisconsinMorphicForm new 
										initializeSHA: fakeSHA 
										form: (Form extent: 32@32 depth: anInteger)
										mipmap: false 
										shrinkFit: true.
	morphic bThumb: true.
	morphic constructor: (MessageSend
			receiver: (constructor receiver name) 
			selector: constructor selector
			arguments: constructor arguments).
	morphic worldExtent: worldExtent.

	"@@@@ The following is VERY important since later we'll need the TMorphic's farRef but we cannot create it in render, so forcing it here is a must @@@@"
	morphic island asFarRef: morphic.

	self initializeWithTForm: morphic.
	self targetExtent: worldExtent.
! !

!TMorphicTexture methodsFor: 'accessing' stamp: 'hrs 4/28/2006 20:07'!
sha
	self tform sha.! !

TMorphicTexture subclass: #TTextTexture
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-Media'!

!TTextTexture methodsFor: 'private' stamp: 'jcg 5/24/2006 22:59'!
justPastedOnto: pasteTarget byUser: userAvtrRep
	super justPastedOnto: pasteTarget byUser: userAvtrRep.
	self tform fakeSHA: (TObjectID new asInteger radix: 36).! !

!TTextTexture methodsFor: 'initialize' stamp: 'hrs 5/2/2006 16:12'!
setup
	super setup.
	self aspectFixed: false.
! !

!TTextTexture methodsFor: 'accessing' stamp: 'hrs 5/3/2006 14:46'!
text: aText
	"Update constructor so that a snapshot made at this point will cause the
	right morph to be created upon resurrection."
	self tform constructor arguments at: 1 put: aText
! !

!TTextTexture methodsFor: 'initialize' stamp: 'jcg 7/8/2006 20:45'!
text: aString extent: worldExtent depth: anInteger
	| hash |
	hash := TSharedMediaCache generateSHA: TObjectID new.
	self constructor: (MessageSend
						receiver: MorphicWorldHost
						selector: #makeText:extent:from:
						arguments: {aString})
		key: hash
		extent: worldExtent 
		depth: anInteger.! !

TMorphicTexture subclass: #TXrfbTexture
	instanceVariableNames: 'url'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-Xrfb'!

!TXrfbTexture methodsFor: 'events' stamp: 'jcg 8/2/2006 19:27'!
passEvent: anEvent type: evtType
	"An error is raised if 'ocean' is unavailable.  This implies that VNC can only be used with Wisconsin controllers for now.  I would rather make this explicit with an error than what I used to do: silently returning when the ocean is nil (leaving people to wonder why VNC isn't responding)." 
	self flag: #jcg.
	self ocean userID = anEvent userID ifTrue: [super passEvent: anEvent type: evtType].! !

!TXrfbTexture methodsFor: 'initialize' stamp: 'jcg 7/8/2006 20:45'!
url: aString extent: worldExtent depth: anInteger
	| hash |
	hash := TSharedMediaCache generateSHA: TObjectID new.
	url := aString.
	self constructor: (MessageSend
						receiver: MorphicWorldHost
						selector: #makeXrfb:objectID:extent:from:
						arguments: {aString. hash})
		key: hash
		extent: worldExtent 
		depth: anInteger.! !

!TContactPoint methodsFor: '*Wisconsin' stamp: 'hrs 7/15/2006 19:20'!
addContact: cc 
	contactsByName at: cc name ifAbsentPut:[ cc ].
	contactsByID at: cc id ifAbsentPut:[ cc ].! !

SmartSyntaxInterpreterPlugin subclass: #DShowVideoDecoderPlugin
	instanceVariableNames: 'sema sampleTime'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-Video-Win32'!

!DShowVideoDecoderPlugin class methodsFor: 'as yet unclassified' stamp: 'yo 8/13/2002 21:29'!
declareCVarsIn: cg

	super declareCVarsIn: cg.
	cg var: #sema type: #'int'.
	cg var: #sampleTime type: #'double'.
! !

!DShowVideoDecoderPlugin class methodsFor: 'as yet unclassified' stamp: 'yo 8/13/2002 23:03'!
headerFile

	^ '
#include "SampleGrabber.h"
#include "sqWin32DirectShow.h"
'
! !

!DShowVideoDecoderPlugin methodsFor: 'primitives' stamp: 'yo 8/13/2002 22:42'!
initialiseModule

	self export: true.

	sema := 0.
	sampleTime := 0.0.

	^ true
! !

!DShowVideoDecoderPlugin methodsFor: 'primitives' stamp: 'yo 8/14/2002 22:34'!
primDecoderCopyLastCapturedFrameInto: aForm

	| bits width height depth ret |
	self primitive: 'primDecoderCopyLastCapturedFrameInto'
		parameters: #(Oop).

	bits := interpreterProxy fetchPointer: 0 ofObject: aForm.
	width := interpreterProxy fetchInteger: 1 ofObject: aForm.
	height := interpreterProxy fetchInteger: 2 ofObject: aForm.
	depth := interpreterProxy fetchInteger: 3 ofObject: aForm.

	depth < 16 ifTrue: [interpreterProxy primitiveFail. ^ nil].

	ret := self cCode: 'convertToSqueakForm((unsigned char *)bits+4, width, height, depth)'.

	ret ifFalse: [
		interpreterProxy primitiveFail.
		^ nil.
	].
	^ ret asOop: SmallInteger
	! !

!DShowVideoDecoderPlugin methodsFor: 'primitives' stamp: 'yo 8/13/2002 10:57'!
primDecoderGetDecodeSize

	| result |
	self primitive: 'primDecoderGetDecodeSize'
		parameters: #().

	result := self cCode: 'DecoderDecodeSize()'.

	"result ifFalse: [interpreterProxy success: false. ^ nil]."

	interpreterProxy pop: 1.
	interpreterProxy push: (interpreterProxy positive32BitIntegerFor: result).
! !

!DShowVideoDecoderPlugin methodsFor: 'primitives' stamp: 'yo 8/13/2002 22:58'!
primDecoderGetLastError

	| ret |
	self primitive: 'primDecoderGetLastError'
		parameters: #().

	ret := self cCode: 'DecoderGetLastError()'.
	^ ret asOop: SmallInteger
! !

!DShowVideoDecoderPlugin methodsFor: 'primitives' stamp: 'yo 8/13/2002 22:59'!
primDecoderGetLastSampleTime

	self primitive: 'primDecoderGetLastSampleTime'
		parameters: #().
	
	^ sampleTime asOop: Float

! !

!DShowVideoDecoderPlugin methodsFor: 'primitives' stamp: 'yo 8/13/2002 22:59'!
primDecoderPause

	| ret |
	self primitive: 'primDecoderPause'
		parameters: #().

	ret := self cCode: 'DecoderPause()'.

	ret ifFalse: [
		interpreterProxy primitiveFail.
		^ nil.
	].
	^ ret asOop: SmallInteger
! !

!DShowVideoDecoderPlugin methodsFor: 'primitives' stamp: 'yo 8/13/2002 22:59'!
primDecoderRequestCapture

	| ret |
	self primitive: 'primDecoderRequestCapture'
		parameters: #().

	ret := self cCode: 'DecoderCaptureFrame()'.

	ret ifFalse: [
		interpreterProxy primitiveFail.
		^ nil.
	].
	^ ret asOop: SmallInteger
! !

!DShowVideoDecoderPlugin methodsFor: 'primitives' stamp: 'yo 8/13/2002 23:00'!
primDecoderRun

	| ret |
	self primitive: 'primDecoderRun'
		parameters: #().

	ret := self cCode: 'DecoderRun()'.

	ret ifFalse: [
		interpreterProxy primitiveFail.
		^ nil.
	].
	^ ret asOop: SmallInteger
! !

!DShowVideoDecoderPlugin methodsFor: 'primitives' stamp: 'yo 8/13/2002 23:00'!
primDecoderSetDecodeSizeWidth: w Height: h

	| ret |
	self primitive: 'primDecoderSetDecodeSize'
		parameters: #(SmallInteger SmallInteger).

	ret := self cCode: 'DecoderSetDecodeSize(w, h)'.

	ret ifFalse: [
		interpreterProxy primitiveFail.
		^ nil
	].
	^ ret asOop: SmallInteger
! !

!DShowVideoDecoderPlugin methodsFor: 'primitives' stamp: 'yo 8/14/2002 22:18'!
primDecoderSetRenderRectX: x y: y w: w h: h

	| ret |
	self primitive: 'primDecoderSetRenderRect'
		parameters: #(SmallInteger SmallInteger SmallInteger SmallInteger).

	ret := self cCode: 'SetRenderRect(x, y, w, h)'.

	ret ifFalse: [
		interpreterProxy primitiveFail.
		^ nil
	].
	^ ret asOop: SmallInteger
! !

!DShowVideoDecoderPlugin methodsFor: 'primitives' stamp: 'yo 8/13/2002 23:00'!
primDecoderShowWindow: showFlag

	| ret |
	self primitive: 'primDecoderShowWindow'
		parameters: #(Boolean).

	ret := self cCode: 'ShowRenderWindow(showFlag)'.

	ret ifFalse: [
		interpreterProxy primitiveFail.
		^ nil
	].
	^ ret asOop: SmallInteger
! !

!DShowVideoDecoderPlugin methodsFor: 'primitives' stamp: 'yo 8/13/2002 23:00'!
primDecoderStop

	| ret |
	self primitive: 'primDecoderStop'
		parameters: #().

	ret := self cCode: 'DecoderStop()'.

	ret ifFalse: [
		interpreterProxy primitiveFail.
		^ nil
	].
	^ ret asOop: SmallInteger
! !

!DShowVideoDecoderPlugin methodsFor: 'primitives' stamp: 'yo 8/14/2002 22:18'!
primInitializeDecoder

	| ret theSTWindow |
	self primitive: 'primInitializeDecoder'
		parameters: #().

	self var: 'theSTWindow' declareC: 'void *theSTWindow'.
	theSTWindow := self cCode: '(void*) interpreterProxy->ioLoadFunctionFrom("stWindow","")'.
 	theSTWindow = nil ifTrue: [
		interpreterProxy primitiveFail.
		^ nil.
	].

	ret := self cCode: 'SetRenderWindow(theSTWindow)'.
	ret ifFalse: [
		interpreterProxy primitiveFail.
		^ nil
	].

	ret := self cCode: 'InitializeDecoder()'.
	ret ifFalse: [
		interpreterProxy primitiveFail.
		^ nil
	].
	^ ret asOop: SmallInteger
! !

!DShowVideoDecoderPlugin methodsFor: 'primitives' stamp: 'yo 8/14/2002 22:22'!
primSetFrameSemaphore: semaIndex

	| ret |
	self primitive: 'primSetFrameSemaphore'
		parameters: #(SmallInteger).

	sema := semaIndex.

	ret := self cCode: 'SetCallBackFunction(signalFrame)'.
	ret ifFalse: [
		interpreterProxy primitiveFail.
		^ nil.
	].

	^ ret asOop: SmallInteger
! !

!DShowVideoDecoderPlugin methodsFor: 'primitives' stamp: 'yo 8/14/2002 22:24'!
primShutdownDecoder

	| ret |
	self primitive: 'primShutdownDecoder'
		parameters: #().

	ret := self cCode: 'dshowShutdown()'.

"	ret ifFalse: [
		interpreterProxy primitiveFail.
		^ nil
	].
"
	^ ret asOop: SmallInteger
! !

!DShowVideoDecoderPlugin methodsFor: 'primitives' stamp: 'yo 8/13/2002 11:03'!
shutdownModule

	self export: true.
	^self cCode: 'dshowShutdown()'! !

!DShowVideoDecoderPlugin methodsFor: 'primitives' stamp: 'yo 8/9/2002 19:43'!
signalFrame: currentSampleTime

	self export: true.
	self returnTypeC: 'void'.	
	self var: 'currentSampleTime' declareC: 'double currentSampleTime'. 

	sampleTime := currentSampleTime.
	
	sema > 0 ifTrue: [
		interpreterProxy signalSemaphoreWithIndex: sema.
	].
! !

IntroWorld subclass: #UWIntroWorld
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-Worlds'!

!UWIntroWorld methodsFor: 'as yet unclassified' stamp: 'jcg 4/27/2006 16:34'!
initialize
	| space portal | 
	space := super initialize.
	portal := self makePortal: 'Bucky.gif'.
	portal translation: 0@0@10.
	portal rotationAroundY: 180.
	portal contents postcardLink: (TPostcard new 
									routerAddress: nil
									id: WisconsinWorld islandID
									name: WisconsinWorld name asString
									viewpointName: #mainEntry).
	space addChild: portal.
	^space.! !

Error subclass: #XrfbHttpReplyException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-Xrfb'!

TextMorph subclass: #TextMorphWithSignalling
	instanceVariableNames: 'textTexture'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-Media'!

!TextMorphWithSignalling methodsFor: 'event handling' stamp: 'hrs 6/8/2006 13:55'!
keyStroke: evt
	super keyStroke: evt.

	"We DO need to replicate the new text value, because not every participant will have
	rendered the TTextTexture, so they will not all have instantiated us. Without replicating
	this message back to the island, some folks will get out of sync"

	"I'd like this to be 
		self signal: #text with: text.
	but I couldn't figure out how to get the receiver set up."

	self flag: #FIXME. "We should really have TTextTexture>>passEvent:type: do a determination of
	whether or not it was the originator of the event, and then indicate that here.
	The next line, below, would be conditionalized on that so that if there are 50 users rendering
	the same text, we don't have 50 future text: messages. Not that it breaks anything, it
	would just be nicer."

	self textTexture future text: text asString.! !

!TextMorphWithSignalling methodsFor: 'accessing' stamp: 'hrs 5/3/2006 14:22'!
textTexture
	^textTexture! !

!TextMorphWithSignalling methodsFor: 'accessing' stamp: 'hrs 5/3/2006 14:21'!
textTexture: aTTexture
	textTexture := aTTexture! !

!MorphicWorldHost class methodsFor: '*Wisconsin-hacks' stamp: 'hrs 5/3/2006 14:45'!
makeText: aString extent: worldExtent from: tform
	| host morph |
	morph := TextMorphWithSignalling new.
	morph contents: aString wrappedTo: worldExtent x.
	morph autoFit: true.
	morph textTexture: (tform get: #texture).
"	tform send: [:morphicForm | 
		morphicForm texture send: [:texture |
			texture inspect.
			morph inspect.
			texture  runScript: #text: when: {morph. #text}.
			].
		]."
	host := self new initializeWithMorph: morph thumb: tform extent: worldExtent.
	morph bounds: host world bounds.
	host redraw.
	TMorphicForm registerHost: host.! !

!MorphicWorldHost class methodsFor: '*Wisconsin-hacks' stamp: 'hrs 4/28/2006 16:34'!
makeXrfb: uri objectID: objectID extent: worldExtent from: tform
	| host morph world |
	host := self new initializeWithMorph: nil thumb: tform extent: worldExtent depth: 16.
	world := host world.
	morph := XrfbClient url: uri objectID: objectID..
	morph openInWorld: world.
	morph bounds: (Rectangle origin: -20@-20 corner: worldExtent + (20@40)).  "Yuck"

	host redraw.
	TMorphicForm registerHost: host.! !

RFBClient subclass: #XrfbClient
	instanceVariableNames: 'password'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-Xrfb'!

!XrfbClient class methodsFor: 'utility' stamp: 'hrs 4/25/2006 21:30'!
messageMorph: msg extent: pageExtent url: url
	^TextMorph new  
			beAllFont: ((TextStyle named: #BitstreamVeraSans) fontOfSize: 32);
			backgroundColor: Color yellow;
			crAction: (MessageSend receiver: self selector: #yourself);
			extent: pageExtent;
			contentsWrapped: msg asText;
			setBalloonText: 'This decribes the error received when trying to connect to the Xrfb Desktop Server';
			centered;
			yourself.! !

!XrfbClient class methodsFor: 'instance creation' stamp: 'hrs 4/28/2006 15:54'!
url: url objectID: objectId
	| pageExtent client hostAddrName hostAddr hostPort socket displayNumber msg  |

	"Always answers a Morph. You hope that it will be an XrfbClient, but it could be a 
	TextMorph with an error message."
	"example:
		(XrfbClient url: 'http://www.google.com' objectID: 'A999') openInWorld.  
	but be sure to first set things up with:
		XrfbControlPanelMorph new openInWorld
	"

	"strick TODO: a better way than hardwiring 800x600"
	pageExtent := 800@600.
	hostAddrName := XrfbServerMaker new httpServerHostAddress.

	Transcript show: 'XrfbClient url: ', url, ' objectId: ', objectId; cr.
	[
		displayNumber := 
		  XrfbServerMaker new 
			rpcLaunchServerForDocumentUrl: url objectId: objectId.
		displayNumber ifNil: [self error: 'Cannot reach ', hostAddrName, ':', 
									XrfbServerMaker new httpServerPortNumber].
	] on: Exception do: [ :ex | 
		"Could not talk to Xrfb Server -- bad host, port, password, or it is not running"
		^self messageMorph: url, '
==================================
',ex messageText 
				extent: pageExtent url: url.
	].

	Transcript show: 'displayNumber=', displayNumber; cr.
	[
		hostAddr := NetNameResolver addressForName: hostAddrName timeout: 8.
		hostPort := 5900 + displayNumber.

		Transcript show: hostAddrName, ':', hostPort; cr.

		socket := RFBClientSocket newTCP.
		socket connectTo: hostAddr port: hostPort.

		self depth: 16.

		client := XrfbClient new
			setPassword: XrfbServerMaker new httpServerPassword;
			yourself.
		"client target: teaWorld." "????"
		client beSticky.
	] on: Error do: [  :ex | 

			msg := url, '
==================================
An error occurred while trying to connect to the Xvnc desktop
at host ', hostAddr asString, ' port ', hostPort asString, '
---------------
', ex asString, '
---------------
', ex messageText.

		^self messageMorph: msg extent: pageExtent url: url.
	].


	client connectTo: socket.

	client isConnected ifFalse:[

		" a little cleanup "
		socket ifNotNil:[socket destroy].
		client delete.

		msg := url, '
==================================
RFBClient failed to connect.'.
		^self messageMorph: msg extent: pageExtent url: url.
	].

	"client visible: true."
	World activeHand keyboardFocus: nil.
	^client systemWindow.

	

! !

!XrfbClient methodsFor: 'connecting' stamp: 'hrs 4/26/2006 09:05'!
connectTo: aSocket
	"Open a new connection."

	self isConnected ifTrue: [^self inform: 'This viewer is already connected.'].
	(socket := aSocket) isNil ifTrue: [^self].
	process := [self clientRunLoop] forkAt: self clientPriority! !

!XrfbClient methodsFor: 'connecting' stamp: 'strick 2/15/2006 16:21'!
disconnect
	"Close the new connection.

	In our super, it uses #inform: and #confirm: -- we omit those, and just abort if connected.
	"

	self isConnected ifTrue: [
		self abort
	]
! !

!XrfbClient methodsFor: 'as yet unclassified' stamp: 'hrs 4/26/2006 15:18'!
requestPassword: anIgnoredLabel

	"Xrfb uses the same shared password for everything,
	so we don't have to ask the user for it here.

	The challenge-response encryption ALTERS the string
	it is passed, so we must create a new String instance here.

	Appending to an empty string seems to do it."

	^ '', password.

! !

!XrfbClient methodsFor: 'as yet unclassified' stamp: 'strick 2/7/2006 16:28'!
setPassword: aString

	password := aString! !

!XrfbClient methodsFor: 'as yet unclassified' stamp: 'hrs 4/26/2006 11:46'!
systemWindow
	(scrollPane := RFBScrollPane new)
		extent: ((self width min: 300 max: 100) @ (self height min: 150 max: 100));
		borderWidth: 0.
	scrollPane scroller addMorph: self.
	scrollPane
		setScrollDeltas;
		color: self color darker;
		model: self.
	window := (RFBSystemWindow labelled: WindowLabel) model: self.
	window addMorph: scrollPane frame: (0@0 corner: 1@1).
	^window.
! !

!TSpinner methodsFor: '*Wisconsin-hacks' stamp: 'hrs 5/9/2006 13:50'!
pasteMaterial: aMaterialOrTexture
	self contents pasteMaterial: aMaterialOrTexture.! !

!TSpinner methodsFor: '*Wisconsin-hacks' stamp: 'hrs 5/9/2006 13:35'!
serializeMaterial
	^self contents serializeMaterial.! !

!TRemoteController methodsFor: '*Wisconsin-GlobalCache' stamp: 'hrs 6/13/2006 13:29'!
requestContent: id
	^self sync: id.  "WisconsinController uses a different facet for this."! !

BaseWorld subclass: #WisconsinWorld
	instanceVariableNames: 'floorOffset floor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-Worlds'!

WisconsinWorld subclass: #CritiquetWorld
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-Worlds'!

!CritiquetWorld class methodsFor: 'accessing' stamp: 'hrs 4/24/2006 16:23'!
islandID
	^TObjectID readHexFrom: '1f2f349874e53ebe785f68158591e917'! !

!CritiquetWorld methodsFor: 'initialize' stamp: 'jcg 4/27/2006 15:57'!
initializeToys: space
	self initializeCommonPortals: space.! !

WisconsinWorld subclass: #ForensicsWorld
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-Worlds'!

!ForensicsWorld class methodsFor: 'as yet unclassified' stamp: 'hrs 4/24/2006 16:27'!
islandID
	^TObjectID readHexFrom: '0da60df9945553fad1000c12bfdd8890'! !

!ForensicsWorld methodsFor: 'initialize' stamp: 'jcg 4/27/2006 15:57'!
initializeToys: space
	self initializeCommonPortals: space.! !

!ForensicsWorld methodsFor: 'initialize' stamp: 'jcg 4/27/2006 15:37'!
terrainSeed
	^23456! !

WisconsinWorld subclass: #QuiltersWorld
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-Worlds'!

!QuiltersWorld class methodsFor: 'accessing' stamp: 'hrs 4/24/2006 16:23'!
islandID
	^TObjectID readHexFrom: '28db72f0d933e17716f707b88f430a21'! !

!QuiltersWorld methodsFor: 'initialize' stamp: 'jcg 4/27/2006 15:57'!
initializeToys: space
	self initializeCommonPortals: space.! !

!QuiltersWorld methodsFor: 'initialize' stamp: 'jcg 4/27/2006 15:38'!
terrainSeed
	^34567! !

WisconsinWorld subclass: #WisconsinNextWorld1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-Worlds'!

!WisconsinNextWorld1 class methodsFor: 'accessing' stamp: 'hrs 4/24/2006 16:24'!
islandID
	^TObjectID readHexFrom: '7b22795f7aadfa4602e7c0ce189eb594'! !

!WisconsinNextWorld1 methodsFor: 'initialize' stamp: 'jcg 4/27/2006 15:57'!
initializeToys: space
	self initializeCommonPortals: space.! !

!WisconsinNextWorld1 methodsFor: 'initialize' stamp: 'jcg 4/27/2006 15:38'!
terrainSeed
	^45678! !

WisconsinWorld subclass: #WisconsinNextWorld2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-Worlds'!

!WisconsinNextWorld2 class methodsFor: 'accessing' stamp: 'hrs 4/24/2006 16:24'!
islandID
	^TObjectID readHexFrom: '72c2977984222e044d173befca9f317f'! !

!WisconsinNextWorld2 methodsFor: 'initialize' stamp: 'jcg 4/27/2006 15:57'!
initializeToys: space
	self initializeCommonPortals: space.! !

!WisconsinNextWorld2 methodsFor: 'initialize' stamp: 'jcg 4/27/2006 15:38'!
terrainSeed
	^56789! !

!WisconsinWorld class methodsFor: 'as yet unclassified' stamp: 'hrs 4/23/2006 09:39'!
buildTerrain: terrain textureName: fileName uvScale: uvScale scale: scale space: space 
	| texture | 
	texture :=  TTexture
					new initializeWithFileName: fileName
					mipmap: true
					shrinkFit: false.
	texture uvScale: uvScale.
	terrain genGrid.
	terrain buildMeshWithTexture: texture.
	terrain boundsDepth: 2.
	terrain initBounds.
	terrain scale: scale.
	^TTerrainQuadTree new initializeWithSpace: space frame: terrain.
! !

!WisconsinWorld class methodsFor: 'accessing' stamp: 'hrs 4/23/2006 07:50'!
islandID
	^TObjectID readHexFrom: 'c2be09189969d56cc3073ec4d256cb6d'! !

!WisconsinWorld methodsFor: 'initialize' stamp: 'jcg 4/27/2006 16:34'!
initialize
	| space sky |

	Processor activeIsland id: self class islandID.
	space := TSpace new.
	space registerGlobal: #mainEntry.
	self makeLight: space.
	floorOffset :=  0.0.
	self initializeFloor: space.
	sky := TSkyBox new initializeWithFileName: 'GRS'.
	space addChild: sky.
	self initializeToys: space.
	sky step. "get going"
	^space.
! !

!WisconsinWorld methodsFor: 'initialize' stamp: 'jcg 4/27/2006 16:07'!
initializeCommonPortals: space
	self makeOnePortal: WisconsinWorld textureFileName: 'Bucky.gif' scale: 2 position: 0@0@-20 space: space.
! !

!WisconsinWorld methodsFor: 'initialize' stamp: 'jcg 4/27/2006 15:43'!
initializeFloor: space
	"self makeFloor: space fileName:'lawn.BMP'."
	self initializeTerrain: space.! !

!WisconsinWorld methodsFor: 'initialize' stamp: 'hrs 4/27/2006 21:21'!
initializeTerrain: space
	floor := self class buildTerrain: (TFractalTerrain  initializeSize: 32 
								smoothness: self terrainSmoothness
								heightScale: self terrainHeightScale
								randomSeed: self terrainSeed)
				textureName: self terrainTextureName
				uvScale: self terrainUVScale
				scale: 500
			 	space: space.
	floorOffset :=  (floor contents heightAt: 0@0).
	floor translation: 0@(-3 - floorOffset)@0.
	floor addRotationAroundY: 0.4. "Avoid travelling in seams that we fall through."
	^floor.! !

!WisconsinWorld methodsFor: 'initialize' stamp: 'hrs 4/27/2006 19:44'!
initializeToys: space
	self makeOnePortal: WisconsinNextWorld1 textureFileName: 'caust31.BMP' scale: 3 position: -25@0@-20 space: space.
	self makeOnePortal: ForensicsWorld textureFileName: 'graph128.bmp'     scale: 2 position: -15@0@-20 space: space.
	self makeOnePortal: UWIntroWorld textureFileName: 'GrnChplTwr.bmp'   scale: 2 position: -5@0@-20 space: space.
	self makeOnePortal: QuiltersWorld textureFileName: 'checker.png'        scale: 2 position: 5@0@-20 space: space.
	self makeOnePortal: CritiquetWorld textureFileName: 'default.bmp'      scale: 4 position: 15@0@-20 space: space.
	self makeOnePortal: WisconsinNextWorld2 textureFileName: 'floor.bmp' scale: 2 position: 25@0@-20 space: space.
! !

!WisconsinWorld methodsFor: 'initialize' stamp: 'hrs 5/1/2006 09:29'!
makeOnePortal: aClass textureFileName: aString scale: aNumber position: aVector space: space
	| portal |
	portal := self makePortal: aString.
	portal extent: portal extent * aNumber.
	portal contents postcardLink: (TPostcard new 
									routerAddress: nil
									id: aClass islandID
									name: aClass name asString
									viewpointName: #mainEntry).
	self position: portal at: aVector.
	portal addRotationAroundY: 0.5.
	space addChild: portal.
! !

!WisconsinWorld methodsFor: 'initialize' stamp: 'jcg 4/27/2006 16:22'!
position: anObject at: aTranslation
	floor ifNil: [^anObject translation: aTranslation].
	anObject translation: aTranslation x @ 
				((floor contents heightAt: aTranslation x @ aTranslation z) - floorOffset)@
				aTranslation z.
	
	! !

!WisconsinWorld methodsFor: 'initialize' stamp: 'hrs 4/23/2006 10:44'!
position: anObject on: aTerrain at: aTranslation
	anObject translation: aTranslation x @ 
				((aTerrain contents heightAt: aTranslation x @ aTranslation z) - floorOffset)@
				aTranslation z.
	
	! !

!WisconsinWorld methodsFor: 'initialize' stamp: 'jcg 4/27/2006 15:51'!
terrainHeightScale
	^0.3! !

!WisconsinWorld methodsFor: 'initialize' stamp: 'jcg 4/27/2006 15:36'!
terrainSeed
	^12345! !

!WisconsinWorld methodsFor: 'initialize' stamp: 'jcg 4/27/2006 15:51'!
terrainSmoothness
	^0.8! !

!WisconsinWorld methodsFor: 'initialize' stamp: 'jcg 4/27/2006 15:52'!
terrainTextureName
	^'lawn.BMP'! !

!WisconsinWorld methodsFor: 'initialize' stamp: 'jcg 4/27/2006 15:52'!
terrainUVScale
	^256@256! !

!TMaterial methodsFor: '*Wisconsin-hacks' stamp: 'hrs 5/8/2006 21:10'!
asMaterialFor: aTFrame
	aTFrame material: self.! !

!TMaterial methodsFor: '*Wisconsin-hacks' stamp: 'hrs 5/8/2006 21:06'!
pasteOnto: target byUser: userAvtrRep
	target pasteMaterial: self.
! !

!TMaterial methodsFor: '*Wisconsin-hacks' stamp: 'hrs 5/9/2006 13:34'!
serializeMaterial
	^self serializeYourself.! !

!TMaterial methodsFor: '*Wisconsin-hacks' stamp: 'hrs 5/9/2006 14:04'!
serializeYourself
	^TIslandCopier new export: self! !

CroquetHarnessWithMenu subclass: #WisconsinHarness
	instanceVariableNames: 'userName password hud meshFrameData videoWindowData clipboard handleManager'
	classVariableNames: 'DefaultURL'
	poolDictionaries: ''
	category: 'Wisconsin'!

!WisconsinHarness methodsFor: 'accessing' stamp: 'jcg 4/14/2006 15:30'!
addContact: contact
	(contactPoint ifNil: [contactPoint := TContactPoint new]) addContact: contact! !

!WisconsinHarness methodsFor: 'actions' stamp: 'hrs 5/6/2006 15:28'!
addPotentialLandmark
	"Make a landmark of our current space and position IFF we don't already have some
	landmark for this space.
	Typically sent to add original position, and whenever we have just opened a portal
	to a space that we have not yet visited. This algorithm ensures that we can get back
	if we do visit it."

	| newSpace newLandmark|
	newSpace := self activeSpace. 
	snapshots do: [:landmark | landmark space = newSpace ifTrue: [^landmark]].
	newLandmark := TSnapshot new space: newSpace 
						transform: (self avatar localTransform ifNil: [Matrix4x4 identity]).
	snapshots add: newLandmark.
	^newLandmark.! !

!WisconsinHarness methodsFor: 'actions' stamp: 'hrs 5/14/2006 13:07'!
addToAvatarOrSpace: newObj
	| farAv class |
	farAv := self avatar replica.
	newObj wait.
	class := newObj get: #class. 
	farAv send: [:av | 
				(av isCarryingA: class)
					ifTrue: [^self activeSpace future addChild: newObj 
												byUser: farAv]
					ifFalse: [newObj future nowCarried.
							^farAv future carrying: newObj
							].
				].! !

!WisconsinHarness methodsFor: 'accessing' stamp: 'hrs 5/1/2006 11:06'!
archiveDirectory
	| fd |
	fd := FileDirectory default directoryNamed: 'archive'.
	fd assureExistence.
	^fd! !

!WisconsinHarness methodsFor: 'accessing' stamp: 'jcg 5/5/2006 12:16'!
clipboard
	^ clipboard! !

!WisconsinHarness methodsFor: 'accessing' stamp: 'hrs 4/28/2006 20:59'!
defaultURL
	^DefaultURL ifNil: [DefaultURL := 'http://www.google.com' asUrl]! !

!WisconsinHarness methodsFor: 'accessing' stamp: 'hrs 4/28/2006 21:00'!
defaultURL: url
	DefaultURL := url! !

!WisconsinHarness methodsFor: 'event handling' stamp: 'hrs 5/2/2006 11:22'!
dropFile: aFile
	^self new: TMedia from: aFile.
	! !

!WisconsinHarness methodsFor: 'accessing' stamp: 'jcg 8/5/2006 12:02'!
handleManager
	^ handleManager! !

!WisconsinHarness methodsFor: 'accessing' stamp: 'hrs 4/23/2006 13:30'!
hud
	^hud! !

!WisconsinHarness methodsFor: 'accessing' stamp: 'hrs 4/23/2006 13:30'!
hud: aHUD
	hud := aHUD! !

!WisconsinHarness methodsFor: 'initialize' stamp: 'jcg 8/5/2006 12:01'!
initialize
	| seed |
	super initialize.

	"Make sure that there is entropy in the ocean."
  	seed := ByteArray new: 128.
  	TCryptoRandom gatherEntropy: seed.
  	Island default randomStream seedVector: seed.

	"We would prefer to not use a singleton here... see CroquetClipboard class comment."
	self flag: #jcg.
	clipboard := CroquetClipboard default.
	clipboard harness: self.

	handleManager := TransientHandleManager new.! !

!WisconsinHarness methodsFor: 'initialize' stamp: 'hrs 7/18/2006 21:31'!
initializeAvatar: snapshots
	avatar := TAvatarUserWisconsin new.
	avatar harness: self.
	avatar snapshots: snapshots.
	avatar loadAvatar: 'Content/Avatars/WhiteRabbit.mdl'.
! !

!WisconsinHarness methodsFor: 'event handling' stamp: 'hrs 5/17/2006 16:38'!
keyDown: anEvent
	"We sometimes get problems when we're in a transition to a different space."
	avatar safeTranslation. "for effect"
	super keyDown: anEvent.! !

!WisconsinHarness methodsFor: 'event handling' stamp: 'hrs 5/17/2006 16:01'!
keyStroke: anEvent
	"We sometimes get problems when we're in a transition to a different space."
	avatar safeTranslation. "for effect"
	super keyStroke: anEvent.! !

!WisconsinHarness methodsFor: 'event handling' stamp: 'hrs 5/17/2006 16:38'!
keyUp: anEvent
	"We sometimes get problems when we're in a transition to a different space."
	avatar safeTranslation. "for effect"
	super keyUp: anEvent.! !

!WisconsinHarness methodsFor: 'messages' stamp: 'hrs 6/8/2006 16:49'!
logAllWorlds
	islandsByName keysAndValuesDo: [:name :island |
		(island get: #controller) log: (self logDirectory forceNewFileNamed: name, '.log').
		].! !

!WisconsinHarness methodsFor: 'accessing' stamp: 'hrs 6/8/2006 16:41'!
logDirectory
	| fd |
	fd := FileDirectory default directoryNamed: 'controller-logs'.
	fd assureExistence.
	^fd! !

!WisconsinHarness methodsFor: 'actions' stamp: 'hrs 5/13/2006 20:50'!
makeAudioSource
	|   island speaker audioSource stream streamingSpeaker|
	island := self activeIsland.
	
	"Create speaker."
	stream := FileStream readOnlyFileNamed: 
							(FileDirectory default pathFromURI: 'Content/Widgets/speaker.ASE').
	speaker := TMediaMesh newOn: island from: stream.
	stream close.
	streamingSpeaker := TMediaStreamingSpeaker newOn: island from: speaker.

	"Connect speaker to audio source."
	audioSource := LiveAudioSource current.
	streamingSpeaker future audioID: audioSource sourceID.
	streamingSpeaker future attemptAudioConnection.

	"Add speaker to avatar."
	streamingSpeaker future addRotationAroundY: 180.
	streamingSpeaker future translation: -0.75@-0.75@1.
	self addToAvatarOrSpace: streamingSpeaker.

	^ streamingSpeaker! !

!WisconsinHarness methodsFor: 'actions' stamp: 'hrs 5/2/2006 08:55'!
makeCube
	| cube |
	cube := TCube newOn: self activeIsland.
	^self new: TMedia3DContainer from: cube.! !

!WisconsinHarness methodsFor: 'actions' stamp: 'hrs 5/2/2006 09:00'!
makeDesktop: url
	| rfb |
	rfb := self activeIsland future new: TXrfbTexture.
	rfb future url: url asString extent: 800@600 depth: 16.
	^self new: TWindow from: rfb.! !

!WisconsinHarness methodsFor: 'actions' stamp: 'hrs 6/7/2006 12:13'!
makeFloor: sp fileName: txtrName
	| floor txt |
	txt := TTexture
				new initializeWithFileName: txtrName
				mipmap: true
				shrinkFit: false.
	txt uvScale: 8.0@8.0.

	floor := TCube newOn: self activeIsland.
	floor future extentX:100 y:0.5 z: 100.
	floor future translationX: 0 y: -6.0 z: 0.0.
	floor future texture: txt.
	floor future objectName: 'floor' copy.
	floor := self new: TMedia3DContainer from: floor.
	sp future addChild: floor.
	^ floor.
! !

!WisconsinHarness methodsFor: 'actions' stamp: 'hrs 5/16/2006 10:18'!
makeLight
	| obj |
	obj := self makeNakedLight.
	obj future visible: true.
	obj future rotationAroundZ: 180.
	^self new: TMedia3DContainer from: obj.! !

!WisconsinHarness methodsFor: 'actions' stamp: 'hrs 5/16/2006 09:24'!
makeLight: sp
	| tframe |
	tframe := self makeNakedLight.
	tframe future translationX: -10 y:0.0 z: 0.0.
	tframe future rotationAroundZ: 120.
	sp future addChild: tframe.
	^tframe.! !

!WisconsinHarness methodsFor: 'actions' stamp: 'hrs 5/13/2006 15:33'!
makeMirror
	| portal |
	portal := self activeIsland future new: TPortal.
	^self new: TWindow from: portal.! !

!WisconsinHarness methodsFor: 'actions' stamp: 'hrs 5/16/2006 10:09'!
makeNakedLight
	| island  tframe |
	island := self activeIsland.
	tframe := TLight newOn: island.
	"This is to avoid some odd lighting effects"
	tframe future rotateBy: 1 around: 1@0@0.
	^tframe.! !

!WisconsinHarness methodsFor: 'actions' stamp: 'hrs 6/7/2006 11:49'!
makeSpace
	| island space name pc newWindow activeSpaceWindow portalToNewSpace portalToActiveSpace|
	island := self activeIsland.
	space := island future new: TSpace.
	name := TObjectID new asSymbol.
	space future registerGlobal: name.
	self makeLight: space.
	self makeFloor: space fileName: (FileDirectory uri: 'Content/Textures/') fileNames atRandom.
	portalToActiveSpace := TMagneticPortal newOn: island.
	newWindow := TWindow newOn: island from: portalToActiveSpace.
	newWindow future addRotationAroundY: 180.
	space future addChild: newWindow.

	portalToNewSpace := TMagneticPortal newOn: island.
	activeSpaceWindow := self new: TWindow from: portalToNewSpace.
	
	pc := portalToNewSpace future postcard.
	portalToActiveSpace future postcardLink: pc.
	pc := portalToActiveSpace future postcard. 
	portalToNewSpace future postcardLink: pc.

	^activeSpaceWindow.
! !

!WisconsinHarness methodsFor: 'actions' stamp: 'hrs 5/2/2006 15:35'!
makeText: aString
	| content |
	content := self activeIsland future new: TTextTexture.  
	content future text: aString asString extent: 150@100 depth: 32.
	^self new: TWindow from: content.! !

!WisconsinHarness methodsFor: 'actions' stamp: 'hrs 5/14/2006 11:29'!
makeVideoWindow
	|   island videoWindow videoSource |
	island := self activeIsland.
	
	"Create video window."
	videoWindow := TLiveVideoWindow newOn: island.

	"Connect video window to video source."
	videoSource := LiveVideoSource current.
	videoWindow future cameraID: videoSource sourceID.
	videoWindow future attemptCameraConnection.

	"Add video window to avatar."
	videoWindow future addRotationAroundY: 180.
	videoWindow future translation: 0@3.7@1.9.
	self addToAvatarOrSpace: videoWindow.

	^ videoWindow! !

!WisconsinHarness methodsFor: 'actions' stamp: 'hrs 5/2/2006 14:58'!
new: aClass from: newObject
	|  container |
	container := aClass newOn: self activeIsland from: newObject.
	container ifNotNil: [
		self activeSpace future addChild: container byUser: self avatar replica.
		].
	^container.! !

!WisconsinHarness methodsFor: 'accessing' stamp: 'jcg 4/13/2006 16:26'!
password
	^ password! !

!WisconsinHarness methodsFor: 'accessing' stamp: 'jcg 4/13/2006 16:26'!
password: passwordString
	password := passwordString! !

!WisconsinHarness methodsFor: 'actions' stamp: 'hrs 5/2/2006 11:19'!
promptForStream
	| dialog nameString |
	^self ifTweak: [
		dialog := CFileOpenDialog new.  
		nameString := dialog	openFile: {
						{'Pictures'. #('*.jpg' '*.bmp' '*.gif' '*.png' '*.tif' '*.jpeg')}.
						{'Meshes'. #('*.ase' '*.wrl' '*.vrml' '*.mdl' '*.tea')}.
						{'Audio'. #('*.mp3' '*.wav' '*.aif')}.
						{'Video'. #('*.mpeg')}.
						{'Flash'. #('*.swf')}.
						{'Web'. #('*.html' '*.htm')}.
						{'any'. #('*.*')}.
						} 
						label: 'Choose content to import:'.
		nameString ifNotNil: [FileDirectory default readOnlyFileNamed: nameString.].
		]
		ifNot: [self notYetImplemented. "self promptForURL etc."]! !

!WisconsinHarness methodsFor: 'actions' stamp: 'hrs 4/28/2006 21:10'!
promptForURL
	| nameString |
	nameString := UIManager default request: 'URL to import:' initialAnswer: self defaultURL asString.
	(nameString isNil or: [nameString isEmpty])   "Tweak returns nil, Morphic empty string."
		ifTrue: [self defaultURL: nil] "A quick way to reset to default."
		ifFalse: [self defaultURL: (self defaultURL newFromRelativeText: nameString)].
	^self defaultURL.! !

!WisconsinHarness methodsFor: 'actions' stamp: 'hrs 6/3/2006 19:22'!
saveCurrentWorld
	(self activeSpace island get: #controller) cacheTo: self cacheDirectory 
			archive: self archiveDirectory. 
! !

!WisconsinHarness methodsFor: 'actions' stamp: 'hrs 6/3/2006 20:10'!
saveParticipatingWorlds
	islandsByID do: [:island |
		(island get: #name) ifNotNil: [ "e.g., for local controllers"
			(island get: #controller) cacheTo: self cacheDirectory archive: self archiveDirectory
			].
		].
! !

!WisconsinHarness methodsFor: 'initialize' stamp: 'hrs 5/19/2006 18:14'!
setupUser: username password: password entryWorld: aClass address: routerAddress port: routerPort
	| entry |
	entry := (TPostcard new routerAddress: nil
	    						id: aClass islandID name: aClass name asString
	    						viewpointName: #mainEntry).
	self setupUser: username password: password entry: entry address: routerAddress port: routerPort.! !

!WisconsinHarness methodsFor: 'initialize' stamp: 'jcg 8/3/2006 20:51'!
setupUser: usernameString password: passwordString entry: entryPostcard address: routerAddress port: routerPort
	| cacheController promise |
	self userName: usernameString.
	self avatar nickname: self userName.
	self password: passwordString.
		

	"Allow use of global cache.  This isn't the prettiest."
	self bitCache: TGlobalBitCache new.
	self mediaCache bitCache: self bitCache.
	cacheController := WisconsinCacheController new.
	self bitCache controller: cacheController.
	self addController: cacheController.
	cacheController 	
				connectTo: (NetNameResolver addressForName: routerAddress) 
				port: routerPort
				sessionID: WisconsinCacheRouter defaultRouterID.
	promise := cacheController login: 'global' password: 'cache'.
	promise wait.
	promise := cacheController join.
	promise wait.


	WisconsinParticipant worlds do:
		[:class || contact |
		contact := WisconsinContact new
						address: (NetNameResolver addressForName: routerAddress)
						port: routerPort
						id: class islandID name: class name asString
						worldClass: class
						harness: self.
		self addContact: contact].

	self viewPortal future postcardLink: entryPostcard.
	self findViewpointByPostcard: entryPostcard.
	self step. "why doesn't this happen when we openInWorld?"
! !

!WisconsinHarness methodsFor: 'messages' stamp: 'hrs 5/6/2006 18:02'!
step
	| checkForSnapshot |
	checkForSnapshot := postcard notNil.
	super step.
	
	"Is there a better place to add landmarks? 
	We can't add initial landmark during setup because the entry postcard isn't resolved that
     early.  #findViewpointByPostcard: returns nil in such cases, not a promise that we would
	be able to hang a whenResolved: on."
	(checkForSnapshot and: [postcard isNil] 
		and: [self activeSpace notNil] "I don't know how, but it happens")
		 ifTrue: [self addPotentialLandmark].! !

!WisconsinHarness methodsFor: 'actions' stamp: 'hrs 6/9/2006 11:46'!
syncAllWorlds
	"Useful for starting up interactivity servers."
	| controller id name |
	contactPoint contactsByID do: [:contact |
		id := contact id.
		islandsByID at: id ifAbsentPut:[
			contact setupContact.
			controller := contact controller.
			self addController: controller.
			name := contact name.
			name ifNotNil: [islandsByName at: name put: controller island].
			controller island.
			].
		].! !

!WisconsinHarness methodsFor: 'accessing' stamp: 'jcg 5/7/2006 17:29'!
userID
	^ event userID! !

!WisconsinHarness methodsFor: 'accessing' stamp: 'jcg 4/13/2006 16:26'!
userName
	^ userName! !

!WisconsinHarness methodsFor: 'accessing' stamp: 'jcg 4/13/2006 16:26'!
userName: nameString
	userName := nameString! !

TWindow subclass: #TMedia2DContainer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-Media'!

TMedia2DContainer subclass: #TImageContainer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-Media'!

!TImageContainer class methodsFor: 'as yet unclassified' stamp: 'hrs 5/12/2006 09:53'!
connectContentsFrom: input intoContainer: myInstance
	myInstance future contents: (TRectangle newOn: myInstance island).
	myInstance future rectFront: input.
	myInstance future closeContents.
	^myInstance.! !

TWindow subclass: #TVideoWindow
	instanceVariableNames: 'isOpen'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-Video'!

TVideoWindow subclass: #TLiveVideoWindow
	instanceVariableNames: 'decoder cameraID'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-Video'!

!TLiveVideoWindow commentStamp: 'jcg 5/5/2006 01:33' prior: 0!
See LiveVideoSource class comment.!

!TLiveVideoWindow methodsFor: 'connecting' stamp: 'jcg 5/9/2006 17:27'!
attemptCameraConnection
	cameraID ifNil: [^ self "Don't know who we want to connect to."]. 
	self videoWindowRegistry add: self.
	LiveVideoSource attemptConnectionTo: cameraID copy from: (self island register: decoder).! !

!TLiveVideoWindow methodsFor: 'connecting' stamp: 'jcg 5/4/2006 18:49'!
attemptCameraDisconnection
	cameraID ifNil: [^ self "Don't know who we want to disconnect from."]. 
	self videoWindowRegistry remove: self ifAbsent: [].
	LiveVideoSource attemptDisconnectionFrom: cameraID from: (self island register: decoder).! !

!TLiveVideoWindow methodsFor: 'initialize' stamp: 'jcg 5/3/2006 22:52'!
cameraID: id
	cameraID := id! !

!TLiveVideoWindow methodsFor: 'actions' stamp: 'jcg 6/14/2006 13:27'!
closeContents
	super closeContents.
	self attemptCameraDisconnection.
! !

!TLiveVideoWindow methodsFor: 'accessing' stamp: 'jcg 5/3/2006 22:51'!
decoder
	^ decoder! !

!TLiveVideoWindow methodsFor: 'actions' stamp: 'jcg 5/9/2006 18:36'!
destroy
	super destroy.
	self attemptCameraDisconnection! !

!TLiveVideoWindow methodsFor: 'initialize' stamp: 'jcg 6/14/2006 13:25'!
initialize
	super initialize.
	decoder := FrameDecoder new.
	decoder extent: 160@120.  "or whatever"
	decoder targetTForm: self targetTForm.! !

!TLiveVideoWindow methodsFor: 'private' stamp: 'jcg 5/5/2006 15:20'!
justPastedOnto: target byUser: userAvtrRep
	super justPastedOnto: target byUser: userAvtrRep.
	isOpen ifTrue: [self attemptCameraConnection].! !

!TLiveVideoWindow methodsFor: 'actions' stamp: 'jcg 6/14/2006 13:28'!
openContents
	super openContents.
	self attemptCameraConnection.
! !

!TLiveVideoWindow methodsFor: 'private' stamp: 'jcg 5/4/2006 21:14'!
videoWindowRegistry
	| registry |
	self flag: #jcg.  "Originally tried to access 'globals' via #at: instead of #lookup:"
	registry := self island
						lookup: #videoWindows 
						ifAbsent: [self island register: IdentitySet new name: #videoWindows].
	^ registry valueOn: self island
	! !

TVideoWindow subclass: #TMovieWindow
	instanceVariableNames: 'player'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-Movie'!

!TMovieWindow class methodsFor: 'instance creation' stamp: 'jcg 7/28/2006 03:05'!
connectContentsFrom: movie intoContainer: myInstance
	myInstance future movie: movie.
	myInstance future closeContents. "Get ourselves all straightened out."
	myInstance future openContents. "What we really want."
	^myInstance.! !

!TMovieWindow methodsFor: 'actions' stamp: 'jcg 7/28/2006 03:35'!
closeContents
	super closeContents.
	player stop.! !

!TMovieWindow methodsFor: 'initialize' stamp: 'jcg 7/28/2006 03:39'!
initialize
	super initialize.
	player := TMoviePlayer new frame: self.
	self contents material texture: (TTexture new initializeWithTForm: player videoTarget).! !

!TMovieWindow methodsFor: 'accessing' stamp: 'jcg 7/26/2006 20:06'!
movie
	^ player movie! !

!TMovieWindow methodsFor: 'accessing' stamp: 'jcg 7/28/2006 05:53'!
movie: aMovie
	| ext |
	player movie: aMovie.
	ext := self videoExtent.
	self contents
			extent: self contents extent;
			aspect: (ext y / ext x) asFloat;
			aspectFixed: true.
	self extent: self contents extent.! !

!TMovieWindow methodsFor: 'actions' stamp: 'jcg 7/28/2006 03:35'!
openContents
	super openContents.
	player playFromBeginning.! !

!TMovieWindow methodsFor: 'accessing' stamp: 'jcg 7/26/2006 20:05'!
player
	^ player! !

!TMovieWindow methodsFor: 'private' stamp: 'jcg 7/28/2006 15:12'!
postImportFromIslandCopier: copier
	super postImportFromIslandCopier: copier.
	self closeContents
	! !

!TMovieWindow methodsFor: 'accessing' stamp: 'jcg 8/13/2006 02:34'!
serializeMaterial
	"Answer a material that will show whatever is being played in the movie.  In order to do this, we temporarily bash in a TFormCacheRef with the same sha as the real cache ref (a TMovieTargetFormCacheRef).  This is done because TMovieTargetFormCacheRef assigns itself a random sha upon import (see TMovieTargetFormCache>>postImportFromIslandCopier:)... in this case we don't want this, because we want to reference the same TForm that the movie player is decoding into."
	| tex savedRef fakeRef result |

	tex := self contents material texture.
	savedRef := tex tform cacheRef.
	fakeRef := TFormCacheRef new sha: savedRef sha clone; yourself.
	[tex tform cacheRef: fakeRef.
	result := tex serializeMaterial] ensure: [tex tform cacheRef: savedRef].
	^ result! !

!TMovieWindow methodsFor: 'accessing' stamp: 'jcg 7/28/2006 05:46'!
videoExtent
	^ player videoExtent! !

TVideoWindow subclass: #TMPEGWindow
	instanceVariableNames: 'mpeg videoPlayer audioPlayer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-MPEG'!

!TMPEGWindow class methodsFor: 'instance creation' stamp: 'hrs 6/16/2006 17:08'!
connectContentsFrom: input intoContainer: myInstance
	myInstance future mpeg: input.
	myInstance future closeContents. "Get ourselves all straightened out."
	myInstance future openContents. "What we really want."
	^myInstance.! !

!TMPEGWindow methodsFor: 'actions' stamp: 'jcg 6/14/2006 23:54'!
closeContents
	super closeContents.
	self stop.! !

!TMPEGWindow methodsFor: 'private' stamp: 'jcg 6/15/2006 20:19'!
createAudioPlayer
	audioPlayer := TMPEGAudioPlayer new window: self.
! !

!TMPEGWindow methodsFor: 'private' stamp: 'jcg 6/14/2006 23:40'!
createVideoPlayer
	videoPlayer := TMPEGVideoPlayer new window: self.
! !

!TMPEGWindow methodsFor: 'initialize' stamp: 'jcg 7/27/2006 12:20'!
destroy
	self stop.
	mpeg ifNotNilDo: [:m | m destroyHandle].
	super destroy.
	! !

!TMPEGWindow methodsFor: 'debug' stamp: 'jcg 6/14/2006 22:45'!
mpeg
	^ mpeg! !

!TMPEGWindow methodsFor: 'accessing' stamp: 'jcg 6/25/2006 17:23'!
mpeg: anInternalMPEG
	| videoExtent |
	mpeg := anInternalMPEG.
	mpeg videoStreamCount > 0 ifTrue: 
		[videoExtent := mpeg videoFrameExtentFor: 0.
		self targetTForm 
					initializeSHA: TObjectID new 
					form: (Form extent: videoExtent asSmallerPowerOfTwo depth: 32)
					mipmap: true
					shrinkFit: true.
		self contents 
				extent: self contents extent
				aspect: (videoExtent y / videoExtent x) asFloat.
		self contents aspectFixed: true.
		self extent: self contents extent].

	videoPlayer ifNotNil: [videoPlayer destroy. videoPlayer := nil].
	audioPlayer ifNotNil: [audioPlayer destroy. audioPlayer := nil].
	! !

!TMPEGWindow methodsFor: 'actions' stamp: 'jcg 6/14/2006 23:54'!
openContents
	super openContents.
	self playFromBeginning.! !

!TMPEGWindow methodsFor: 'actions' stamp: 'jcg 6/15/2006 20:19'!
play
	videoPlayer ifNil: [self createVideoPlayer].
	audioPlayer ifNil: [self createAudioPlayer].

	videoPlayer play.
	audioPlayer play.
	
	
	! !

!TMPEGWindow methodsFor: 'actions' stamp: 'jcg 6/14/2006 23:53'!
playFromBeginning
	videoPlayer ifNotNilDo: [:p | p rewind].
	audioPlayer ifNotNilDo: [:p | p rewind].
	self play.! !

!TMPEGWindow methodsFor: 'actions' stamp: 'jcg 6/14/2006 23:53'!
stop
	videoPlayer ifNotNilDo: [:p | p stop].
	audioPlayer ifNotNilDo: [:p | p stop].! !

!TVideoWindow methodsFor: 'actions' stamp: 'jcg 6/14/2006 13:27'!
closeContents
	super closeContents.
	isOpen := false.

! !

!TVideoWindow methodsFor: 'initialize' stamp: 'jcg 8/6/2006 00:48'!
initialize
	| tform tex mat rect |
	super initialize.
	
	isOpen := true.
	
	tform := TForm new
				initializeSHA: nil
				form: TForm defaultForm 
				mipmap: true 
				shrinkFit: false 
				extension: nil.
	tex := TTexture new initializeWithTForm: tform.
	mat := TMaterial new
					diffuseColor: Color white asVectorColor;
					fullBright: true;
					texture: tex.
	rect := THappyWithMyMaterialRectangle new.
	rect material: mat.
	
	self contents: rect.! !

!TVideoWindow methodsFor: 'testing' stamp: 'jcg 6/14/2006 13:28'!
isOpen
	^ isOpen! !

!TVideoWindow methodsFor: 'actions' stamp: 'jcg 6/14/2006 13:28'!
openContents
	super openContents.
	isOpen := true.! !

!TVideoWindow methodsFor: 'accessing' stamp: 'hrs 6/16/2006 15:53'!
serializeContents
	^self contents serializeMaterial.! !

!TVideoWindow methodsFor: 'accessing' stamp: 'jcg 6/14/2006 13:24'!
targetTForm
	^ self contents material texture tform! !

!TWindow methodsFor: '*Wisconsin-hacks' stamp: 'hrs 7/25/2006 14:31'!
grabbedState: aBoolean
	windowButtons grabButton switch: aBoolean.! !

!TWindow methodsFor: '*Wisconsin-hacks' stamp: 'hrs 5/14/2006 12:48'!
nowCarried
	self windowButtons grabButton switch: true. ! !

!TWindow methodsFor: '*Wisconsin-hacks' stamp: 'hrs 5/12/2006 09:58'!
pasteMaterial: aMaterialOrTexture
	contentsOn ifTrue: [self rectBack: aMaterialOrTexture texture]
		ifFalse: ["Doesn't work without frobbing. Why?"
			self openContents.
			self rectFront: aMaterialOrTexture texture.
			self closeContents.
			].! !

!TWindow methodsFor: '*Wisconsin-hacks' stamp: 'hrs 5/9/2006 10:14'!
rectBack: rect
	self removeChild: rectBack.
	rectBack := rect. 		
	rectBack extent: windowFrame extent asPoint.
	rectBack location: (Vector3 x:0.0 y:0.0 z: windowFrame radius negated).
	rectBack flip: true.
	rectBack material: matRectNorm.
	rectBack objectName: 'rectBack'.
	self addChild: rectBack.

! !

!TWindow methodsFor: '*Wisconsin-hacks' stamp: 'hrs 5/11/2006 20:30'!
serializeMaterial
	"Arbitrary. But I think it's useful for constructing worlds."
	^contentsOn 
		ifTrue: [rectBack serializeMaterial]
		ifFalse: [rectFront serializeMaterial].
! !

CroquetMenuProject subclass: #UWMenuBar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-UI'!

!UWMenuBar commentStamp: 'hrs 4/24/2006 08:47' prior: 0!
A Tweak menu for WisconsinParticipant.

Note that it is planned for Tweak integration with Croquet to change quite a bit for release 1.1.
So I don't think it's worth getting the classes in this category too cleaned up.!

UWMenuBar defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!UWMenuBar class methodsFor: 'actions' stamp: 'hrs 7/26/2006 20:15'!
showInformationOnFarRef: aTFarRef
	self flag: #FIXME.
	"This is what we really want, but it doesn't work. Why not? 'anObject inspect' is ok..."
	"aTFarRef send: [:anObject | CInspector openOn: anObject ]."
	
	"so we'll do this instead. yuck."
	CInspector openOn:  aTFarRef.! !

!UWMenuBar methodsFor: 'menu-actions' stamp: 'hrs 4/29/2006 08:42'!
actionConfigureVNC
	XrfbControlPanelMorph new openInWorld
! !

!UWMenuBar methodsFor: 'menu-actions' stamp: 'hrs 7/26/2006 19:57'!
actionExploreHarness
	hand world ownerMorph harness explore.! !

!UWMenuBar methodsFor: 'menu-actions' stamp: 'hrs 7/26/2006 19:57'!
actionExploreSpace
	hand world ownerMorph harness activeSpace explore.! !

!UWMenuBar methodsFor: 'menu-actions' stamp: 'hrs 4/20/2006 16:30'!
actionFirstPersonPerspective
	hand world ownerMorph harness avatar thirdPerson: 0.! !

!UWMenuBar methodsFor: 'menu-actions' stamp: 'hrs 4/20/2006 16:30'!
actionGamersPerspective
	hand world ownerMorph harness avatar thirdPerson: 1.! !

!UWMenuBar methodsFor: 'menu-actions' stamp: 'hrs 4/21/2006 11:48'!
actionMakeSnapshot
	hand world ownerMorph harness makeSnapshot.! !

!UWMenuBar methodsFor: 'menu-actions' stamp: 'jcg 5/10/2006 12:04'!
actionNewAudioSource
	| harness |
	harness := hand world ownerMorph harness.
	harness makeAudioSource.! !

!UWMenuBar methodsFor: 'menu-actions' stamp: 'hrs 4/28/2006 21:40'!
actionNewCube
	| harness |
	harness := hand world ownerMorph harness.
	harness makeCube.! !

!UWMenuBar methodsFor: 'menu-actions' stamp: 'hrs 4/28/2006 21:05'!
actionNewDesktop
	| harness |
	harness := hand world ownerMorph harness.
	harness makeDesktop: harness promptForURL.! !

!UWMenuBar methodsFor: 'menu-actions' stamp: 'hrs 5/2/2006 11:20'!
actionNewFromFile
	| harness stream |
	harness := hand world ownerMorph harness.

	"In principle, application code shouldn't need to have permission to open files.
	The UI makes it obvious to the user that the disk is being accessed, so a nice
	secure interface, without being draconian, would be to have the file dialog UI produce 
	an already open stream.

	We will pretend that things work that way, even though they don't, and even though
	the downstream code for handling meshes is currently going to have to open a file anyway.
	"
	stream := harness promptForStream.
	[harness dropFile: stream] ensure: [stream close].! !

!UWMenuBar methodsFor: 'menu-actions' stamp: 'hrs 5/16/2006 09:32'!
actionNewLight
	^hand world ownerMorph harness makeLight.! !

!UWMenuBar methodsFor: 'menu-actions' stamp: 'hrs 5/13/2006 15:34'!
actionNewMirror
	^hand world ownerMorph harness makeMirror.! !

!UWMenuBar methodsFor: 'menu-actions' stamp: 'hrs 4/30/2006 20:19'!
actionNewSpace
	| harness |
	harness := hand world ownerMorph harness.
	harness makeSpace.! !

!UWMenuBar methodsFor: 'menu-actions' stamp: 'hrs 5/2/2006 14:52'!
actionNewText
	| harness |
	harness := hand world ownerMorph harness.
	harness makeText: 'Type here.'.! !

!UWMenuBar methodsFor: 'menu-actions' stamp: 'jcg 5/1/2006 18:39'!
actionNewVideoWindow
	| harness |
	harness := hand world ownerMorph harness.
	harness makeVideoWindow.! !

!UWMenuBar methodsFor: 'menu-actions' stamp: 'hrs 4/20/2006 16:48'!
actionQuit
	"(self confirm: 'Quit Croquet?') ifFalse:[^false]."
	World ifNil:[^Smalltalk snapshot: false andQuit: true].
"	self closeProject."
	self window ifNotNil:[self window close].! !

!UWMenuBar methodsFor: 'menu-actions' stamp: 'jcg 5/30/2006 07:03'!
actionSaveAllWorlds
	| harness |
	harness := hand world ownerMorph harness.
	"This method is being executed in a high-priority Tweak script, which means
	that some lower-priority stuff hasn't had a chance to let go of 'temporary globals'
	which cause cross-island pointer references during snapshotting. So let's let this happen
	later."
	[harness saveParticipatingWorlds] forkAt: Processor userSchedulingPriority + 2.! !

!UWMenuBar methodsFor: 'menu-actions' stamp: 'hrs 5/1/2006 11:11'!
actionSaveCurrentWorld
	| harness |
	harness := hand world ownerMorph harness.
	"This method is being executed in a high-priority Tweak script, which means
	that some lower-priority stuff hasn't had a chance to let go of 'temporary globals'
	which cause cross-island pointer references during snapshotting. So let's let this happen
	later."
	[harness saveCurrentWorld] forkAt: Processor userSchedulingPriority + 1.! !

!UWMenuBar methodsFor: 'menu-actions' stamp: 'hrs 7/26/2006 20:17'!
actionSpaceInformation
	self class showInformationOnFarRef: hand world ownerMorph harness activeSpace.! !

!UWMenuBar methodsFor: 'menu-actions' stamp: 'hrs 5/1/2006 12:13'!
actionSyncAllWorlds
	hand world ownerMorph harness syncAllWorlds.! !

!UWMenuBar methodsFor: 'menu-actions' stamp: 'hrs 4/20/2006 16:31'!
actionThirdPersonPerspective
	hand world ownerMorph harness avatar thirdPerson: 3.! !

!UWMenuBar methodsFor: 'private' stamp: 'jcg 5/5/2006 12:13'!
harness
	"This method exists because the harness is not yet set up when the menu is built."
	^ hand world ownerMorph harness! !

!UWMenuBar methodsFor: 'menu' stamp: 'hrs 7/26/2006 20:19'!
menuBarDevelopersMenu
	| menu |
	menu := CMenu new.
	menu add: 'Space Information' target: self action: #actionSpaceInformation.
	menu add: 'Explore Space' target: self action: #actionExploreSpace.
	menu add: 'Explore Harness' target: self action: #actionExploreHarness.
	menu addSeparator.
	menu add: 'Sync Known Worlds' target: self action: #actionSyncAllWorlds.
	menu add: 'Cache Current World' target: self action: #actionSaveCurrentWorld.
	menu add: 'Cache Sync''d Worlds' target: self action: #actionSaveAllWorlds.
	menu addSeparator.
	menu add: 'Toggle Halo' target: self action: #actionToggleHalo disabled: false.
	menu add: 'Refresh Display' target: self action: #refreshDisplay.
	menu add: 'Restore Cursor' target: self action: #restoreCursor.
	menu add: 'Refresh World Menu' target: self action: #installWorldMenu.
	menu addSeparator.
	menu add: 'Reclaim Memory' target: self action: #garbageCollect.
	menu add: 'VM Statistics' target: self action: #vmStatistics.
	menu add: 'Start MessageTally' target: self action: #startMessageTally.
	menu addSeparator.
	menu add: 'Toggle Primitive Stats' target: self action: #actionTogglePrimitiveStats.
	^menu! !

!UWMenuBar methodsFor: 'menu' stamp: 'hrs 5/16/2006 09:32'!
menuBarNewMenu
	| menu |
	menu := CMenu new.
	menu add: 'Space' target: self action: #actionNewSpace.
	menu add: 'Light' target: self action: #actionNewLight.
	menu add: 'Cube' target: self action: #actionNewCube.
	menu add: 'Mirror' target: self action: #actionNewMirror.
	menu add: 'Text' target: self action: #actionNewText.
	menu add: 'Video Camera Output' target: self action: #actionNewVideoWindow.
	menu add: 'Microphone Output' target: self action: #actionNewAudioSource.
	menu add: 'Paste' target: self action: #pasteFromClipboard.
	menu addSeparator.
	menu add: 'From File...' target: self action: #actionNewFromFile.
	menu add: 'Desktop...' target: self action: #actionNewDesktop.
	menu add: 'Sketch...' target: self action: #actionOpen: arguments: { TPainter }.
	menu add: 'Terrain...' target: self action: #actionTerrainTool.
	^menu
! !

!UWMenuBar methodsFor: 'menu' stamp: 'hrs 7/23/2006 11:54'!
menuBarToolsMenu
	| menu |
	menu := CMenu new.
	menu add: 'Switch Avatar' target: self action: #actionSwitchAvatar disabled: false.
	menu add: 'Set Nickname' target: self action: #setNickname disabled: false.
	menu add: 'Jabber/IM...' subMenu:  self jabberLoginMenu.
	menu addSeparator.
	menu add: 'Connect to Another World' target: self  action: #connectToAnotherWorld.
	menu add: 'What''s My Location?' target: CPostcardDialog  action: #showMyPostcard .
	menu add: 'Remember This Place' target: self action: #actionMakeSnapshot.
	^menu
! !

!UWMenuBar methodsFor: 'menu' stamp: 'hrs 5/14/2006 13:06'!
menuBarViewMenu
	| menu |
	menu := CMenu new.
	menu add: 'Toggle Full Screen' target: self action: #actionToggleFullScreen.
	menu add: 'Toggle Frame Rate' target: self action: #actionToggleFrameRate.
	menu add: 'Toggle Navigation Buttons' target: hand world ownerMorph action: #toggleNavButtons.
	menu addSeparator.
	menu add: 'Local Text Chat' target: self action: #croquetChatWindow.
	self jabberListener ifNil: [menu add: 'Jabber' target: nil action: nil disabled: true]
		ifNotNil:[menu add: 'Jabber:',self jabberListener identity id 
					subMenu: (self jabberListener makeAccountMenu).
				].
	menu add: 'Audio Volume' target: self action: #actionOpenMasterVolumeTool.
	menu add: 'Remote Desktop Configuration' target: self action: #actionConfigureVNC.
	menu addSeparator.
	menu add: 'First-person perspective (ctrl-a)' target: self action: #actionFirstPersonPerspective.
	menu add: 'Gamers perspective (ctrl-a)' target: self action: #actionGamersPerspective.
	menu add: 'Overview (Third-person perspective) (ctrl-a)' target:  self action: #actionThirdPersonPerspective.
	^menu! !

!UWMenuBar methodsFor: 'initialize' stamp: 'hrs 5/13/2006 21:04'!
newWorldMenu
	| menu |
	menu := CMenuBar new.

	" So the menu doesn't retract. "
	self automaticWorldMenu: false.

	menu add: 'Croquet' subMenu: self menuBarAboutMenu.
	menu add: 'New' subMenu: self menuBarNewMenu.
	menu add: 'View' subMenu: self menuBarViewMenu.
	menu add: 'Tools' subMenu: self menuBarToolsMenu.
	menu add: 'Admin' subMenu: self menuBarDevelopersMenu.

	^menu! !

!UWMenuBar methodsFor: 'menu-actions' stamp: 'jcg 5/5/2006 12:13'!
pasteFromClipboard
	"The paste munu item was disabled - this enabled it"
	self harness clipboard pasteIntoActiveSpace.! !

TFileBitCache subclass: #TGlobalBitCache
	instanceVariableNames: 'controller'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-Cache'!

!TGlobalBitCache commentStamp: 'jcg 8/3/2006 18:30' prior: 0!
Caches data locally like a TFileBitCache.  If data is not available, attempts to get the data from a 'global' cache on the network.  Currently, the global cache is a specialized router.  In the future, it will be based on something like BitTorrent or a DHT.
!

!TGlobalBitCache methodsFor: 'searching' stamp: 'jcg 5/22/2006 23:44'!
cache: data to: fileName
	super cache: data to: fileName.
	controller notify: fileName "sha"! !

!TGlobalBitCache methodsFor: 'initialize' stamp: 'jcg 5/22/2006 18:41'!
controller: aCacheController
	controller := aCacheController.! !

!TGlobalBitCache methodsFor: 'searching' stamp: 'hrs 5/31/2006 09:08'!
findLocally: fileName
	^super find: fileName.! !

!TGlobalBitCache methodsFor: 'searching' stamp: 'jcg 5/22/2006 23:36'!
find: fileName
	| promise |
	(self findLocally: fileName) ifNotNilDo: [:data | ^ data].
	promise := controller request: fileName.
	promise wait.
	^ promise value! !

CacheRef subclass: #TMPEGMovieCacheRef
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-ResourceCache'!

!TMPEGMovieCacheRef methodsFor: 'accessing' stamp: 'jcg 7/28/2006 02:24'!
generateResourceFromBinaryData: data
	"Load the TMPEGMovie from the given binary data."
	^ TMPEGMovie withBytes: data! !

CacheRef subclass: #TResourceGeneratingCacheRef
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-ResourceCache'!

!TResourceGeneratingCacheRef commentStamp: '<historical>' prior: 0!
This is an abstract base class for cache refs that immediately generate a new resource when no matching resource is found (instead of the default behavior of creating a resource when data is found in the bit cache).!

TResourceGeneratingCacheRef subclass: #TMovieTargetFormCacheRef
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-ResourceCache'!

!TMovieTargetFormCacheRef commentStamp: '<historical>' prior: 0!
Generates a TMovieTargetForm.!

!TMovieTargetFormCacheRef methodsFor: 'private' stamp: 'jcg 7/28/2006 05:39'!
generateResourceFromScratch
	^ TMovieTargetForm new
							bShrinkFit: true;
							bMipmap: true;
							cacheRef: self copy;
							setupForm: (Form extent: 2@2 depth: 32). "will be resized later"! !

!TMovieTargetFormCacheRef methodsFor: 'private' stamp: 'jcg 8/13/2006 02:35'!
postImportFromIslandCopier: copier
	"This is done so that when a movie player is imported, it generates a new target TForm in the ocean (i.e. in the SharedMediaCache).  Otherwise, two movie players could stomp on each other by decoding into the same TForm."
	sha := TObjectID new! !

!TResourceGeneratingCacheRef methodsFor: 'accessing' stamp: 'jcg 7/20/2006 22:06'!
generateResourceFromBinaryData: data
	"The whole point of this class is to immediately generate a resource when one isn't found, instead of looking in the bit cache."
	self shouldNotImplement! !

!TResourceGeneratingCacheRef methodsFor: 'private' stamp: 'jcg 7/20/2006 22:46'!
generateResourceFromScratch
	self subclassResponsibility! !

!TResourceGeneratingCacheRef methodsFor: 'initialize' stamp: 'jcg 7/20/2006 22:47'!
initialize
	super initialize.
	sha := TObjectID new.! !

!TResourceGeneratingCacheRef methodsFor: 'double-dispatch' stamp: 'jcg 7/30/2006 01:27'!
resourceNotFoundIn: sharedCache distance: dist
	"Double dispatch.  Immediately generate resource ourselves."	
	| resource |
	resource := self generateResourceFromScratch.
	resource cacheRef: self copy.
	sharedCache substituteResource: resource cacheRef: self.
	^ resource
! !

TPortal subclass: #TMagneticPortal
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin'!

!TMagneticPortal commentStamp: 'hrs 5/16/2006 18:26' prior: 0!
I can be cut or copied. When I get pasted somewhere, the portal that I link to adjusted to link back to me.

In the case of pure copying, it would be acceptable to leave the other portal pointing to my original. But I am used where one never knows if the original still exists. If I'm pasted somewhere, then we KNOW that I exist, so it is certainly safe to have the far portal link back to me.!

!TMagneticPortal methodsFor: 'fileIn/Out' stamp: 'jcg 7/4/2006 20:40'!
postImportFromIslandCopier: ignore
	| postcardLink otherPortal|
	super postImportFromIslandCopier: ignore.
	postcardLink := self postcardLink ifNil: [^self].
	postcardLink = self ifTrue: [^self].

	"I don't like this 'clipboard harness' business... we've been trying to disallow controllers to get access to other controllers.  Maybe we can use TControllerEnvironment to do this more nicely."
	self flag: #jcg.
	otherPortal := (self island get: #controller) clipboard harness 
					findViewpointByPostcard: postcardLink.
	otherPortal future postcardLink: self postcard.! !

!CroquetHarness methodsFor: '*Wisconsin' stamp: 'jcg 8/5/2006 12:02'!
handleManager
	self error: 'only in WisconsinController'.
	^ nil! !

!TIslandController methodsFor: '*Wisconsin' stamp: 'jcg 5/5/2006 12:30'!
clipboard
	"Just use the singleton CroquetClipboard (see CroquetClipboard's class comment)"	
	^ CroquetClipboard default! !

!TIslandController methodsFor: '*Wisconsin' stamp: 'jcg 5/5/2006 12:30'!
clipboard: ignore
	"Just use the singleton CroquetClipboard (see CroquetClipboard's class comment)"! !

!TIslandController methodsFor: '*Wisconsin' stamp: 'jcg 8/2/2006 00:23'!
ocean
	"We didn't presume to add an 'ocean' iVar... see WisconsinController"
	^ nil ! !

!TIslandController methodsFor: '*Wisconsin' stamp: 'jcg 8/2/2006 00:23'!
ocean: ignore
	"We didn't presume to add an 'ocean' iVar... see WisconsinController"
	^ nil ! !

!TIslandController methodsFor: '*Wisconsin' stamp: 'jcg 7/25/2006 00:12'!
openAL
	^ OpenAL singleton! !

!TIslandController methodsFor: '*Wisconsin' stamp: 'jcg 5/10/2006 16:28'!
openAL: ignore
	! !

!CMenu methodsFor: '*Wisconsin-construction' stamp: 'jcg 5/8/2006 17:07'!
add: aString target: anObject action: aSelector argument: arg disabled: aBool
	| item |
	item := self add: aString target: anObject action: aSelector arguments: {arg}.
	item disabled: aBool.
	^ item! !

!TFormManager methodsFor: '*Wisconsin' stamp: 'jcg 8/3/2006 00:08'!
addFile: file mipmap: bMM shrinkFit: bSF extension: ext
	"This is the guts of #addFileNamed:mipmap:shrinkFit:extention:.
	In my opinion, this is preferred interface, because it ought to be safe for any
	API to do operations with an already opened file. Only 'safe' operations (e.g.,
	those explicitly given permission by the user, or those that nag the user, should be allowed
	to open a file on my machine. Besides, the other method could be rewritten to use this one."
	| form tform sha contents |
	contents := file binary contentsOfEntireFile.
	"compute the sha hash"
	sha := TFormManager generateSHA: contents.
	"load the file into a Form"
	tform := textureDictionary at: sha ifAbsentPut:[
		form := Form fromBinaryStream: (ReadStream on:contents).
		form ifNotNil:[
			tform := TForm new 
							initializeSHA: sha 
							form: form 
							mipmap: bMM 
							shrinkFit: bSF 
							extension: ext 
							url: nil.
		] ifNil:[
			Transcript show:'Bad texture file - cannot load';cr.
			^ nil.
		].
		tform.
	].
	"copy the original file into the local cache"
	cacheMgr cache: contents to: sha.
	^tform thumb.! !

TFormManager subclass: #WisconsinResourceManager
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-Cache'!

!WisconsinResourceManager methodsFor: 'as yet unclassified' stamp: 'jcg 8/4/2006 15:31'!
loadNextTFF: tff
	"Copies all the code from our super (!!) but uses #requestContent: instead of #sync:."
	| data controller promise sha |
	"Look in the local file cache"
	self log: tff sha, ': Loading texture...'.
	data := cacheMgr find: tff sha.
	data ifNotNil:[
		"See if cache got corrupted"
		self log: tff sha, ': Found in file cache...'.
		sha := TFormManager generateSHA: data.
		sha = tff sha ifFalse:[
			self log: tff sha, ': Cache invalid (SHA mismatch)...'.
			cacheMgr delete: tff sha.
			data := nil]].
	data ifNotNil:[^self loadNextTFF: tff from: data].
	"Try to get data from a controller"
	controller := TIslandController controllerWithID: tff controllerID.
	controller ifNil:[
		"Try to find another controller later - if this texture is still used we'll get around to it"
		self log: tff sha, ': Controller went away...'.
		mutex critical:[
			findList removeKey: tff sha.
			sortedFindList remove: tff
		].
		^self
	].
	"Ask the controller for the data"
	self log: tff sha, ': Requesting sync...'.
	promise := controller requestContent: tff sha.
	promise wait.
	data := promise result.
	self log: tff sha, ': Sync complete...'.
	data ifNotNil:["Verify SHA"
		sha := TFormManager generateSHA: data.
		sha = tff sha ifFalse:[
			self log: tff sha, ': Data invalid (SHA mismatch)...'.
			data := nil].
	].
	data ifNil:[^self updateForm: nil tff: tff].
	cacheMgr cache: data to: tff sha.
	self log: tff sha, ': Installing texture...'.
	self loadNextTFF: tff from: data.
! !

!OrderedCollection methodsFor: '*Wisconsin-hacks' stamp: 'jcg 4/24/2006 22:55'!
replace: oldObject with: newObject
	| index |
	index := firstIndex.
	[index <= lastIndex]
		whileTrue:
			[(array at: index) = oldObject ifTrue: [ array at: index put: newObject. ^ index].
			index := index + 1].
	self errorNotFound: oldObject! !

!Collection methodsFor: '*Wisconsin-hacks' stamp: 'jcg 4/12/2006 15:47'!
injectFirstInto: binaryBlock 
	"This is clearly not the most efficient implementation."
	^ self copyWithoutFirst inject: self first into: binaryBlock
! !

TGroup subclass: #TEditBox
	instanceVariableNames: 'corners edges sides contents box edgeScale matNorm matEdge matCorner matSide matOver matHilite selectedFrame selectedPoint lastSpin scaleContents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-Media'!

!TEditBox commentStamp: 'das 10/10/2004 11:27' prior: 0!
TEditBox is used to manipulate and position a contained object in 3D space. The contents are dropped into the object via #contents: method.

DAS!

!TEditBox methodsFor: 'accessing' stamp: 'zamp 9/16/2005 14:41'!
contents
	^ contents! !

!TEditBox methodsFor: 'accessing' stamp: 'DPR 1/9/2004 14:05'!
contents: conts

	| parentFrame extent |
	contents := conts.
	box := contents boundingBox copy.
	parentFrame := contents parent.
	self localTransform: conts localTransform.
	self translation: self translation + (self orientation localPointToGlobal:box center).
	contents localTransform: Matrix4x4 identity.
	contents translation: (box center negated).
	extent := box extent.
	box min: (extent/-2.0).
	box max: (extent/2.0).
	parentFrame replaceChild: contents with: self.
	self addChild: conts.
	scaleContents := 1.0.
	self update.! !

!TEditBox methodsFor: 'actions' stamp: 'jcg 4/26/2006 10:34'!
delete

	contents localTransform: (self localTransform composeWith: contents localTransform).
	self removeChild: contents.
	self parent replaceChild: self with: contents.
	contents parent addOwnership: contents.! !

!TEditBox methodsFor: 'actions' stamp: 'jcg 5/3/2006 00:55'!
dragBox: event
	| norm sp sf pointer side |
	sf := selectedFrame translation.
	pointer := event makePointer.

	event shiftPressed
		ifFalse: [
			"Move in the plane of the picked face."
			sf x ~= 0 ifTrue:[ norm := Vector3 x:1 y:0 z:0].
			sf y ~= 0 ifTrue:[norm := Vector3 x:0 y:1 z:0].
			sf z ~= 0 ifTrue:[norm := Vector3 x:0 y:0 z:1].
		]
		ifTrue: [
			"Move in the plane perpendicular to the plane of the picked face, and most aligned to the screen horizontal."
			side := self inverseGlobalTransform localPointToGlobal: 
								(event selection cameraTransform localPointToGlobal: 1@0@0).
			sf x ~= 0 ifTrue: [norm := ((side dot: 0@1@0) > (side dot: 0@0@1))
																	ifTrue: [0@0@1]
																	ifFalse: [0@1@0]].
			sf y ~= 0 ifTrue: [norm := ((side dot: 1@0@0) > (side dot: 0@0@1))
																	ifTrue: [0@0@1]
																	ifFalse: [1@0@0]].
			sf z ~= 0 ifTrue: [norm := ((side dot: 0@1@0) > (side dot: 1@0@0))
																	ifTrue: [1@0@0]
																	ifFalse: [0@1@0]].
		].

	sp := selectedFrame localTransform localPointToGlobal: selectedPoint.

	(pointer frame: self pickPlane: sp normal: norm) ifTrue:[
		self translation: self translation + 
							(self orientation localPointToGlobal: (pointer selectedPoint-sp)).].

	self signal: #draggedContents
! !

!TEditBox methodsFor: 'events' stamp: 'jcg 4/24/2006 23:46'!
eventMask

	^ EventPointerOver bitOr: EventPointerDown.! !

!TEditBox methodsFor: 'accessing' stamp: 'jcg 4/25/2006 14:22'!
frameBox
	^ box ifNil: [super frameBox]! !

!TEditBox methodsFor: 'initialize' stamp: 'jcg 12/17/2005 18:57'!
initializeWithContents: conts

	| parentFrame extent txtr |
	contents := conts.
	box := contents boundingBox copy.
	txtr := TTexture
				new initializeWithFileName: 'box.png'
				mipmap: true
				shrinkFit: false.

	matNorm := TMaterial new.
	matNorm ambientColor: #(0.5 0.7 0.7 0.5) asFloatArray.
	matNorm diffuseColor: #(0.5 0.7 0.7 0.5) asFloatArray.
	matNorm texture: txtr.

	matCorner := TMaterial new.
	matCorner ambientColor: #(0.9 0.9 0.3 0.9) asFloatArray.
	matCorner diffuseColor: #(0.9 0.9 0.3 0.9) asFloatArray.
	matCorner texture: txtr.

	matEdge := TMaterial new.
	matEdge ambientColor: #(1.0 0.4 0.4 0.9) asFloatArray.
	matEdge diffuseColor: #(1.0 0.4 0.4 0.9) asFloatArray.
	matEdge texture: txtr.

	matHilite := TMaterial new.
	matHilite ambientColor: #(1.0 1.0 0.2 0.5) asFloatArray.
	matHilite diffuseColor: #(1.0 1.0 0.2 0.5) asFloatArray.

	matOver := TMaterial new.
	matOver ambientColor: #(0.2 0.5 1.0 0.8) asFloatArray.
	matOver diffuseColor: #(0.2 0.5 1.0 0.8) asFloatArray.

	self makeCorners.
	self makeEdges.
	self makeSides.
	parentFrame := contents parent.
	self localTransform: conts localTransform.
	self translation: self translation + (self orientation localPointToGlobal:box center).
	contents localTransform: Matrix4x4 identity.
	contents translation: (box center negated).
	extent := box extent.
	box min: (extent/-2.0).
	box max: (extent/2.0).
	parentFrame replaceChild: contents with: self.
	self addChild: conts.
	scaleContents := 1.0.
	self update.
	^self! !

!TEditBox methodsFor: 'testing' stamp: 'das 5/19/2003 10:54'!
isComponent

	^ true.! !

!TEditBox methodsFor: 'events' stamp: 'jcg 4/24/2006 22:32'!
keyDown: pointer

	| c spin |
	c := pointer event2D keyCharacterWithCase.
	c = $x ifTrue:[ spin := Matrix4x4 identity rotationAroundX: -1.0].
	c = $X ifTrue:[ spin := Matrix4x4 identity rotationAroundX: 1.0].
	c = $y ifTrue:[ spin := Matrix4x4 identity rotationAroundY: -1.0].
	c = $Y ifTrue:[ spin := Matrix4x4 identity rotationAroundY: 1.0].
	c = $z ifTrue:[ spin := Matrix4x4 identity rotationAroundZ: -1.0].
	c = $Z ifTrue:[ spin := Matrix4x4 identity rotationAroundZ: 1.0].
	c = $d ifTrue:[self delete.].
	c = $e ifTrue:[self delete.].
	pointer event2D keyValue= 28 ifTrue:[ self selectLeftSibling. ]. "left arrow"
	pointer event2D keyValue= 29 ifTrue:[ self selectRightSibling.]. "right arrow"
	pointer event2D keyValue= 30 ifTrue:[ self selectParent. ]. "up arrow"
	pointer event2D keyValue= 31 ifTrue:[ self selectChild. ]. "down arrow"
	spin ifNotNil:[self localTransform: (self localTransform composeWith: spin) ].
	^ true.! !

!TEditBox methodsFor: 'events' stamp: 'jcg 4/24/2006 22:32'!
keyStroke: pointer

	| c spin |
	c := pointer event2D keyCharacter.
	c = $x ifTrue:[ spin := Matrix4x4 identity rotationAroundX: -1.0].
	c = $X ifTrue:[ spin := Matrix4x4 identity rotationAroundX: 1.0].
	c = $y ifTrue:[ spin := Matrix4x4 identity rotationAroundY: -1.0].
	c = $Y ifTrue:[ spin := Matrix4x4 identity rotationAroundY: 1.0].
	c = $z ifTrue:[ spin := Matrix4x4 identity rotationAroundZ: -1.0].
	c = $Z ifTrue:[ spin := Matrix4x4 identity rotationAroundZ: 1.0].
	c = $d ifTrue:[self delete.].
	pointer event2D keyValue= 28 ifTrue:[ self selectLeftSibling. ]. "left arrow"
	pointer event2D keyValue= 29 ifTrue:[ self selectRightSibling.]. "right arrow"
	pointer event2D keyValue= 30 ifTrue:[ self selectParent. ]. "up arrow"
	pointer event2D keyValue= 31 ifTrue:[ self selectChild. ]. "down arrow"
	spin ifNotNil:[self localTransform: (self localTransform composeWith: spin) ].
	^ true.! !

!TEditBox methodsFor: 'initialize' stamp: 'jcg 4/24/2006 22:44'!
makeCorners
	| c |
	corners := OrderedCollection ofSize: 8.
	1 to: 8 do:[:index |
		c := TCube new.
		c material: matCorner.
		c solid: false.
		corners at: index put: c.
		self addChild: c.
		c objectName: #corner.
		].

! !

!TEditBox methodsFor: 'initialize' stamp: 'jcg 4/24/2006 22:44'!
makeEdges
	| e |
	edges := OrderedCollection ofSize: 12.
	1 to: 12 do:[:index |
		e := TCube new.
		e material: matEdge.
		e solid: false.
		self addChild: e.
		edges at: index put: e.
		].

! !

!TEditBox methodsFor: 'initialize' stamp: 'jcg 4/24/2006 22:44'!
makeSides
	| s |
	sides := OrderedCollection ofSize: 6.
	1 to: 6 do:[:index |
		s := TRectangle new.
		s material: matNorm.
		s solid: false.
		s objectName: #side.
		self addChild: s.
		sides at: index put: s.
		].
	(sides at: 1)rotationAroundX:-90.
	(sides at: 2)rotationAroundX: 90.
	(sides at: 3)rotationAroundY:-90.
	(sides at: 4)rotationAroundY: 90.
	(sides at: 5)rotationAroundY:180.
! !

!TEditBox methodsFor: 'events' stamp: 'jcg 5/3/2006 01:02'!
pointerDown: event
	selectedFrame := event selection frame.
	selectedPoint := event selection point.

	"For some reason (probably 3d depth inaccuracies), the contents are sometimes selected instead of one of the edit box sides.  When this happens, we need to fix things up."
	(corners, edges, sides includes: selectedFrame) ifFalse:
		["Need a valid selection."
		| pointer newSelection |
		pointer := event makePointer.
		newSelection := sides 
							detect: 
								[:side | pointer currentFrame: side. 
								pointer pointerPick: side boundSphere]
							ifNone: [Transcript show: 'invalid selection'; cr. nil].
		newSelection ifNotNil:
			[selectedFrame := pointer selection frame.
			selectedPoint := pointer selection point].
		]
! !

!TEditBox methodsFor: 'events' stamp: 'jcg 4/24/2006 23:56'!
pointerEnter: event
	selectedFrame := event selection frame.
! !

!TEditBox methodsFor: 'events' stamp: 'jcg 5/2/2006 17:25'!
pointerMove: event
	self perform: selectedFrame objectName with: event! !

!TEditBox methodsFor: 'events' stamp: 'jcg 5/2/2006 15:15'!
pointerUp: pointer


	scaleContents ~= 1.0 ifTrue:[
		contents scale: scaleContents.
		contents initBounds.

		self flag: #jcg.  "The following line has no effect.  Why is it here?"
		self selectedPoint: selectedPoint.

		scaleContents := 1.0.].
! !

!TEditBox methodsFor: 'actions' stamp: 'jcg 4/25/2006 00:17'!
resizeBox: event
"This needs to be fixed - since the plane does not go through the center of the cube, there is a limit to how small this can get in any one motion. The advantage is this keeps us from getting too small."
	| len1 len2  norm sp sc pointer |
	pointer := event makePointer.
	norm := (pointer frameLookAt: self) negated.
	sp := selectedFrame localTransform localPointToGlobal: selectedPoint.
	(pointer frame: self pickPlane: sp normal: norm) ifTrue:[
		len1 := sp length.
		len2 := pointer selectedPoint length.
		len1 = 0.0 ifTrue:[^ false.].
		sc := len2/len1.
		self scale: sc.
		scaleContents := scaleContents * sc.
		selectedPoint := (selectedFrame localTransform orthoNormInverse localPointToGlobal: pointer selectedPoint).
		^ true.].
	^ false.! !

!TEditBox methodsFor: 'actions' stamp: 'jcg 4/26/2006 09:31'!
rotateBoxX: event

	| len radius delta deltaLoc spto spfrom theta trans pointer |
	pointer := event makePointer.
	" Rotate around the x-axis "
	len := selectedFrame extent x/2.0.
	len := len max: 100.0.
	radius := selectedFrame location length.
	(pointer frame: self pickCylinderFrom: ( Vector3 x: len  y: 0 z: 0)
		to:( Vector3 x: len negated y: 0 z: 0) radius: radius) 
	ifFalse:["we are not on the cylinder anymore...."
		delta := 2*radius.
		(pointer framePointer row2 dot: (pointer framePosition))  > 0 
			ifFalse:[  delta := delta negated.].
		deltaLoc := pointer framePointer row2 * delta.
		(pointer frame: self pickCylinderFrom: (Vector3 x: len  y: deltaLoc y z: deltaLoc z)
			to: (Vector3 x: len negated y: deltaLoc y z: deltaLoc z) radius: radius)
				ifFalse:[lastSpin := nil. ^ false.].
		spto := pointer selectedPoint copy- deltaLoc.
		spto x: 0
			y: spto y negated
			z: spto z negated.
			]
	ifTrue: [spto := pointer selectedPoint copy.].

	spfrom := selectedPoint copy.
	spfrom x: 0.0.
	spfrom normalize.
	spto x: 0.0.
	spto normalize.
	theta := ((spfrom y * spto z) - (spto y * spfrom z))"/selectedRadiusSquared".
	theta < -1.0 ifTrue:[theta:= -1.0].
	theta > 1.0 ifTrue:[theta := 1.0].
	theta := theta arcSin radiansToDegrees/2.0.
	lastSpin := Matrix4x4 identity rotationAroundX: theta.

	trans := self translation.
	self translationX: 0.0 y:0.0 z:0.0.
	self localTransform: (self localTransform composeWith: lastSpin).
	self translation: trans.
	self localTransform: localTransform clone.

	self signal: #rotatedContents.
	^ true.
! !

!TEditBox methodsFor: 'actions' stamp: 'jcg 4/26/2006 09:31'!
rotateBoxY: event

	| trans spfrom spto deltaLoc theta radius len delta pointer |
		pointer := event makePointer.
		" Rotate around the y-axis "
		len := selectedFrame extent y/2.0.
		len := len max: 100.0.
		radius := selectedFrame location length.
		(pointer frame: self pickCylinderFrom: (Vector3 x: 0.0 y: len z: 0.0)
				to: (Vector3 x: 0.0 y: len negated z: 0.0) radius: radius)
			ifFalse: [ "we are not on the cylinder anymore...."
			delta := 2*radius.
			(pointer framePointer row1 dot: (pointer framePosition)) > 0
				ifFalse:[ delta := delta negated ].
			deltaLoc := pointer framePointer row1 * delta.
			(pointer frame: self pickCylinderFrom: (Vector3 x: deltaLoc x y: len z: deltaLoc z )
				to: (Vector3 x: deltaLoc x y: len negated z: deltaLoc z) radius: radius)
				ifFalse:[lastSpin := nil. ^ false.].
			spto := pointer selectedPoint copy- deltaLoc.
			spto x: spto x negated
				y: 0
				z: spto z negated.
			]
	ifTrue: [spto := pointer selectedPoint copy.].

	spfrom := selectedPoint copy.
	spfrom y: 0.0.
	spfrom normalize.
	spto y: 0.0.
	spto normalize.
	theta := ((spfrom z * spto x) - (spto z * spfrom x))"/selectedRadiusSquared".
	theta < -1.0 ifTrue:[theta:= -1.0].
	theta > 1.0 ifTrue:[theta := 1.0].
	theta := theta arcSin radiansToDegrees/2.0.
	lastSpin := Matrix4x4 identity rotationAroundY: theta.

	trans := self translation.
	self translationX: 0.0 y:0.0 z:0.0.
	self localTransform: (self localTransform composeWith: lastSpin).
	self translation: trans.
	self localTransform: localTransform clone.

	self signal: #rotatedContents.
	^ true.
! !

!TEditBox methodsFor: 'actions' stamp: 'jcg 4/26/2006 09:31'!
rotateBoxZ: event

	| delta trans spfrom spto deltaLoc theta radius len pointer |
		pointer := event makePointer.
		" Rotate around the z-axis "
		len := selectedFrame extent z/2.0.
		len := len max: 100.0.
		radius := selectedFrame location length.
		(pointer frame: self pickCylinderFrom: (Vector3 x: 0.0 y: 0.0 z: len)
				to: (Vector3 x: 0.0 y: 0.0 z: len negated) radius: radius)
			ifFalse: [ "we are not on the cylinder anymore...."
			delta := 2*radius.
			(pointer framePointer row2 dot: (pointer framePosition))  > 0 
				ifFalse:[  delta := delta negated. ].
			deltaLoc := pointer framePointer row2 * delta.
			(pointer frame: self pickCylinderFrom: (Vector3 x: deltaLoc x y: deltaLoc y z: len)
				to: (Vector3 x: deltaLoc x y: deltaLoc y z: len negated) radius: radius)
				ifFalse:[lastSpin := nil. ^ false.].
			spto := pointer selectedPoint copy- deltaLoc.
			spto x: spto x negated
				y: spto y negated
				z: 0.
			]
	ifTrue: [spto := pointer selectedPoint copy.].

	spfrom := selectedPoint copy.
	spfrom z: 0.0.
	spfrom normalize.
	spto z: 0.0.
	spto normalize.
	theta := ((spfrom x * spto y) - (spto x * spfrom y))"/selectedRadiusSquared".
	theta < -1.0 ifTrue:[theta:= -1.0].
	theta > 1.0 ifTrue:[theta := 1.0].
	theta := theta arcSin radiansToDegrees/2.0.
	lastSpin := Matrix4x4 identity rotationAroundZ: theta.

	trans := self translation.
	self translationX: 0.0 y:0.0 z:0.0.
	self localTransform: (self localTransform composeWith: lastSpin).
	self translation: trans.
	self localTransform: localTransform clone.

	self signal: #rotatedContents.
	^ true.
! !

!TEditBox methodsFor: 'accessing' stamp: 'das 5/22/2003 12:51'!
scale: sc

	box scale: sc.
"	contents scale: sc."
	self update.! !

!TEditBox methodsFor: 'actions' stamp: 'jcg 4/24/2006 22:33'!
selectChild
	| eb |

	contents frameChildren ifNotNil:[
		contents frameChildren size > 0 ifTrue:[
			eb:= TEditBox new.
			eb contents: (contents frameChildren at: 1).
			self delete.
			].
		].
! !

!TEditBox methodsFor: 'accessing' stamp: 'das 5/24/2003 15:13'!
selectedPoint: sp

	selectedPoint := sp.! !

!TEditBox methodsFor: 'actions' stamp: 'jcg 4/24/2006 22:33'!
selectLeftSibling
	|  siblings previous eb |

	siblings := self parent frameChildren.

	siblings size > 1 ifTrue:[
		previous := siblings previous: self.
		self delete.
		eb := TEditBox new. 
		eb contents: previous .
		].
! !

!TEditBox methodsFor: 'actions' stamp: 'jcg 4/24/2006 22:33'!
selectParent
	| par eb |
	self parent ifNotNil: [ "we are the root"
		self parent ~= self root ifTrue:[ " don't select the root, as that would be really hard to edit"
		par := self parent.
		self delete.
		eb := TEditBox new.
		eb contents: par.
		].
	].
		! !

!TEditBox methodsFor: 'actions' stamp: 'jcg 4/24/2006 22:33'!
selectRightSibling
	|  siblings next eb |
	siblings := self parent frameChildren.

	siblings size > 1 ifTrue:[
		next := siblings next: self.
		self delete.
		eb := TEditBox new.
		eb contents: next .
		].
! !

!TEditBox methodsFor: 'transform' stamp: 'das 6/28/2003 09:03'!
update

	| mn mx sz counter cc |

	mn := box min.
	mx := box max.
	edgeScale := (1@1@1)*((mx-mn)max/20.0).
	cc := edgeScale x/2.0.
	sz:= (mx - mn max: (cc@cc@cc))/2.0.
	mn := box center - sz.
	mx := box center + sz.
	counter := 1.
	{mn x. mx x} do:[:xx |
	{mn y. mx y} do:[:yy |
	{mn z. mx z} do:[:zz |
		(corners at: counter) extent: edgeScale.
		(corners at: counter) location: xx@yy@zz.
		(corners at: counter) objectName: #resizeBox: .
		counter := counter + 1.
		]]].
	self updateEdge: (edges at: 1) from: (mn x @ mn y @ (mn z+cc)) to:(mn x @ mn y @ (mx z-cc))
		message: #rotateBoxZ: .
	self updateEdge: (edges at: 2) from: ((mn x+cc) @ mn y @ mx z) to:((mx x-cc) @ mn y @ mx z)
		message: #rotateBoxX: .
	self updateEdge: (edges at: 3) from: (mx x @ mn y @ (mx z-cc)) to:(mx x @ mn y @ (mn z+cc))
		message: #rotateBoxZ: .
	self updateEdge: (edges at: 4) from: ((mx x-cc) @ mn y @ mn z) to:((mn x+cc) @ mn y @ mn z)
		message: #rotateBoxX: .

	self updateEdge: (edges at: 5) from: (mn x @ mx y @ (mn z+cc)) to:(mn x @ mx y @ (mx z-cc))
		message: #rotateBoxZ: .
	self updateEdge: (edges at: 6) from: ((mn x+cc) @ mx y @ mx z) to:((mx x-cc) @ mx y @ mx z)
		message: #rotateBoxX: .
	self updateEdge: (edges at: 7) from: (mx x @ mx y @ (mx z-cc)) to:(mx x @ mx y @ (mn z+cc))
		message: #rotateBoxZ: .
	self updateEdge: (edges at: 8) from: ((mx x-cc) @ mx y @ mn z) to:((mn x+cc) @ mx y @ mn z)
		message: #rotateBoxX: .

	self updateEdge: (edges at: 9) from: (mn x @ (mn y+cc) @ mn z) to:(mn x @ (mx y-cc) @ mn z)
		message: #rotateBoxY: .
	self updateEdge: (edges at: 10) from: (mn x @ (mn y+cc) @ mx z) to:(mn x @ (mx y-cc) @ mx z)
		message: #rotateBoxY: .
	self updateEdge: (edges at: 11) from: (mx x @ (mn y+cc) @ mx z) to:(mx x @ (mx y-cc) @ mx z)
		message: #rotateBoxY: .
	self updateEdge: (edges at: 12) from: (mx x @ (mn y+cc) @ mn z) to:(mx x @ (mx y-cc) @ mn z)
		message: #rotateBoxY: .
	cc:= cc*2.
	(sides at: 1) extent: (mx x-mn x-cc)@(mx z - mn z-cc).
	(sides at: 1) translation:  box center+(0@mx y@0).
	(sides at: 2) extent: (mx x-mn x-cc)@(mx z - mn z-cc).
	(sides at: 2) translation:  box center+(0@mn y@0).
	(sides at: 3) extent: (mx z-mn z-cc)@(mx y - mn y-cc).
	(sides at: 3) translation:  box center+(mn x@0@0).
	(sides at: 4) extent: (mx z-mn z-cc)@(mx y - mn y-cc).
	(sides at: 4) translation:  box center+(mx x@0@0).
	(sides at: 5) extent: (mx x-mn x-cc)@(mx y - mn y-cc).
	(sides at: 5) translation:  box center+(0@0@mn z).
	(sides at: 6) extent: (mx x-mn x-cc)@(mx y - mn y-cc).
	(sides at: 6) translation: box center+(0@0@mx z).
	sides do:[:s | s objectName: #dragBox: ].
! !

!TEditBox methodsFor: 'transform' stamp: 'das 6/28/2003 09:03'!
updateEdge: edge from: from to: to message: msg

	| scale center |

	scale := (from - to) abs max: edgeScale.
	center := (from + to)/2.0.
	edge extent: scale.
	edge location: center.
	edge objectName: msg.! !

TGroup subclass: #TMedia3DContainer
	instanceVariableNames: 'contents buttons'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-Media'!

!TMedia3DContainer methodsFor: 'private' stamp: 'hrs 5/1/2006 21:38'!
adjustButtons
	"Move mesh buttons nicely above the mesh."
	| reference box translation |
	reference := self contents.
	(self contents parent isKindOf: TEditBox) ifTrue: [reference := self contents parent].
	box := reference boundingBox transformedBy: reference localTransform.
	translation := box center.
	translation y: box max y.
	buttons translation: translation.
	buttons extent: (box extent x max: 1.5)@0.
! !

!TMedia3DContainer methodsFor: 'private' stamp: 'hrs 5/16/2006 12:01'!
adjustButtonsForRotation
	"separate script name for easier termination."
	self adjustButtons.
! !

!TMedia3DContainer methodsFor: 'private' stamp: 'jcg 4/26/2006 09:27'!
adjustEditBox: editBox
	self translation: (self localTransform localPointToGlobal: editBox translation).
	editBox translation: 0@0@0.! !

!TMedia3DContainer methodsFor: 'initialize' stamp: 'hrs 7/23/2006 16:57'!
buttonClass
	^ WisconsinButtons! !

!TMedia3DContainer methodsFor: 'accessing' stamp: 'jcg 4/24/2006 16:45'!
buttons
	^ buttons ! !

!TMedia3DContainer methodsFor: 'editing' stamp: 'hrs 7/19/2006 13:11'!
closeContents
	self closeEditBox.! !

!TMedia3DContainer methodsFor: 'editing' stamp: 'hrs 5/16/2006 12:02'!
closeEditBox
	| editBox |
	editBox := self contents parent.
	(editBox isKindOf: TEditBox) ifFalse: [self error: 'expecting edit box for parent of contents'].
	self stopScript: #adjustEditBox:.
	self stopScript: #adjustButtonsForRotation.
	editBox delete! !

!TMedia3DContainer methodsFor: 'accessing' stamp: 'hrs 5/1/2006 21:41'!
contents
	^ contents! !

!TMedia3DContainer methodsFor: 'initialize' stamp: 'hrs 7/14/2006 18:54'!
contents: aTFrame
	contents := aTFrame.
	self addChild: aTFrame.
	self adjustButtons! !

!TMedia3DContainer methodsFor: 'events' stamp: 'jcg 4/24/2006 16:06'!
eventMask

	^ EventPointerOver bitOr: EventPointerDown.! !

!TMedia3DContainer methodsFor: 'accessing' stamp: 'hrs 7/25/2006 14:32'!
grabbedState: aBoolean
	buttons grabButton switch: aBoolean.! !

!TMedia3DContainer methodsFor: 'initialize' stamp: 'hrs 7/19/2006 13:23'!
initialize
	super initialize.
	buttons := self buttonClass new initializeWithWindow: self extent: 5@2.
	self addChild: buttons.! !

!TMedia3DContainer methodsFor: 'actions' stamp: 'hrs 5/14/2006 13:03'!
nowCarried
	self buttons grabButton switch: true. ! !

!TMedia3DContainer methodsFor: 'editing' stamp: 'hrs 7/19/2006 13:11'!
openContents
	self openEditBox.! !

!TMedia3DContainer methodsFor: 'editing' stamp: 'hrs 5/16/2006 12:01'!
openEditBox
	| box |
	box := TEditBox new initializeWithContents: self contents.
	self runScript: #adjustEditBox: withArguments: {box} when: {box. #draggedContents}.
	self runScript: #adjustButtonsForRotation when: {box. #rotatedContents}.! !

!TMedia3DContainer methodsFor: 'actions' stamp: 'hrs 5/9/2006 13:52'!
pasteMaterial: aMaterialOrTexture
	self contents pasteMaterial: aMaterialOrTexture
	! !

!TMedia3DContainer methodsFor: 'events' stamp: 'jcg 4/24/2006 16:45'!
pointerEnter: event
	buttons enable.! !

!TMedia3DContainer methodsFor: 'events' stamp: 'jcg 4/24/2006 16:45'!
pointerLeave: event
	buttons disable.! !

!TMedia3DContainer methodsFor: 'accessing' stamp: 'hrs 5/9/2006 13:36'!
serializeMaterial
	^self contents serializeMaterial.! !

TMedia3DContainer subclass: #TMediaStreamingSpeaker
	instanceVariableNames: 'isOpen audioID codec oalSource silencedID'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-Audio'!

!TMediaStreamingSpeaker methodsFor: 'connecting' stamp: 'jcg 5/11/2006 01:05'!
attemptAudioConnection
	audioID ifNil: [^ self "Don't know who we want to connect to."].
	self streamingSpeakerRegistry add: self.
	LiveAudioSource attemptConnectionTo: audioID copy from: (self island register: self).

	oalSource play.! !

!TMediaStreamingSpeaker methodsFor: 'connecting' stamp: 'jcg 5/11/2006 01:05'!
attemptAudioDisconnection
	audioID ifNil: [^ self "Don't know who we want to connect to."].
	self streamingSpeakerRegistry remove: self ifAbsent: [].
	LiveAudioSource attemptDisconnectionFrom: audioID copy from: (self island register: self).

	oalSource stop! !

!TMediaStreamingSpeaker methodsFor: 'initialize' stamp: 'jcg 5/10/2006 15:05'!
audioID: auID
	audioID := auID! !

!TMediaStreamingSpeaker methodsFor: 'private' stamp: 'jcg 5/10/2006 16:02'!
codec
	"This must match the codec in LiveAudioSource.  Later, add a protocol for updating codecs on the fly."
	codec ifNil: [codec := ADPCMCodec newBitsPerSample: 4].
	^ codec! !

!TMediaStreamingSpeaker methodsFor: 'actions' stamp: 'jcg 5/10/2006 14:48'!
connect: event
	self attemptAudioConnection.! !

!TMediaStreamingSpeaker methodsFor: 'decode' stamp: 'jcg 7/26/2006 19:30'!
decode: encoded
	"We don't want to hear ourselves. This does not effect island state in any 
	meaningful way."
	self silencedID = LiveAudioSource current sourceID ifTrue: [^self].

	self flag: #jcg.  "I don't like the copy, but it avoids checkpoint failures.  Alternatives?"
	oalSource addBufferData: (self codec decodeCompressedDataNoReset: encoded) clone
			! !

!TMediaStreamingSpeaker methodsFor: 'actions' stamp: 'hrs 5/16/2006 10:56'!
destroy
	super destroy.
	self attemptAudioDisconnection ! !

!TMediaStreamingSpeaker methodsFor: 'actions' stamp: 'jcg 5/10/2006 14:48'!
disconnect: event
	self attemptAudioDisconnection.! !

!TMediaStreamingSpeaker methodsFor: 'private' stamp: 'jcg 5/11/2006 23:01'!
frameChanged
	super frameChanged.
	oalSource position: self globalPosition.
	oalSource direction: self lookAt.! !

!TMediaStreamingSpeaker methodsFor: 'initialize' stamp: 'jcg 7/26/2006 01:49'!
initialize
	super initialize.
	isOpen := true.
	buttons openButton 
					action: #disconnect:;
					action2: #connect:.
	oalSource := TStreamingSoundSource new.
	oalSource 
			gain: 1.0;
			coneOuterGain: 0.3;
			coneInnerAngle: 135.0;
			referenceDistance: 5.0;
			play.
! !

!TMediaStreamingSpeaker methodsFor: 'testing' stamp: 'jcg 5/12/2006 01:35'!
isOpen
	^ isOpen! !

!TMediaStreamingSpeaker methodsFor: 'private' stamp: 'jcg 5/12/2006 00:07'!
justPastedOnto: target byUser: userAvtrRep
	super justPastedOnto: target byUser: userAvtrRep.
	isOpen ifTrue: [self attemptAudioConnection].! !

!TMediaStreamingSpeaker methodsFor: 'accessing' stamp: 'jcg 5/11/2006 02:15'!
oalSource
	^ oalSource! !

!TMediaStreamingSpeaker methodsFor: 'accessing' stamp: 'hrs 5/15/2006 11:28'!
silencedID
	^silencedID ifNil: [self silencedID: audioID].! !

!TMediaStreamingSpeaker methodsFor: 'accessing' stamp: 'hrs 5/15/2006 11:24'!
silencedID: id
	silencedID := id.! !

!TMediaStreamingSpeaker methodsFor: 'private' stamp: 'jcg 5/10/2006 13:52'!
streamingSpeakerRegistry
	| registry |
	self flag: #jcg.  "Originally tried to access 'globals' via #at: instead of #lookup:"
	registry := self island
					lookup: #streamingSpeakers 
					ifAbsent: [self island register: IdentitySet new name: #streamingSpeakers].
	^ registry valueOn: self island
	! !

!TButton methodsFor: '*Wisconsin-hacks' stamp: 'jcg 5/10/2006 12:50'!
action2: act
	action2 := act.! !

!TButton methodsFor: '*Wisconsin-hacks' stamp: 'jcg 5/10/2006 12:50'!
action: act
	action := act.! !

!TButton methodsFor: '*Wisconsin-hacks' stamp: 'jcg 5/5/2006 15:15'!
justPastedOnto: pasteTarget byUser: userAvtrRep
	stepping := false.
	self disable.
	super justPastedOnto: pasteTarget byUser: userAvtrRep.! !

OpenALSourceName subclass: #OpenALStreamingSourceName
	instanceVariableNames: 'freeBuffers busyBuffers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-Audio'!

!OpenALStreamingSourceName methodsFor: 'actions' stamp: 'jcg 8/5/2006 12:27'!
addBufferData: aSoundBuffer samplingRate: rate
	| buf holder openAL |
	
"	true ifTrue: [Transcript show: 'free: ', freeBuffers size, '    busy: ', busyBuffers size; cr]."

	openAL := self openAL.
	openAL checkForError.

	"First free buffers that have already been processed."
	holder := WordArray new: 1.
	openAL alGetSourcei: alID with: ALBuffersProcessed with: holder.
	holder := WordArray new: (holder at: 1).
	openAL alSourceUnqueueBuffers: alID with: holder size with: holder.
	holder do: 
		[:id |
		buf := busyBuffers removeFirst.
		freeBuffers addLast: buf.

		self flag: #jcg. "Use 'buf nameIn:', not 'buf handle' since we are in the ocean."
		(buf nameIn: openAL) alID = id ifFalse: 
							[self error: '#addBufferData:   unexpected buffer was processed'].
		].

	busyBuffers size > 5 ifTrue: [^ self "behind, so drop sample"].

	"Now find a free buffer (creating one if necessary), and fill it with data"
	buf := freeBuffers isEmpty 
							ifFalse: [freeBuffers removeFirst] 
							ifTrue: [TSoundBuffer new].
	buf data: aSoundBuffer samplingRate: rate format: ALFormatMono16.

	"Now queue the buffer."
	holder := WordArray new: 1.
	self flag: #jcg. "Use 'buf nameIn:', not 'buf handle' since we are in the ocean."
	holder at: 1 put: (buf nameIn: openAL)  alID.
	openAL alSourceQueueBuffers: alID with: 1 with: holder.
	self isPlaying ifFalse: [openAL alSourcePlay: alID].
	busyBuffers addLast: buf.
! !

!OpenALStreamingSourceName methodsFor: 'initialize' stamp: 'jcg 5/10/2006 23:41'!
initialize
	super initialize.
	freeBuffers := OrderedCollection new.
	busyBuffers := OrderedCollection new.
! !

!OpenALStreamingSourceName methodsFor: 'accessing' stamp: 'jcg 6/15/2006 21:34'!
samplingRate: hertz
	samplingRate := hertz! !

!OpenALStreamingSourceName methodsFor: 'controls' stamp: 'jcg 7/12/2006 22:56'!
stop
	| holder |
	super stop.
	busyBuffers isEmpty ifFalse: 
		[holder := WordArray new: busyBuffers size.
		openAL alSourceUnqueueBuffers: alID with: holder size with: holder.
		freeBuffers addAll: busyBuffers.
		busyBuffers removeAll.]! !

TMessageRelay subclass: #TBaseMessageRouterClient
	instanceVariableNames: 'router'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-Cache'!

!TBaseMessageRouterClient commentStamp: 'jcg 8/3/2006 18:25' prior: 0!
This is a very simple base class for message router clients.  TMessageRouterClient should inherit from it, but I'm trying not to make waves.

Instance variables:
	router		<TMessageRouter>	The router!

!TBaseMessageRouterClient methodsFor: 'initialize' stamp: 'jcg 5/21/2006 16:51'!
destroy
	router ifNotNil:[router removeClient: self].
	super destroy.
! !

!TBaseMessageRouterClient methodsFor: 'initialize' stamp: 'jcg 5/21/2006 16:50'!
handleError: exception stack: longStack
	router logError: exception from: self stack: longStack.
	super handleError: exception stack: longStack.! !

!TBaseMessageRouterClient methodsFor: 'accessing' stamp: 'jcg 5/21/2006 16:51'!
router
	^router! !

!TBaseMessageRouterClient methodsFor: 'accessing' stamp: 'jcg 5/21/2006 16:51'!
router: aRouter
	router := aRouter! !

TBaseMessageRouterClient subclass: #WisconsinCacheRouterClient
	instanceVariableNames: 'requestFacet serveFacet'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-Cache'!

!WisconsinCacheRouterClient commentStamp: 'jcg 5/21/2006 16:58' prior: 0!
Instance variables:
	requestFacet		<TObjectID>		The request: facet for requesting a resource to be uploaded.
	serveFacet		<TObjectID>		The serve: facet for sending a resource to a client.
!

!WisconsinCacheRouterClient methodsFor: 'accessing' stamp: 'jcg 5/21/2006 16:59'!
requestFacet
	^ requestFacet! !

!WisconsinCacheRouterClient methodsFor: 'accessing' stamp: 'jcg 5/21/2006 16:59'!
requestFacet: aFacet
	requestFacet := aFacet! !

!WisconsinCacheRouterClient methodsFor: 'accessing' stamp: 'jcg 5/21/2006 16:59'!
serveFacet
	^ serveFacet! !

!WisconsinCacheRouterClient methodsFor: 'accessing' stamp: 'jcg 5/21/2006 16:59'!
serveFacet: aFacet
	serveFacet := aFacet! !

AlignmentMorphBob1 subclass: #XrfbBasePanelMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-Xrfb'!

!XrfbBasePanelMorph commentStamp: 'strick 2/11/2006 00:56' prior: 0!
XrfbBasePanelMorph is the base for the Control Panel and Server Configuration

!

!XrfbBasePanelMorph methodsFor: 'as yet unclassified' stamp: 'strick 2/11/2006 01:00'!
buttonColor

	^color darker! !

!XrfbBasePanelMorph methodsFor: 'as yet unclassified' stamp: 'strick 2/11/2006 00:57'!
buttonNamed: aString action: aSymbol color: aColor help: helpString

	| f col |
	f := SimpleButtonMorph new
		target: self;
		label: aString font: self myFont;
		color: aColor;
		actionSelector: aSymbol;
		setBalloonText: helpString.
	f width: 10 * aString size + 10.
	f cornerStyle: #square.
	f color: (Color r: 0.95 g: 0.95 b: 1.0).
	f borderStyle: (BorderStyle raised width: 2).
	col := (self inAColumn: {f}) hResizing: #spaceFill.
	^col! !

!XrfbBasePanelMorph methodsFor: 'as yet unclassified' stamp: 'strick 2/11/2006 01:39'!
closeButton

	^self
		buttonNamed: 'X' 
		action: #delete
		color: self buttonColor 
		help: 'Close the Control Panel'! !

!XrfbBasePanelMorph methodsFor: 'as yet unclassified' stamp: 'strick 2/11/2006 00:59'!
initialize
"
  self new openInWorld
"

	| fs |
	super initialize.
	self beSticky.
	fs := GradientFillStyle ramp: {0.0 -> (Color r: 0.8 g: 0.8 b: 1.0). 1.0 -> (Color white) }.
	self vResizing: #shrinkWrap.
	self hResizing: #shrinkWrap.
	color := Color paleYellow.
	borderWidth := 4.
	borderColor := #complexRaised.
	self layoutInset: (4@6).
	self rebuild: ' '.
	fs origin: bounds origin.
	fs direction: 0@self fullBounds height.
	self fillStyle: fs.! !

!XrfbBasePanelMorph methodsFor: 'as yet unclassified' stamp: 'strick 2/11/2006 01:02'!
maker

	^ XrfbServerMaker new! !

!XrfbBasePanelMorph methodsFor: 'as yet unclassified' stamp: 'strick 2/11/2006 01:02'!
myFont

	^(TextStyle named: #BitstreamVeraSans) fontOfSize: 16! !

XrfbBasePanelMorph subclass: #XrfbControlPanelMorph
	instanceVariableNames: 'listButton cleanButton shutdownButton textArea'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-Xrfb'!

!XrfbControlPanelMorph commentStamp: 'strick 2/10/2006 23:10' prior: 0!
XrfbControlPanel --

A Morph for controlling the Xrfb Desktop Server daemon.

(* Much of this code stolen from TLoginMorph.  Thanks y'all. *)!

!XrfbControlPanelMorph methodsFor: 'as yet unclassified' stamp: 'strick 2/11/2006 00:23'!
cleanButton

	^self
		buttonNamed: 'Clean up' 
		action: #doClean
		color: self buttonColor 
		help: 'Cleanup unused desktops on the Xrfb Desktop Server'! !

!XrfbControlPanelMorph methodsFor: 'as yet unclassified' stamp: 'strick 2/11/2006 01:40'!
configureButton

	^self
		buttonNamed: 'Configure...' 
		action: #doConfigure
		color: self buttonColor 
		help: 'Configure the hostname, port number, and shared password for the server'! !

!XrfbControlPanelMorph methodsFor: 'as yet unclassified' stamp: 'strick 2/11/2006 19:28'!
doClean

	self doSomething: 'clean'
! !

!XrfbControlPanelMorph methodsFor: 'as yet unclassified' stamp: 'strick 2/20/2006 02:05'!
doConfigure

	XrfbServerConfigMorph new openInWorld comeToFront.

	" #rebuild: considers '...' to be a special case, also changing the top right blurb "
	self rebuild: '...'
! !

!XrfbControlPanelMorph methodsFor: 'as yet unclassified' stamp: 'strick 2/11/2006 19:27'!
doList

	self doSomething: 'list'
! !

!XrfbControlPanelMorph methodsFor: 'as yet unclassified' stamp: 'strick 2/11/2006 19:28'!
doShutdown

	self doSomething: 'shutdown'
! !

!XrfbControlPanelMorph methodsFor: 'as yet unclassified' stamp: 'strick 2/11/2006 19:32'!
doSomething: what

	"set a message while we are working"
	self rebuild: '... sending request: ', what, ' ...' .
	self refreshWorld.

	"do the work"
	self rebuild: (self maker doSomething: what)
! !

!XrfbControlPanelMorph methodsFor: 'as yet unclassified' stamp: 'strick 2/10/2006 22:55'!
listButton

	^self
		buttonNamed: 'List Desktops' 
		action: #doList 
		color: self buttonColor 
		help: 'List all desktops and connections on the Xrfb Desktop Server'! !

!XrfbControlPanelMorph methodsFor: 'as yet unclassified' stamp: 'strick 2/20/2006 02:08'!
rebuild: someText

	| label |

	someText = '...' ifTrue: [

		"Obliterate the label after 'Configure' is pressed, so the Control Panel won't be showing a stale IP address.  This is easier than sending a rebuild to all of the Control Panels after the Configure is saved. "

		label := ' '.
	] ifFalse: [
		label := '  Desktops on ', XrfbServerMaker new httpServerHostAddress asString.
	].

	self removeAllMorphs.

	self addARow: { 
		self closeButton.
		(StringMorph contents: label ) lock 
	}.

	self addARow: { 
		self listButton.
		self cleanButton.
		self configureButton.
		self shutdownButton.
	}.

	self addARow: { 
		(textArea := TextMorph new

			beAllFont: self myFont;
			crAction: (MessageSend receiver: self selector: #doOK);
			extent: 600@40;
			contentsWrapped: someText asText;
			setBalloonText: 'Results are displayed here.'
		)
	}.

! !

!XrfbControlPanelMorph methodsFor: 'as yet unclassified' stamp: 'strick 2/20/2006 02:09'!
shutdownButton

	^self
		buttonNamed: 'Kill All Desktops!!' 
		action: #doShutdown
		color: self buttonColor 
		help: 'Forcibly shutdown all desktops on the Xrfb Desktop Server, dropping any connections from clients'! !

XrfbBasePanelMorph subclass: #XrfbServerConfigMorph
	instanceVariableNames: 'hostBox portBox passwordBox'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wisconsin-Xrfb'!

!XrfbServerConfigMorph methodsFor: 'as yet unclassified' stamp: 'strick 2/11/2006 01:14'!
cancelButton

	^self
		buttonNamed: 'Cancel' 
		action: #delete
		color: self buttonColor 
		help: 'Don''t make changes'! !

!XrfbServerConfigMorph methodsFor: 'as yet unclassified' stamp: 'strick 2/11/2006 01:48'!
doOK

	| p |


	self maker httpServerHostAddress: hostBox contents asString.

	p := portBox contents asString asInteger.
	p ifNotNil: [ self maker httpServerPortNumber: p].

	self maker httpServerPassword: passwordBox contents asString.

	self delete.

! !

!XrfbServerConfigMorph methodsFor: 'as yet unclassified' stamp: 'strick 2/11/2006 01:13'!
okButton

	^self
		buttonNamed: 'OK' 
		action: #doOK
		color: self buttonColor 
		help: 'Accept Changes'! !

!XrfbServerConfigMorph methodsFor: 'as yet unclassified' stamp: 'strick 2/11/2006 01:36'!
rebuild: ignoredText

	| label |

	label := '  Configure the Xrfb Desktop Server'.

	self removeAllMorphs.

	self addARow: {
		(StringMorph contents: label ) lock 
	}.

	self addARow: {
		(StringMorph contents: 'Server Hostname or IP Address:' font: self myFont) lock.
	}.
	(self addARow: {
		(hostBox := TextMorph new
			beAllFont: self myFont;
			crAction: (MessageSend receiver: self selector: #doOK);
			extent: 236@20;
			contentsWrapped: self maker httpServerHostAddress;
			setBalloonText: 'Enter the hostname or IP address of the Xrfb Desktop Server'
			).
	}) color: Color white; borderColor: Color black; borderWidth: 1.

	self addARow: {
		(StringMorph contents: 'TCP Port Number: (default is 5899)' font: self myFont) lock.
	}.
	(self addARow: {
		(portBox := TextMorph new
			beAllFont: self myFont;
			crAction: (MessageSend receiver: self selector: #doOK);
			extent: 236@20;
			contentsWrapped: self maker httpServerPortNumber asString;
			setBalloonText: 'Enter the TCP port of the Xrfb Desktop Server (usually 5899)'
			).
	}) color: Color white; borderColor: Color black; borderWidth: 1.

	self addARow: {
		(StringMorph contents: 'Password:' font: self myFont) lock.
	}.
	(self addARow: {
		(passwordBox := TextMorph new
			beAllFont: (StrikeFont passwordFontSize: 16);
			crAction: (MessageSend receiver: self selector: #doOK);
			extent: 236@20;
			contentsWrapped: self maker httpServerPassword;
			setBalloonText: 'Enter the shared password for the server'
			).
	}) color: Color white; borderColor: Color black; borderWidth: 1.


	self addARow: {
		self okButton.
		self cancelButton.
	}.
! !

TAvatarUserVehicle subclass: #TAvatarUserWisconsin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'OpenALConstants'
	category: 'Wisconsin-UI'!

!TAvatarUserWisconsin methodsFor: 'accessing' stamp: 'hrs 4/24/2006 08:55'!
actOnThirdPerson
	"We can get away with locally setting this IFF we know that we can't
	provide a synch."
	replica ifNil: [^self].
	replica island send: [: i |
		(i controller facets includesKey: #beServer) ifTrue: [^self].
		].
	replica send: [:rep | 
		rep transparency: 
			(thirdPerson < 2 
				ifTrue: [thirdPerson * 0.4]
				ifFalse: [1.0])
			].
! !

!TAvatarUserWisconsin methodsFor: 'portals' stamp: 'hrs 5/20/2006 14:00'!
addToNewSpace: aSpace
	| newCarrying data |
	data := replica get: #copyCarrying.
	newCarrying := data ifNotNil: [TIslandCopier new import: data to: aSpace island].
	super addToNewSpace: aSpace.
	replica future restoreCarrying: newCarrying.! !

!TAvatarUserWisconsin methodsFor: 'driving' stamp: 'hrs 5/17/2006 13:27'!
back
	self replica future translation: self safeTranslation + self lookAt.! !

!TAvatarUserWisconsin methodsFor: 'events' stamp: 'hrs 7/25/2006 13:11'!
doBlueButtonUp: event
  WorldState addDeferredUIMessage: [self showContextMenu: event for: event selection target]! !

!TAvatarUserWisconsin methodsFor: 'driving' stamp: 'hrs 5/17/2006 13:27'!
down
	self replica future translation: self safeTranslation - self lookUp.! !

!TAvatarUserWisconsin methodsFor: 'driving' stamp: 'hrs 5/17/2006 13:27'!
forward
	self replica future translation: self safeTranslation - self lookAt.! !

!TAvatarUserWisconsin methodsFor: 'private' stamp: 'jcg 5/11/2006 23:32'!
frameChanged
	| orientation |
	super frameChanged.
	orientation := Vector3Array new: 2.
	orientation at: 1 put: self globalTransform lookAt.
	orientation at: 2 put: self globalTransform lookUp.
	harness openAL 
				alListenerfv: ALPosition with: self globalPosition;
				alListenerfv: ALOrientation with: orientation.! !

!TAvatarUserWisconsin methodsFor: 'popup menu' stamp: 'hrs 7/25/2006 15:59'!
grab: obj
	"grab the object or its parent if the parent is a TSpinner"
	| par movObj cls |

	movObj := obj.  	
	par := obj get: #parent.
	cls := par get: #class.
	(cls inheritsFrom: TSpinner) ifTrue: [movObj := par.].
	
	movObj future grabbedState: true.
	movObj future grabbedBy: replica.! !

!TAvatarUserWisconsin methodsFor: 'events' stamp: 'hrs 4/24/2006 08:57'!
keyStroke: evt
	| char code | 
	char := evt keyCharacter.
	code := evt keyValue.
	char = $q ifTrue: [^self rotateLeft].
	char = $w ifTrue: [^self forward].
	char = $e ifTrue: [^self rotateRight].
	char = $a ifTrue: [^self left].
	char = $s ifTrue: [^self back].
	char = $d ifTrue: [^self right].
	code = 28 ifTrue: [^self rotateLeft].
	code = 29 ifTrue: [^self rotateRight].
	code = 30 ifTrue: [^self up].
	code = 31 ifTrue: [^self down].
	^super keyStroke: evt
! !

!TAvatarUserWisconsin methodsFor: 'driving' stamp: 'hrs 5/17/2006 13:28'!
left
	self replica future translation: self safeTranslation - (self lookSide/2).! !

!TAvatarUserWisconsin methodsFor: 'popup menu' stamp: 'hrs 7/25/2006 16:00'!
release: obj
	"release the object (or it's parent if the parent is a TSpinner)"
	|   par movObj cls  |

	movObj := obj.
	par := obj get: #parent.
	cls := par get: #class.

	(cls inheritsFrom: TSpinner) ifTrue: [movObj := par.].

	" Release it to the space. "
	movObj future grabbedState: false.
	movObj future releasedBy: replica.
! !

!TAvatarUserWisconsin methodsFor: 'driving' stamp: 'hrs 5/17/2006 13:28'!
right
	self replica future translation: self safeTranslation + (self lookSide/2).! !

!TAvatarUserWisconsin methodsFor: 'driving' stamp: 'hrs 4/24/2006 08:56'!
rotateLeft
	self replica future addRotationAroundY: 3! !

!TAvatarUserWisconsin methodsFor: 'driving' stamp: 'hrs 4/24/2006 08:56'!
rotateRight
	self replica future addRotationAroundY: -3! !

!TAvatarUserWisconsin methodsFor: 'driving' stamp: 'hrs 5/17/2006 13:27'!
safeTranslation
	self replica wait.
	^self translation.! !

!TAvatarUserWisconsin methodsFor: 'popup menu' stamp: 'hrs 7/25/2006 16:19'!
showContextMenu: evt for: target 
	| script  | 
	script := self startScript: 
			((target get: #class) getPopupMenuScript: self 
				target: target 
				openIn: (self island project world) 
				at: (self island project primaryHand position) 
				carrying: (((target get: #parent) get: #class) includesBehavior: TAvatarCarry) 
				harness: harness).
	script setScheduler: self island project world ownerMorph scriptScheduler.
	script resume.

! !

!TAvatarUserWisconsin methodsFor: 'portals' stamp: 'hrs 7/6/2006 09:45'!
testEnter:ogl portal:pf
	| result |
	result := super testEnter:ogl portal:pf.

	"This avatar is polite: it closes doors behind it after passing through.
	If we don't do this, then soon all the portals are open and everyone has
	to get all the islands."
	
	"I'm not crazy about this. This happens during rendering, and 
	rendering isn't supposed to change the state of things. We're getting away with it here
	because we are the only one with an ogl avatar that is making this test, and if it 
	succeeds, we replicate the closeContents message. But still, as DAS says
	in the related CroquetHarness>>renderWorld, 'this is screwed up'.  -HRS"

	result ifTrue: [(ogl harness activeIsland asFarRef: pf parent) future closeContents].

	^result.! !

!TAvatarUserWisconsin methodsFor: 'accessing' stamp: 'hrs 4/24/2006 08:56'!
thirdPerson: aNumber
	super thirdPerson: aNumber.
	self actOnThirdPerson.
! !

!TAvatarUserWisconsin methodsFor: 'accessing' stamp: 'hrs 4/24/2006 08:56'!
toggleAvatarPerson
	super toggleAvatarPerson.
	self actOnThirdPerson.! !

!TAvatarUserWisconsin methodsFor: 'driving' stamp: 'hrs 5/17/2006 13:28'!
up
	self replica future translation: self safeTranslation + self lookUp.! !
DShowVideoController initialize!
ExternalMediaHandleManager initialize!
LiveAudioSource initialize!
LiveMediaSource initialize!
LiveVideoSource initialize!
TOceanProxy initialize!
TransientHandleManager initialize!
VideoGrabber initialize!
